#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <math.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"


ChildList* CombineChildren(wid,tree)
     GraphWidget  wid;
     XGP_node     *tree;

     {ChildList    *temp = NULL;
      stblentry *t, *lookup();

       if (tree == NULL){
	   return(NULL);
       } else {
	   if (Existing_Name (tree->sval)) {
	     temp = (ChildList*) XGPmalloc(wid,sizeof(ChildList));

/* find the data field for the given name and set a pointer to it */

	     t  = lookup(tree->sval);
	     temp->self = t->datafield;

/* set the data fields of the children to null (cant access them any longer) */
      
	     t->datafield = NULL;

/* set the pointers to the children   */

	     temp->siblings = CombineChildren(wid,tree->sibling);
	     return(temp);
	   } else{
	     error(wid,104,tree->sval);
	     return(CombineChildren(wid,tree->sibling));
	   }
      }
   }


void give_parents(parent,child_list)
    XGPObject    *parent;
    ChildList    *child_list;

    {
      if (child_list != NULL) {
	  child_list->self->parent = parent;
	  give_parents(parent,child_list->siblings);
      }
    }

XGPObject* CombineObject(wid,name,tree)
    GraphWidget  wid;
    char        *name;
    XGP_node    *tree;

    {
      XGPObject   *temp = NULL;
      ChildList   *data;

      data = CombineChildren(wid,tree);
      if (data == NULL) {
	error(wid,103,(char*)NULL);
	return(NULL);
      }else {
	temp = (XGPObject*) XGPmalloc(wid,sizeof(XGPObject));
	temp->data.c_data.children = data;
	give_parents(temp,data);
	AssignDefaultAttribs(wid,temp);
	temp->type = XGPComplex;
	return (temp);
      }
    }
