#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"
extern void error();

extern void XGPDrawLine();
extern void XGPDrawPoint();

void displayPolygon();
void displaysurface();
void displayLine();
void displayPoint();

void Maketempmatrix(a,b)
	float    a[4][4],b[4][4];

	{
	     matrixident(b);
	     matrixmultiply(a,b,4);
	}

int checkvisibility(object)
	XGPObject   *object;

	{
	   if (object == NULL) {
	       return(XtVisible);
	   } else {
	       if (object->Other.Hidden == XtInvisible) {
		  return(XtInvisible);
	       } else {
		  return(checkvisibility(object->parent));
	       }
	   }
	}

int  ChangeStyle(wid,object)
	GraphWidget wid;
	XGPObject   *object;

	{
	     if (NULL == object) {
		 return(0);
	     } else  if((object->Other.linestyle != TSOLID) ||
			(object->Other.linewidth != 0)){
		  Change_Line_Style(wid,object->Other.linewidth,
		      object->Other.linestyle);
		  return(1);
	     } else {
		  return(ChangeStyle(wid,object->parent));
	     } 
	} /* routine */

int  ChangeColor(wid,object)
	GraphWidget wid;
	XGPObject   *object;

	{
	     if (NULL == object) {
		 return(0);
	     } if(object->Other.fgcolor != NULL) { 
		 XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		     MakeColor(wid,object->Other.fgcolor));
		 return(1);
	     } else {
     		return(ChangeColor(wid,object->parent));
             }
	}

void DisplayPrimitive(wid,object,inmatrix)
        GraphWidget      wid;	
	XGPObject   *object;
	float       inmatrix[4][4];

	{
	   XtXGPPointStruct  z,w,s;
	   float             t,r,a1,a2,b1,b2,c1,c2;
	   Numlist           *points;
	   int               flag;   /* true if gc is changed for lines */
           float	     matrix[4][4];

            
	   if (object != NULL) {
	    if (checkvisibility(object) != XtInvisible) {
	     flag = ChangeColor(wid,object);
	     flag = ChangeStyle(wid,object) || flag;
	     matrixident(matrix);
	     if (inmatrix != NULL) {
                 matrixmultiply(inmatrix,matrix,4);
	     }
	     matrixmultiply(object->Other.transformation,matrix);
	     switch (object->data.p_data.type ) {
		 case Line :
		   displayLine(wid,object,matrix);
                   break;
		 case Point :
		   displayPoint(wid,object,matrix); 
		   break;
		 case Elipse :
		 /* this is a problem It needs to be changed for 3D */
		   z.x = object->data.p_data.data.c_data.center.x;
		   z.y = object->data.p_data.data.c_data.center.y;
		   t = object->data.p_data.data.c_data.radius1;
		   r = object->data.p_data.data.c_data.radius2;
		   z.x = z.x - t;
		   z.y = z.y + r;
		   Apply2DMatrix(wid,z.x,z.y,matrix,&z.x,&z.y);
		   XGPDrawElipse(wid,z,t,r);
		   break;
		 case Polygon :
                   displayPolygon(wid, object, matrix);
		   break;
		 case Surface :
		   displaysurface(wid,object,matrix);
		   break;
		 case Polyline :
		   if ((wid->graph.mode ==T2D) ||
		       (wid->graph.mode==T2DONLY)|| (wid->graph.mode == Def)) {
		       points = object->data.p_data.data.pl_data.points;
		       w.x = points->x;
		       w.y = points->y;
		       Apply2DMatrix(wid,w.x,w.y,matrix,&w.x,&w.y);
		       points = points->next;
                       while (points != NULL) {
                         z.x = points->x;
                         z.y = points->y;
		         Apply2DMatrix(wid,z.x,z.y,matrix,&z.x,&z.y);
                         points = points ->next;
                         XGPDrawLine(wid,w,z);
                         w = z;
		       }
		   } else if (wid->graph.mode == T3D) {
		       points = object->data.p_data.data.pl_data.points;
		       w.x = points->x;
		       w.y = points->y;
		       w.z = points->z;
		       Apply3DMatrix(wid,w.x,w.y,w.z,matrix,&w.x,&w.y,&w.z);
		       points = points->next;
                       while (points != NULL) {
                         z.x = points->x;
                         z.y = points->y;
			 z.z = points->z;
		         Apply3DMatrix(wid,z.x,z.y,z.z,matrix,&z.x,&z.y,&z.z);
                         points = points ->next;
			 if (wid->graph.Hidden == TON) {
			     AddPolygon(wid,w,w,z,z);
			 } else {
			     XGPDrawLine3D(wid,w.x,w.y,w.z,z.x,z.y,z.z,TRUE);
			 }
                         w = z;
		       }
                   }
                   break;
		 case Text :
		   if (object->Other.dimension == T2D ) {
		       w.x = object->data.p_data.data.t_data.point.x;
		       w.y = object->data.p_data.data.t_data.point.y;
		       Apply2DMatrix(wid,w.x,w.y,matrix,&w.x,&w.y);
		       XGPDrawString(wid,w.x,w.y,
				     object->data.p_data.data.t_data.text,
				     object->Other.fontstyle);
		   } else {
		       w.x = object->data.p_data.data.t_data.point.x;
		       w.y = object->data.p_data.data.t_data.point.y;
		       w.z = object->data.p_data.data.t_data.point.z;
		       Apply3DMatrix(wid,w.x,w.y,w.z,matrix,&w.x,&w.y,&w.z);
		       XGPDrawString3D(wid,w.x,w.y,w.z,
				     object->data.p_data.data.t_data.text,
				     object->Other.fontstyle);
		   } 
		   break;
		 default :
		   break;
	      }
	      if (flag == TRUE) {
		 Change_Line_Style (wid,0,TSOLID);
		 XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		     wid->graph.foreground);
	      }
	    } /* this is the end of the visibility test  */
	    } /* this is the end of the null object test */
	 }

void DisplayComplex(wid,object,inmatrix)
	GraphWidget   wid;
	XGPObject     *object;
	float         inmatrix[4][4];

	{  ChildList    *temp;
           XGPObject    *node;
           float        tmatrix[4][4];

	temp = object->data.c_data.children;
	if (inmatrix != NULL) {
	    Maketempmatrix(inmatrix,tmatrix);
	    matrixmultiply(object->Other.transformation,tmatrix,4);
	} else {
	    Maketempmatrix(object->Other.transformation,tmatrix,4);
	}
	while (temp != NULL) {
             node = temp->self;
	     switch (node->type) {
		 case XGPPrimitive :
		     DisplayPrimitive(wid,node,tmatrix);
		     break;
		 case XGPComplex :
		     DisplayComplex(wid,node,tmatrix);
		     break;
		 default : break;
	      }
	      temp = temp->siblings;
	}
	}


void displayPolygon(wid,object,matrix)
	GraphWidget   wid;
	XGPObject     *object;
	int           matrix[4][4];
	{
	   float              x,y,z,a,b,c,ha,hb,hc;
	   XtXGPPointStruct   s,w,z1;
	   Numlist            *points;
	   
	   if ((object->Other.dimension == T2D) && ((wid->graph.mode == T2D) ||
	      (wid->graph.mode == T2DONLY) || (wid->graph.mode == defaultdim))) {
	       points = object->data.p_data.data.y_data.points;
    	       s.x = points->x;
	       s.y = points->y;
	       Apply2DMatrix(wid,s.x,s.y,matrix,&s.x,&s.y);
	       w = s;
	       points = points->next;
	       while (points != NULL) {
                 z1.x = points->x;
	         z1.y = points->y;
	         Apply2DMatrix(wid,z1.x,z1.y,matrix,&z1.x,&z1.y);
	         points = points ->next;
	         XGPDrawLine(wid,w,z1);
	         w = z1;
	       }
	       XGPDrawLine (wid,z1,s);
	   } else if ((object->Other.dimension==T3D)&&(wid->graph.mode==T2D)) {
	       points = object->data.p_data.data.y_data.points;
    	       s.x = points->x;
	       s.y = points->y;
	       s.z = points->z;
	       Apply3DMatrix(wid,s.x,s.y,s.z,matrix,&s.x,&s.y,&s.z);
	       w = s;
	       points = points->next;
	       while (points != NULL) {
                 z1.x = points->x;
	         z1.y = points->y;
		 z1.z = points->z;
	         Apply3DMatrix(wid,z1.x,z1.y,z1.z,matrix,&z1.x,&z1.y,&z1.z);
	         points = points ->next;
	         XGPDrawLine(wid,w,z1);
	         w = z1;
	       }
	       XGPDrawLine (wid,z1,s);
           } else if ((object->Other.dimension==T2D)&&(wid->graph.mode==T3D)){
	       points = object->data.p_data.data.y_data.points;
	       a = points->x;
	       b = points->y;
               c = 0;
	       Apply2DMatrix(wid,a,b,matrix,&a,&b);
	       ha = a; hb = b; hc = c; 
	       points = points->next;
	       while (points != NULL) {
                 x = points->x;
	         y = points->y;
                 z = 0;
	         points = points ->next;
	         Apply2DMatrix(wid,x,y,matrix,&x,&y);
	         XGPDrawLine3D(wid,x,y,z,ha,hb,hc,TRUE); 
	         ha = x; hb = y; hc = z; 
	       }
	       XGPDrawLine3D(wid,a,b,c,x,y,z,TRUE);
           } else if ((object->Other.dimension == T3D) && 
	       ((wid->graph.mode == T3D) ||(wid->graph.mode == T3DONLY))) {
	       points = object->data.p_data.data.y_data.points;
	       a = points->x;
	       b = points->y;
               c = points->z;
	       Apply3DMatrix(wid,a,b,c,matrix,&a,&b,&c);
	       ha = a; hb = b; hc = c; 
	       points = points->next;
	       while (points != NULL) {
                 x = points->x;
	         y = points->y;
                 z = points->z;
	         points = points ->next;
	         Apply3DMatrix(wid,x,y,z,matrix,&x,&y,&z);
	         XGPDrawLine3D(wid,x,y,z,ha,hb,hc,TRUE); 
	         ha = x; hb = y; hc = z; 
	       }
	       XGPDrawLine3D(wid,a,b,c,x,y,z,TRUE);
            }
	 }

void hiddenDraw(wid,object,matrix)
	GraphWidget   wid;
	XGPObject     *object;
	int           matrix[4][4];
        {
	      XtXGPPointStruct        w,u,v,x;
	      SquareSurfaceStruct     *point,*nr,*hold;

	point = object->data.p_data.data.s_data.data;
	nr = point->sp;
	hold = nr;
	while(nr != NULL) {
	   while ((point->fp != NULL) && (nr->fp != NULL)) {
	       w.x = point->x; w.y = point->y; w.z = point->z; 
	       x.x = point->fp->x; x.y = point->fp->y; x.z = point->fp->z; 
	       u.x = nr->x; u.y = nr->y; u.z = nr->z; 
	       v.x = nr->fp->x; v.y = nr->fp->y; v.z = nr->fp->z; 
               Apply3DMatrix(wid,w.x,w.y,w.z,matrix,&w.x,&w.y,&w.z);
               Apply3DMatrix(wid,x.x,x.y,x.z,matrix,&x.x,&x.y,&x.z);
               Apply3DMatrix(wid,u.x,u.y,u.z,matrix,&u.x,&u.y,&u.z);
               Apply3DMatrix(wid,v.x,v.y,v.z,matrix,&v.x,&v.y,&v.z);
	       AddPolygon(wid,object,w,x,v,u); 
	       point = point->fp;
	       nr = nr->fp;
	   } /* while point != NULL */
	   point = hold;
	   nr = point->sp;
	   hold = nr;
	}
     }

void displaysurface(wid,object,matrix)
	GraphWidget   wid;
	XGPObject     *object;
	int           matrix[4][4];

	{
	SquareSurfaceStruct     *point,*nr;
        float                   x,y,z,a,b,c;
	XtXGPPointStruct        w,u;

      if (wid->graph.mode != T2DONLY) {
        if (wid->graph.Hidden == TON) { hiddenDraw(wid,object,matrix);} else{
	point = object->data.p_data.data.s_data.data;
	nr = point->sp;
	    while (point != NULL) { 
	       x = point->x;
	       y = point->y;
	       z = point->z;
               Apply3DMatrix(wid,x,y,z,matrix,&x,&y,&z);
	       if (point->sp != NULL) {
		   a = point->sp->x;
		   b = point->sp->y;
		   c = point->sp->z;
		   Apply3DMatrix(wid,a,b,c,matrix,&a,&b,&c);
                  if((wid->graph.mode == T3D) || (wid->graph.mode == T3DONLY)){
		     XGPDrawLine3D(wid,x,y,z,a,b,c,TRUE);
		  } else {
		     w.x = x;
		     w.y = y;
		     u.x = a;
		     u.y = b;
	             XGPDrawLine(wid,w,u);
		  }
	       }
	       if (point->fp != NULL) {
		   a = point->fp->x;
                   b = point->fp->y;
		   c = point->fp->z;
		   Apply3DMatrix(wid,a,b,c,matrix,&a,&b,&c);
                  if((wid->graph.mode == T3D) || (wid->graph.mode == T3DONLY)){
		   XGPDrawLine3D(wid,x,y,z,a,b,c,TRUE);
		  } else {
		     w.x = x;
		     w.y = y;
		     u.x = a;
		     u.y = b;
	             XGPDrawLine(wid,w,u);
		  }
		   point = point->fp;
	       } else {
		   point = nr;
		   if (point != NULL) {
		     nr = point->sp;
		   } else {
		     nr = NULL;
		   }
	       }
	      }
	    }
	}
     }

void displayLine(wid,object,matrix)
	GraphWidget   wid;
	XGPObject     *object;
        float           matrix[4][4];

	{
        float   x1,x2,y1,y2,z1,z2;

	if (object->Other.dimension == T2D) {
	    x1 = object->data.p_data.data.l_data.start_point.x;
	    y1 = object->data.p_data.data.l_data.start_point.y;
	    z1 = 0;
	    x2 = object->data.p_data.data.l_data.end_point.x;
	    y2 = object->data.p_data.data.l_data.end_point.y;
	    z2 = 0;
	    z2 = 0;
	    Apply2DMatrix(wid,x1,y1,matrix,&x1,&y1);
	    Apply2DMatrix(wid,x2,y2,matrix,&x2,&y2);
	    if (wid->graph.mode == T2DONLY) {
		drawline(wid,x1,y1,x2,y2);
	    }
	} else {
	    x1 = object->data.p_data.data.l_data.start_point.x;
	    y1 = object->data.p_data.data.l_data.start_point.y;
	    z1 = object->data.p_data.data.l_data.start_point.z;
	    x2 = object->data.p_data.data.l_data.end_point.x;
	    y2 = object->data.p_data.data.l_data.end_point.y;
	    z2 = object->data.p_data.data.l_data.end_point.z;
	    Apply3DMatrix(wid,x1,y1,z1,matrix,&x1,&y1,&z1);
            Apply3DMatrix(wid,x2,y2,z2,matrix,&x2,&y2,&z2);
	    if (wid->graph.mode == T3DONLY) {
		XGPDrawLine3D(wid,x1,y1,z1,x2,y2,z2,TRUE);
	    }
        }
	if ((wid->graph.mode == T3D)) {
	    XGPDrawLine3D(wid,x1,y1,z1,x2,y2,z2,TRUE);
	} else if ((wid->graph.mode == T2D) || (wid->graph.mode == Def)) {
	    drawline(wid,x1,y1,x2,y2);
	}
}

void displayPoint(wid,object,matrix)
	GraphWidget  wid;
	XGPObject    *object;
	float          matrix[4][4];

	{
	    float  x,y,z;

		   if (object->Other.dimension == T2D) {
		       x = object->data.p_data.data.p_data.point.x;
		       y = object->data.p_data.data.p_data.point.y;
		       z = 0;
		       Apply2DMatrix(wid,x,y,matrix,&x,&y);
		       if (wid->graph.mode == T2DONLY) {
		           drawpoint(wid,x,y);
		       }
		   } else {
		       x = object->data.p_data.data.p_data.point.x;
		       y = object->data.p_data.data.p_data.point.y;
		       z = object->data.p_data.data.p_data.point.z;
		       Apply3DMatrix(wid,x,y,z,matrix,&x,&y,&z);
	               if (wid->graph.mode == T3DONLY) {
		           XGPDraw3DPoint(wid,x,y,z);
		       } 
		   }
	if ((wid->graph.mode == T3D)) {
	    XGPDraw3DPoint(wid,x,y,z);
	} else if ((wid->graph.mode == T2D) || (wid->graph.mode == Def)) {
	    drawpoint(wid,x,y);
	}
}
