#include <X11/copyright.h>
#include <math.h>
extern parse();
extern error();
/* $XConsortium: Graph.c,v 1.2 88/10/25 17:40:25 swick Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */


/* this is a modification of the template widget provided by the    */
/* XConsortium.                                                     */
/* Programmer Dan Bennett                                           */

#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <stdio.h>
#include "Graph.h"
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

void extern GraphError();

static char defaultTranslations[]=
     "<EnterWindow>:       cmap()       \n\
      <LeaveWindow>:       uncmap()       ";

static XtResource resources[] = {
#define offset(field) XtOffset(GraphWidget, graph.field)
    /* {name, class, type, size, offset, default_type, default_addr}, */
       {XtNnormalFont,  XtCNormalFont, XtRFontStruct, sizeof(XFontStruct *),
	       offset(normalfont),XtRString,
	       "-*-*-*-*-*-*-*-*-*-*-*-*-*-*"},
       {XtNitalicFont,  XtCItalicFont, XtRFontStruct, sizeof(XFontStruct *),
	       offset(italicfont),XtRString, 
	       "-*-*-medium-i-*-*-*-*-*-*-*-*-*-*"},
       {XtNboldFont,  XtCBoldFont, XtRFontStruct, sizeof(XFontStruct *),
	       offset(boldfont),XtRString, 
	       "-*-*-bold-*-*-*-*-*-*-*-*-*-*-*"},
       {XtNgreekFont,  XtCGreekFont, XtRFontStruct, sizeof(XFontStruct *),
	       offset(greekfont),XtRString, 
	       "-*-*-*-*-*-*-*-*-*-*-*-*-*-*"},
       {XtNforeground,XtCForeground,XtRPixel, sizeof(Pixel),
               offset(foreground), XtRString, "XtDefaultForeground"},
       {XtNbackground,XtCBackground,XtRPixel, sizeof(Pixel),
	       offset(background), XtRString, "XtDefaultBackground"},
       {XtNbuisy, XtCBuisy, XtRCallback, sizeof(XtPointer),
  	       offset(buisy), XtRCallback, (XtPointer)NULL},
       {XtNresponse, XtCResponse, XtRCallback, sizeof(XtPointer),
  	       offset(response), XtRCallback, (XtPointer)NULL},
       {XtNerror, XtCError, XtRCallback, sizeof(XtPointer),
  	       offset(error), XtRCallback, (XtPointer)GraphError},

#undef offset
};

/*******************************************************/
/* this solution (Adding a translation to map and unamp*/
/* is incorrect according to the X11R4 standards but   */
/* I can't get the reccomended method to work.         */
/*******************************************************/

static void CMAP(),UNCMAP();

static XtActionsRec actionsList[]=
{
    {"cmap",          CMAP},
    {"uncmap",        UNCMAP},
};

static void CMAP(wid,event,params,num_params)
GraphWidget wid;
XEvent *event;
String *params;
Cardinal *num_params;
{
    if (wid->graph.ColormapMode != TPUBLIC ) {
       XInstallColormap(XtDisplay(wid),wid->core.colormap);
    }

}

static void UNCMAP(wid,event,params,num_params)
GraphWidget wid;
XEvent *event;
String *params;
Cardinal *num_params;
{
    if (wid->graph.ColormapMode != TPUBLIC ) {
         XUninstallColormap(XtDisplay(wid),wid->core.colormap);
    }
}

/******************************************************************/
/* this procedure will translate the world coordinates to device  */
/* The inputs are the widget we are working on,   wid             */
/* The world coordinates of the point    xW and yW                */
/* The device coordinates calculatd      xD and yD                */
/******************************************************************/

void world_to_device(wid,xW,yW,xD,yD)
     GraphWidget wid;
     float       xW,yW;
     Position    *xD,*yD;

     {
	 float x,y;
	 /* this is a check to avoid floating exceptions */

             x =  ((xW-wid->graph.graphXMin)
	     /(wid->graph.graphXMax-wid->graph.graphXMin)*(wid->core.width));
	     if (x < 0 ) {
		*xD = 0;
	     } else {
	        *xD = (Position)x;
	     }

	     y = ( wid->core.height - 
	       (yW-wid->graph.graphYMin)/
	       (wid->graph.graphYMax-wid->graph.graphYMin)*(wid->core.height));
	     if (y < 0 ) {
		*yD = 0;
	     } else {
	        *yD = (Position)y;
	     }
     }

float XGPPixelsPerUnitX(wid)
     GraphWidget   wid;
     {
	float foo;

	foo = wid->core.width / (wid->graph.graphXMax-wid->graph.graphXMin);
	return (foo);
     }

float XGPPixelsPerUnitY(wid)
	GraphWidget   wid;
	{
		return(wid->core.height/
		(wid->graph.graphYMax-wid->graph.graphYMin));
	}
		 
Position device_length(wid,wv)
     GraphWidget wid;
     float       wv;

     {
        return( (Position) wv * (wid->core.width)/
		      (wid->graph.graphXMax-wid->graph.graphXMin));
     }


void drawline(wid,x,y,a,b)
        GraphWidget   wid;
        float      x,y,a,b;

        {
          Position x1,y1,a1,b1;
          world_to_device(wid,x,y,&x1,&y1);
          world_to_device(wid,a,b,&a1,&b1);
            XDrawLine(XtDisplay(wid), wid->core.background_pixmap
                                ,wid->graph.XGPgc,x1,y1,a1,b1);
        }

void DrawPolygon(wid,x1,y1,x2,y2,x3,y3,x4,y4)
      GraphWidget wid;
      float   x1,y1,x2,y2,x3,y3,x4,y4;
      {
      XPoint   p[4];
      unsigned long temp;

               world_to_device(wid,x1,y1,&p[0].x,&p[0].y);
               world_to_device(wid,x2,y2,&p[1].x,&p[1].y);
               world_to_device(wid,x3,y3,&p[2].x,&p[2].y);
               world_to_device(wid,x4,y4,&p[3].x,&p[3].y);
	       temp = wid->graph.XGPgc->values.foreground;
               XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
                                 wid->graph.background);
               XFillPolygon(XtDisplay(wid),wid->core.background_pixmap,
                    wid->graph.XGPgc,p,4,Convex,CoordModeOrigin);
               XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
                                 temp);
               drawline(wid,x1,y1,x2,y2);
               drawline(wid,x3,y3,x2,y2);
               drawline(wid,x3,y3,x4,y4);
               drawline(wid,x1,y1,x4,y4);
      }

void drawpoint(wid,x,y)
	GraphWidget   wid;
	float         x,y;

	{
	  Position   nx,ny;

        world_to_device(wid,x,y,&nx,&ny);
        XDrawPoint(XtDisplay(wid),wid->core.background_pixmap
	      ,wid->graph.XGPgc,nx,ny);

	}

void rawdrawpoint(wid,x,y)
      GraphWidget            wid;
      Position                  x,y; 

      {
	XDrawPoint(XtDisplay(wid),wid->core.background_pixmap
	     ,wid->graph.XGPgc,x,y);
      }

/******************************************************************/
/* This procedure allows the programmer to redefine the rotation  */
/* matrix. 							  */
/******************************************************************/

#define degrees_to_radians   0.0174533;

void Change_Line_Style(wid,width,style)
	GraphWidget     wid;
	int             width;
	int  	        style;

	{

	switch (style) {
	    case TSOLID :
	       XSetLineAttributes(XtDisplay(wid),wid->graph.XGPgc,
		(unsigned)width,LineSolid,CapButt,JoinMiter);
	       break;
	    case TDASHED :
	       XSetLineAttributes(XtDisplay(wid),wid->graph.XGPgc,
		  (unsigned)width, LineOnOffDash,CapButt,JoinMiter);
	       break;
	    case TDOUBLE :
	       XSetLineAttributes(XtDisplay(wid),wid->graph.XGPgc,
	          (unsigned)width,LineDoubleDash,CapButt,JoinMiter);
	       break;
	    default : break;
        }
     }

void XGPCopyArea(wid,slx,sly,swd,shg,dlx,dly)
    GraphWidget    wid;
    Position   slx,sly,swd,shg,dlx,dly;

    {
          XCopyArea(XtDisplay(wid),wid->core.background_pixmap,XtWindow(wid),
                               wid->graph.XGPgc,slx,sly,swd,shg,
                                dlx,dly);
    }


void XGPDrawString(wid,x,y,word,style)
      GraphWidget            wid;
      float                  x,y;
      char                   *word;
      int                    style;

      {
	 Position    x1,y1;

         world_to_device(wid,x,y,&x1,&y1);
	 if (style != TREGULAR) {
	     change_font(wid,style);
             put_word(wid,x1,y1,CENTER,RIGHT,word,style);
	     change_font(wid,TREGULAR);
	 } else {
	     put_word(wid,x1,y1,CENTER,RIGHT,word,style);
	 }
      }

void XGPDrawString3D(wid,x,y,z,word,style)
      GraphWidget            wid;
      float                  x,y,z;
      char                   *word;
      int                    style;
      
      {
       float      nx,ny,nz,nnx,nny;
       float      olx,oly,oux,ouy;

       translate(wid,x,y,z,&nx,&ny,&nz);
       PrepareProject(wid,&olx,&oly,&oux,&ouy);

       Project(wid,nx,ny,nz,&nnx,&nny);
       XGPDrawString(wid,nnx,nny,word,style);

       StopProject(wid,olx,oly,oux,ouy);
      }

void XGPDrawLine(wid,s,e)
      GraphWidget            wid;
      XtXGPPointStruct       s,e;

      {
	 Position  x1,x2,y1,y2;

	 world_to_device(wid,s.x,s.y,&x1,&y1);
	 world_to_device(wid,e.x,e.y,&x2,&y2);
	 XDrawLine(XtDisplay(wid), wid->core.background_pixmap,wid->graph.XGPgc,
		   x1,y1,x2,y2);
      }

void XGPDrawPoint(wid,p)
      GraphWidget            wid;
      XtXGPPointStruct       p;

      {
	Position x,y;

	world_to_device(wid,p.x,p.y,&x,&y);
	XDrawPoint(XtDisplay(wid),wid->core.background_pixmap
	    ,wid->graph.XGPgc,x,y);
      }

void XGPDrawElipse(wid,center,r1,r2)
	GraphWidget   wid;
	XtXGPPointStruct   center;
	float         r1,r2;

        { 
	  Position             nr1,nr2,x,y;
          XtXGPPointStruct      c;

	  c = center;
	   
          world_to_device(wid,c.x,c.y,&x,&y);
	  nr1 = device_length(wid,r1);
	  nr2 = device_length(wid,r2); 
          XDrawArc(XtDisplay(wid),wid->core.background_pixmap,wid->graph.XGPgc,x
                         ,y,nr1,nr2,0,23040);

        }

void redisplay_picture(wid)
	GraphWidget    wid;

	{
	   XGPNameList   *list;
	   XGPObject    *node;

	 if (wid->graph.Redraw == TON) {
	   XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
				 wid->graph.background);
	   XFillRectangle(XtDisplay(wid),wid->core.background_pixmap,
		   wid->graph.XGPgc,0,0,wid->core.width,wid->core.height);
	   XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
				 wid->graph.foreground);
	   list = wid->graph.names;
	   while (list != NULL) {
	       node = list->object;
	       switch (node->type) {
		 case XGPPrimitive :
		     DisplayPrimitive(wid,node,
		          wid->graph.twoDtrans.transformation);
		     break;
		 case XGPComplex :
		     DisplayComplex(wid,node,
			 wid->graph.twoDtrans.transformation);
		     break;
		 default : break;
	       }
	      list = list->next;
	   }
	   if (wid->graph.Hidden == TON) {
	       drawlist(wid);
           }
	   if ((wid->graph.mode != T3D) && (wid->graph.mode != T3DONLY)) {
	       display_axis(wid);
	       display_grid(wid);
	       display_ref(wid);
	   }
	   if ((wid->graph.mode == T3D) || (wid->graph.mode == T3DONLY)) {
	       Draw3DAxis(wid);
	       Draw3DViewbox(wid);
	   }
	 }
	}

extern GraphWidget widgetholdforparse;

static void XGPInitialize(junk,new)
    GraphWidget  junk,new;

    {
        int   i;
/***********************************************************************/
/*     get a graphics context for the widget                           */
/*     and initialize the transformation matricies and such            */
/***********************************************************************/

        new->graph.twoDtrans.Hidden = XtVisible;
	new->graph.twoDtrans.linewidth = 0;
	new->graph.twoDtrans.linestyle = TSOLID;
	new->graph.twoDtrans.fontstyle = TREGULAR;
	new->graph.twoDtrans.dimension = T2D;
	matrixident(new->graph.twoDtrans.transformation);

	new->graph.graphXMax = 100;
	new->graph.graphYMax = 100;
	new->graph.graphXMin = -100;
	new->graph.graphYMin = -100;
   
	new->graph.twoDvaluesFlag = FALSE;
	new->graph.Update2Dminmax = FALSE;
        new->graph.Hidden = TOFF;
	new->graph.polylist = NULL;
	
        matrixident(new->graph.trans3D);
       XGPSet3DViewing(new,100.0,20.0,20.0,0.0,0.0,0.0,100.0,100.0,100.0,-90.0);

/***********************************************************************/
/* set up the axis stuff for this durn thing                           */
/***********************************************************************/
        initalize_axis1(new);
	initalize_axis2(new);
	initalize_grid(new);
	initalize_horilin(new);
	initalize_virtlin(new);

/**********************************************************************/
/* set up the 3D axis stuff too                                       */
/**********************************************************************/

	initalize_3d_axis(new);

	new->graph.viewbox.xmin = -25;
	new->graph.viewbox.xmax = 25;
	new->graph.viewbox.ymin = -25;
	new->graph.viewbox.ymax = 25;
	new->graph.viewbox.zmin = -25;
	new->graph.viewbox.zmax = 25;
        new->graph.viewbox.visibility = XtInvisible;
	new->graph.viewbox.AxisColor = NULL;

/***********************************************************************/
/* set up the fils stuff for the record option                         */
/***********************************************************************/

	new->graph.files.outfile1 = NULL;
	new->graph.files.outflag = TOFF;

/**********************************************************************/
/*    initialize the symbol table for the parser                      */
/**********************************************************************/
         widgetholdforparse=new;
	 preload ();

/**********************************************************************/
/* set up 2d-3d flag and other misc stuff                             */
/**********************************************************************/

	 new->graph.mode = defaultdim;
	 new->graph.modeadj = TRUE;
	 new->graph.StringHold = NULL;
	 new->graph.StringLength = 0;

/**********************************************************************/
/* set up the stuff for the hard copy routines                        */
/**********************************************************************/
 
	 new->graph.HardCopyStuff =  (OutputParam*) CreateOutputParameters(new);

/**********************************************************************/
/* set up the colormap flag.   (we are using the default color map    */
/**********************************************************************/

	new->graph.ColormapMode = TPUBLIC;
	new->graph.Redraw = TON;
	new->graph.SUImode = TOFF;
	new->graph.extremes.xmax = 0;
	new->graph.extremes.xmin = 0;
	new->graph.extremes.ymax = 0;
	new->graph.extremes.ymin = 0;
	new->graph.extremes.zmax = 0;
	new->graph.extremes.zmin = 0;
	new->graph.extremes.dxmin = 0;
	new->graph.extremes.dxmax = 0;
	new->graph.extremes.dymin = 0;
	new->graph.extremes.dymax = 0;
	new->graph.extremes.valid = FALSE;
	new->graph.extremes.dvalid = FALSE;
    }

void XGPInit(wid)
     GraphWidget  wid;
     {
	 XGPInitialize(NULL,wid);
     }

static void XGPRealize(w,valueMask, attributes)
     GraphWidget w;
     Mask *valueMask;
     XSetWindowAttributes *attributes;
     
     { 
       XGCValues values;
       Display   *disp;
       int       scrnnum;

       (widgetClassRec.core_class.realize)(w,valueMask,attributes);

/*******************************************************************/
/*   find the display and the screen number, then finally point to */
/*   the default colormap of the wm                                */
/*******************************************************************/

       disp = XtDisplay(w);
       scrnnum = XDefaultScreen(disp);
       w->core.colormap = XDefaultColormap(disp,scrnnum);
       w->graph.ColormapMode = TPUBLIC;

/*******************************************************************/
/* get a pixmap to draw in so that all is nice and purdy           */
/*******************************************************************/

       w->core.background_pixmap = XCreatePixmap(XtDisplay(w),XtWindow(w), 
		       w->core.width,w->core.height,
                       XDefaultDepthOfScreen(XtScreen(w)));
       values.foreground = w->graph.background;
       values.background = w->graph.foreground;

       w->graph.XGPgc = XtGetGC(w,GCForeground|GCBackground,&values);
       change_font(w,TREGULAR);   /* load the correct font into the gc */
       XtAddInput(0,XtInputReadMask,parse,w);
       redisplay_picture(w);

     }
static void XGPResize(w,event)
    GraphWidget    w;
    XEvent         *event;

    { 
       if (XtIsRealized(w) != True) {
	  return;
       } else {
           XFreePixmap(XtDisplay(w),w->core.background_pixmap);
           w->core.background_pixmap = XCreatePixmap(XtDisplay(w),XtWindow(w), 
		       w->core.width,w->core.height,
                       XDefaultDepthOfScreen(XtScreen(w)));
           redisplay_picture(w);
      }
    }

static void XGPExpose(wid,event)
    GraphWidget    wid;
    XEvent         *event;

    { 
       XGPCopyArea(wid,0,0,wid->core.width,wid->core.height,0,0); 
    }

GraphClassRec graphClassRec = {
  { /* core fields */
    /* superclass		*/	(WidgetClass) &widgetClassRec,
    /* class_name		*/	"Graph",
    /* widget_size		*/	sizeof(GraphRec),
    /* class_initialize		*/	NULL,
    /* class_part_initialize	*/	NULL,
    /* class_inited		*/	FALSE,
    /* initialize		*/	XGPInitialize,
    /* initialize_hook		*/	NULL,
    /* realize			*/	XGPRealize,
    /* actions			*/	actionsList,
    /* num_actions		*/	XtNumber(actionsList),
    /* resources		*/	resources,
    /* num_resources		*/	XtNumber(resources),
    /* xrm_class		*/	NULLQUARK,
    /* compress_motion		*/	TRUE,
    /* compress_exposure	*/	TRUE,
    /* compress_enterleave	*/	TRUE,
    /* visible_interest		*/	FALSE,
    /* destroy			*/	NULL,
    /* resize			*/	XGPResize,
    /* expose			*/	XGPExpose,
    /* set_values		*/	NULL,
    /* set_values_hook		*/	NULL,
    /* set_values_almost	*/	XtInheritSetValuesAlmost,
    /* get_values_hook		*/	NULL,
    /* accept_focus		*/	NULL,
    /* version			*/	XtVersion,
    /* callback_private		*/	NULL,
    /* tm_table			*/	defaultTranslations,
    /* query_geometry		*/	XtInheritQueryGeometry,
    /* display_accelerator	*/	XtInheritDisplayAccelerator,
    /* extension		*/	NULL
  },
  { /* graph fields */
    /* empty			*/	0
  }
};

WidgetClass graphWidgetClass = (WidgetClass)&graphClassRec;
