#include <X11/copyright.h>

/* $XConsortium: Graph.h,v 1.2 88/10/25 17:22:09 swick Exp $ */
/* Copyright	Massachusetts Institute of Technology	1987, 1988 */

#ifndef _Graph_h
#define _Graph_h

/****************************************************************
 *
 * Graph widget
 *
 ****************************************************************/

/* Resources:

 Name		     Class		RepType		Default Value
 ----		     -----		-------		-------------
 background	     Background		Pixel		XtDefaultBackground
 border		     BorderColor	Pixel		XtDefaultForeground
 borderWidth	     BorderWidth	Dimension	1
 destroyCallback     Callback		Pointer		NULL
 height		     Height		Dimension	0
 mappedWhenManaged   MappedWhenManaged	Boolean		True
 sensitive	     Sensitive		Boolean		True
 width		     Width		Dimension	0
 x		     Position		Position	0
 y		     Position		Position	0
 font                Font               XFontStruct*    XtDefaultFont
 foreground          Foreground         Pixel           XtDefaultForeground
 buisy               Callback           Pointer         NULL
 response            Callback           Pointer         NULL
 error               Callback           Pointer         GraphError
*/

/* define any special resource names here that are not in <X11/StringDefs.h> */

#define XtNnormalFont             "normalfont"
#define XtNitalicFont   	  "italicfont"
#define XtNboldFont	          "boldfont"
#define XtNgreekFont		  "greekfont"
#define XtNbuisy   		  "buisy"
#define XtNresponse               "response"
#define XtNerror         	  "error"
#ifndef XtNforeground
#define XtNforeground             "foreground"
#define XtNbackground             "background"
#endif

#ifndef XtCForeground
#define XtCForeground             "Foreground"
#define XtCBackground             "Background"
#endif
#define XtCNormalFont	          "NormalFont"
#define XtCItalicFont	          "ItalicFont"
#define XtCBoldFont		  "BoldFont"
#define XtCGreekFont		  "GreekFont"
#define XtCBuisy   		  "Buisy"
#define XtCResponse               "Response"
#define XtCError      		  "Error"

#define XtRotate      0
#define XtTranslate   1
#define XtScale       2 

#define XtDegres      0
#define XtRadians     1

#define XtVisible     1 
#define XtInvisible   0

#define XtWorking      1
#define XtDone         2

/* the folowing are structures to use in the graphwidget */

#define XtXGPTransformationMatricies 3


/* declare specific GraphWidget class and instance datatypes */

typedef struct _GraphClassRec*	GraphWidgetClass;
typedef struct _GraphRec*		GraphWidget;

/* declare the class constant */

extern WidgetClass graphWidgetClass;

extern void buildcommand();  /* wid, buffer */
     /* GraphWidget   wid     */
     /* char          *buffer */

extern void parsebuiltcommand();  /* wid */
     /* GraphWidget   wid     */

extern void XGPParseString();  /* wid, buffer */
     /* GraphWidget   wid     */
     /* char          *buffer */

#endif  _Graph_h
