#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

extern float XGPPixelsPerUnitX();
extern float XGPPixelsPerUnitY();
extern float return_float_point();
extern int   return_int_point();
extern int   return_visibility();
extern int   return_justify();

void assign3daxisstuff(tree,data)
	XGP_node    *tree;
	D3reflinedef *data;

	{
	  data->start = return_float_point(tree->child[0]->child[0]);
	  data->stop = return_float_point(tree->child[0]->child[1]);
	  data->otherv1=return_float_point(tree->child[1]->child[0]->child[0]);
	  data->otherv2=return_float_point(tree->child[1]->child[0]->child[1]);
	  data->center = return_float_point(tree->child[1]->child[1]);
	}

void Assign3DRefAttrib(wid,tree)
        GraphWidget     wid;
        XGP_node    *tree;
   
	{
	  if (tree != NULL ) {
	    switch (tree->node_type) {
		case TVISIBILITY :
		     wid->graph.axis3d.xline.visibility = 
			      return_visibility(tree->child[0]->node_type);
		     wid->graph.axis3d.yline.visibility = 
			      return_visibility(tree->child[0]->node_type);
		     wid->graph.axis3d.zline.visibility = 
			      return_visibility(tree->child[0]->node_type);
		     break;
		case TXAXIS :
		    assign3daxisstuff(tree,&wid->graph.axis3d.xline); 
		    break;
		case TYAXIS :
		    assign3daxisstuff(tree,&wid->graph.axis3d.yline);
		    break;
		case TZAXIS :
		    assign3daxisstuff(tree,&wid->graph.axis3d.zline);
		    break;
		case TCOLOR :
		 AssignColorField(wid,
			tree->child[0]->sval,&wid->graph.axis3d.AxisColor);
		  break;
		default :
		    break;
	    }
	    Assign3DRefAttrib(wid,tree->sibling);
	  } else {
	    redisplay_picture(wid);
	  }
	}

void Draw3DAxis(wid)
        GraphWidget wid;

        {
          /* Draw the give axis */
	  if (NULL != wid->graph.axis3d.AxisColor) {
	       XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		  MakeColor(wid,wid->graph.axis3d.AxisColor));
	  }
          if (wid->graph.axis3d.xline.visibility == TRUE) {
              XGPDrawLine3D(wid,wid->graph.axis3d.xline.start,
                            wid->graph.axis3d.xline.otherv1,
                            wid->graph.axis3d.xline.otherv2,
                            wid->graph.axis3d.xline.stop,
                            wid->graph.axis3d.xline.otherv1,
                            wid->graph.axis3d.xline.otherv2,TRUE);
          }
          if (wid->graph.axis3d.yline.visibility == TRUE) {
              XGPDrawLine3D(wid,wid->graph.axis3d.yline.otherv1,
                            wid->graph.axis3d.yline.start,
                            wid->graph.axis3d.yline.otherv2,
                            wid->graph.axis3d.yline.otherv1,
                            wid->graph.axis3d.yline.stop,
                            wid->graph.axis3d.yline.otherv2,TRUE);
          }
          if (wid->graph.axis3d.zline.visibility == TRUE) {
              XGPDrawLine3D(wid,wid->graph.axis3d.zline.otherv1,
                            wid->graph.axis3d.zline.otherv2,
                            wid->graph.axis3d.zline.start,
                            wid->graph.axis3d.zline.otherv1,
                            wid->graph.axis3d.zline.otherv2,
                            wid->graph.axis3d.zline.stop,TRUE);
          }
	  if (NULL != wid->graph.axis3d.AxisColor) {
	     XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		wid->graph.foreground);
	  }
        }

void AssignVolumeRefAttrib(wid,tree) 
	GraphWidget   wid;
	XGP_node      *tree;

	{
	if (tree != NULL) {
	    switch (tree->node_type) {
		case TVISIBILITY :
		    wid->graph.viewbox.visibility = return_visibility
				    (tree->child[0]->node_type);
		    break;
		case TVIEWCOR :
		    wid->graph.viewbox.xmin = return_float_point(
                            tree->child[0]->child[0]->child[0]);
		    wid->graph.viewbox.ymin = return_float_point(
                            tree->child[0]->child[0]->child[1]);
		    wid->graph.viewbox.zmin = return_float_point(
                            tree->child[0]->child[1]);
		    wid->graph.viewbox.xmax = return_float_point(
                            tree->child[1]->child[0]->child[0]);
		    wid->graph.viewbox.ymax = return_float_point(
                            tree->child[1]->child[0]->child[1]);
		    wid->graph.viewbox.zmax = return_float_point(
                            tree->child[1]->child[1]);
	            break;
		case TVIEWDIM :
		    wid->graph.viewbox.xmin = 
			return_float_point(tree->child[0]->child[0]->child[0])
			-return_float_point(tree->child[1]->child[0]->child[0])
			/2;
		    wid->graph.viewbox.xmax =
		     return_float_point(tree->child[0]->child[0]->child[0])
		     +return_float_point(tree->child[1]->child[0]->child[0])/2;
		    wid->graph.viewbox.ymin =
		     return_float_point(tree->child[0]->child[0]->child[1])-
		     return_float_point(tree->child[1]->child[0]->child[1])/2;
		    wid->graph.viewbox.ymax =
		     return_float_point(tree->child[0]->child[0]->child[1])+
		     return_float_point(tree->child[1]->child[0]->child[1])/2;
		    wid->graph.viewbox.zmin =
		     return_float_point(tree->child[0]->child[1])-
		     return_float_point(tree->child[1]->child[1])/2;
		    wid->graph.viewbox.zmax =
		     return_float_point(tree->child[0]->child[1])+
		     return_float_point(tree->child[1]->child[1])/2;
		    break;
		case TCOLOR:
		 AssignColorField(wid,
		      tree->child[0]->sval,&wid->graph.viewbox.AxisColor);
		  break;
		default :
		    break;
	    }
            AssignVolumeRefAttrib(wid,tree->sibling);
	  } else {
            redisplay_picture(wid);
	  }
	}

void Draw3DViewbox(wid)
	GraphWidget   wid;

/* do the following   
	 1. translate edges and place them in an edge table
	 2. sort on lowest z.
	 3  draw first 3 edges dashed.
	 4. draw the rest of the edges
*/

	{
        XtXGPPointStruct  edges[12][2];
	int               loop,loop1;
        float             mx,xx,my,xy,mz,xz;

	    if (wid->graph.viewbox.visibility == XtVisible) {
	        mx = wid->graph.viewbox.xmin;
	        my = wid->graph.viewbox.ymin;
	        mz = wid->graph.viewbox.zmin;
	        xx = wid->graph.viewbox.xmax;
	        xy = wid->graph.viewbox.ymax;
	        xz = wid->graph.viewbox.zmax;

	translate(wid,mx,my,mz,&edges[0][0].x,&edges[0][0].y,&edges[0][0].z);
        translate(wid,mx,my,xz,&edges[0][1].x,&edges[0][1].y,&edges[0][1].z);
	translate(wid,mx,my,mz,&edges[1][0].x,&edges[1][0].y,&edges[1][0].z);
	translate(wid,xx,my,mz,&edges[1][1].x,&edges[1][1].y,&edges[1][1].z);
        translate(wid,mx,my,mz,&edges[2][0].x,&edges[2][0].y,&edges[2][0].z);	
	translate(wid,mx,xy,mz,&edges[2][1].x,&edges[2][1].y,&edges[2][1].z);
        translate(wid,xx,xy,mz,&edges[3][0].x,&edges[3][0].y,&edges[3][0].z);	
	translate(wid,mx,xy,mz,&edges[3][1].x,&edges[3][1].y,&edges[3][1].z);
        translate(wid,xx,xy,mz,&edges[4][0].x,&edges[4][0].y,&edges[4][0].z);	
	translate(wid,xx,my,mz,&edges[4][1].x,&edges[4][1].y,&edges[4][1].z);
        translate(wid,xx,xy,mz,&edges[5][0].x,&edges[5][0].y,&edges[5][0].z);	
	translate(wid,xx,xy,xz,&edges[5][1].x,&edges[5][1].y,&edges[5][1].z);
        translate(wid,xx,my,xz,&edges[6][0].x,&edges[6][0].y,&edges[6][0].z);	
	translate(wid,mx,my,xz,&edges[6][1].x,&edges[6][1].y,&edges[6][1].z);
        translate(wid,xx,my,xz,&edges[7][0].x,&edges[7][0].y,&edges[7][0].z);	
	translate(wid,xx,xy,xz,&edges[7][1].x,&edges[7][1].y,&edges[7][1].z);
        translate(wid,xx,my,xz,&edges[8][0].x,&edges[8][0].y,&edges[8][0].z);	
	translate(wid,xx,my,mz,&edges[8][1].x,&edges[8][1].y,&edges[8][1].z);
        translate(wid,mx,xy,xz,&edges[9][0].x,&edges[9][0].y,&edges[9][0].z);	
	translate(wid,mx,my,xz,&edges[9][1].x,&edges[9][1].y,&edges[9][1].z);
       translate(wid,mx,xy,xz,&edges[10][0].x,&edges[10][0].y,&edges[10][0].z);	
       translate(wid,xx,xy,xz,&edges[10][1].x,&edges[10][1].y,&edges[10][1].z);
       translate(wid,mx,xy,xz,&edges[11][0].x,&edges[11][0].y,&edges[11][0].z);	
       translate(wid,mx,xy,mz,&edges[11][1].x,&edges[11][1].y,&edges[11][1].z);

   
	    for (loop=0;loop<12;loop++) {
		if (edges[loop][0].x > edges[loop][1].x) {
 mx=edges[loop][0].x; edges[loop][0].x=edges[loop][1].x;edges[loop][1].x=mx;
 my=edges[loop][0].y; edges[loop][0].y=edges[loop][1].y;edges[loop][1].y=my;
 mz=edges[loop][0].z; edges[loop][0].z=edges[loop][1].z;edges[loop][1].z=mz;
		}
	    }

	    for (loop=0;loop<11;loop++) {
	       for (loop1=loop+1;loop1<12;loop1++) {
		  if (edges[loop][0].x > edges[loop1][0].x) {
 mx=edges[loop1][0].x; edges[loop1][0].x=edges[loop][0].x;edges[loop][0].x=mx;
 my=edges[loop1][0].y; edges[loop1][0].y=edges[loop][0].y;edges[loop][0].y=my;
 mz=edges[loop1][0].z; edges[loop1][0].z=edges[loop][0].z;edges[loop][0].z=mz;
 mx=edges[loop1][1].x; edges[loop1][1].x=edges[loop][1].x;edges[loop][1].x=mx;
 my=edges[loop1][1].y; edges[loop1][1].y=edges[loop][1].y;edges[loop][1].y=my;
 mz=edges[loop1][1].z; edges[loop1][1].z=edges[loop][1].z;edges[loop][1].z=mz;
                  }
	       }
	    }
	    if (NULL != wid->graph.viewbox.AxisColor) {
	       XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		    MakeColor(wid,wid->graph.viewbox.AxisColor));
            }

	    mz = edges[0][0].x;

	    for (loop=0;loop<12;loop++) {
                if (edges[loop][0].x == mz) {
		    Change_Line_Style(wid,0,TDASHED);
		}
		XGPDrawLine3D(wid,edges[loop][0].x,edges[loop][0].y,
			          edges[loop][0].z,edges[loop][1].x,
			          edges[loop][1].y,edges[loop][1].z,FALSE);
                if (edges[loop][0].x == mz) {
		    Change_Line_Style(wid,0,TSOLID);
		}
	    }
	    if (NULL != wid->graph.viewbox.AxisColor) {
		XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		    wid->graph.foreground);
	    }
          }
	}
