#include <stdio.h>
#include "GraphP.h"
#include "GraphAxis.h"

/*********************************************************************/
/* Procedure display axis   					     */
/* Dan Bennett     11/89					     */
/* 								     */
/* this procedure sets up for a call to draw reference line to       */
/* which will display both axis 1 and axis2.                         */
/*********************************************************************/

void display_axis(wid)
       GraphWidget   wid;

       {
         Position x1,x2,y1,y2;
         float    current,start,stop;
         int      tickskip = 0;
	 param    *fid;
         int      loop;

	   fid = (param*) XGPmalloc(wid,sizeof(param));
	   for (loop=0;loop < MaxAxis;loop++){
           if (wid->graph.axis[loop].Visible ){
		fid->dir = VERTICAL;
                fid->loc = wid->graph.axis[loop].YCenter;
		fid->lab = wid->graph.axis[loop].YLabelVisible; 
                fid->tick = wid->graph.axis[loop].YTickVisible; 
		fid->tickskip = wid->graph.axis[loop].YLabelSkip;
                fid->labskip = wid->graph.axis[loop].YLabelSkip;
		fid->width = wid->graph.axis[loop].YWidth;
		fid->style = wid->graph.axis[loop].YStyle; 
		fid->labfont = wid->graph.axis[loop].YLabelFont;
		fid->labipre = wid->graph.axis[loop].YIntPre;
		fid->labdpre = wid->graph.axis[loop].YDecPre;
		fid->labjust = wid->graph.axis[loop].Yjustify;
		fid->cent = wid->graph.axis[loop].XCenter;
		fid->tickscal = wid->graph.axis[loop].Yscale;
		fid->tickmin = wid->graph.axis[loop].TickYmin;
		fid->tickmax = wid->graph.axis[loop].TickYmax; 
		fid->labmin = wid->graph.axis[loop].LabYmin;
		fid->labmax = wid->graph.axis[loop].LabYmax;
		fid->AC = wid->graph.axis[loop].AxisColor;
		fid->TC = wid->graph.axis[loop].TickColor;
		fid->LC = wid->graph.axis[loop].LabelColor;
		drawReferenceLine(wid,fid,Default);
		fid->dir = HOROZONTAL;
                fid->loc = wid->graph.axis[loop].XCenter;
		fid->lab = wid->graph.axis[loop].XLabelVisible; 
                fid->tick = wid->graph.axis[loop].XTickVisible; 
		fid->tickskip = wid->graph.axis[loop].XLabelSkip;
                fid->labskip = wid->graph.axis[loop].XLabelSkip;
		fid->width = wid->graph.axis[loop].XWidth;
		fid->style = wid->graph.axis[loop].XStyle;
		fid->labfont = wid->graph.axis[loop].XLabelFont;
		fid->labipre = wid->graph.axis[loop].XIntPre;
		fid->labdpre = wid->graph.axis[loop].XDecPre;
		fid->labjust = wid->graph.axis[loop].Xjustify;
		fid->cent = wid->graph.axis[loop].YCenter;
		fid->tickscal = wid->graph.axis[loop].Xscale;
		fid->tickmin = wid->graph.axis[loop].TickXmin;
		fid->tickmax = wid->graph.axis[loop].TickXmax; 
		fid->labmin = wid->graph.axis[loop].LabXmin;
		fid->labmax = wid->graph.axis[loop].LabXmax;
		drawReferenceLine(wid,fid,Default);
	  }
     } /* of the for loop */
     free(fid);
}
