#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <stdio.h>
#include <math.h>
#include "GraphP.h"

#define degrees_to_radians   0.0174533

SquareSurfaceStruct* CreateCircle(wid,x,y,z,a,b,c,radius,npoints)
	GraphWidget  wid;
	float   x,y,z,a,b,c;  /* x,y,z center a,b,c normal */
	float   radius;       /* the radius of the circle */
	int     npoints;      /* the number of points to genorate */

	{
	  float   ca,cb,sa,sb,d1,d2;
	  float   t1,t2,t3;
	  float   x1,y1,z1;
          SquareSurfaceStruct   *temp,*points;

/* build the transformation matrix */

	  points = NULL;

	  t1 = (a-x)*(a-x);
	  t2 = (b-y)*(b-y);
	  t3 = (c-z)*(c-z);

	  d1 = (float) sqrt(t1+t2+t3);
          if (0 == d1) {
	      ca = 1;
	      sa = 0;
	  } else {
	      ca = (float) ((a-x)+(c-z))/d1;
	      sa = (float) (b-y)/d1;
	  }
	  t1 = a*ca+b*sa-x;
	  t1 = t1 * t1;
	  d2 = (float) sqrt(t1+t3);
	  if (0 == d2) {
	      cb = 1;
	      sb = 0;
	  } else {
	      cb = (a*ca+b*sa-x) / d2;
	      sb = (c-z) / d2;
	  }

	  for (t1=0;t1<=360+ 360/(npoints);t1 = t1+ 360/(npoints)) {
	      z1= radius * cos(t1*degrees_to_radians);
	      y1= radius * sin(t1*degrees_to_radians);
	      x1= 0;
	      temp = (SquareSurfaceStruct*)XGPmalloc(wid,sizeof(SquareSurfaceStruct));
	      temp->x = x1*ca*cb - y1*sa - z1*sb*ca + x;
	      temp->y = x1*cb*sa + y1*ca - z1*sa*sb + y;
	      temp->z = x1*sb + z1*cb + z;
	      temp->sp = NULL;
	      temp->fp = points;
	      points = temp;
	  }
	  return(points);
    }
