#include "GraphP.h"

void AssignColorField(wid,foo,bar)
	char *foo,**bar;

	{
	  if (foo != NULL) {
	    if (*bar != NULL) {
		free(*bar);
	    }
	    *bar =(char*) XGPmalloc(wid,(strlen(foo)+1)*sizeof(char));
	       strcpy(*bar,foo);
	  }
	}

unsigned long MakeColor(wid,name)
  GraphWidget   wid;
  char          *name;
     {
     XColor   exact,close;
     Display  *disp;
     Screen   *scrn;
     int      scrnnum;

     disp = XtDisplay(wid);
     scrnnum = XDefaultScreen(disp);
     scrn = XScreenOfDisplay(disp,scrnnum);

     if (XLookupColor(disp,wid->core.colormap,name,&exact,&close) == 1) {
         if(XAllocColor(disp,wid->core.colormap,&exact)){
            return(exact.pixel);
         } else {
            error(wid,260,name);
            return(wid->graph.foreground);
         }
     } else {
	 error(wid,261,name);
         return(wid->graph.foreground);
     }
     }

/*******************************************/
/* make a new colormap if the default is the default color map
   and nothing if the colormap is curently not the default
*******************************************/

void MakeColormap(wid)
	GraphWidget   wid;

	{
	 Display   *disp;
	 XColor    fg,bg;

         disp = XtDisplay(wid);

/* get the color of the forground and background in the old colormap */

         fg.pixel = wid->graph.foreground;
	 bg.pixel = wid->graph.background;

	 wid->graph.fghold = fg.pixel;
	 wid->graph.bghold = bg.pixel;

	 XQueryColor(disp,wid->core.colormap,&fg);
	 XQueryColor(disp,wid->core.colormap,&bg);

/* make a new colormap */

	 wid->core.colormap =
                 XCreateColormap(disp,XtWindow(wid),
		 DefaultVisual(disp,XDefaultScreen(disp)),AllocNone);

/* set up the forground and background colors in the new colormap*/

	 XAllocColor(disp,wid->core.colormap,&fg);
	 XAllocColor(disp,wid->core.colormap,&bg);

	 XSetBackground(disp,wid->graph.XGPgc,bg.pixel);
         XSetForeground(disp,wid->graph.XGPgc,fg.pixel);

	 wid->graph.foreground = fg.pixel;
	 wid->graph.background = bg.pixel;
	}

void RestoreDefaultColormap(wid)
	GraphWidget wid;
	{
	  Display   *disp;

         disp = XtDisplay(wid);
	 XSetBackground(disp,wid->graph.XGPgc,wid->graph.bghold);
         XSetForeground(disp,wid->graph.XGPgc,wid->graph.fghold);

	 XFreeColormap(disp,wid->core.colormap);

	 wid->core.colormap = DefaultColormap(disp,XDefaultScreen(disp));

	}
