#include <stdio.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"


/****************************************************************/
/*  Procedure getcommand					*/
/* Programmer Dan Bennett       10/30/89                        */
/*								*/
/* this routine will read in a command from the file pointed to */
/* by the file pointer fp.  It will return a command or a null  */
/* string if the end of file is reached.                        */
/****************************************************************/


#define STOP 0
#define GO   1
#define BLKSIZ 215

char* getcommand(wid,fp)
	 GraphWidget  wid;
	 FILE      *fp;

	 {
	 char    buf1,
		 *buf2;
         int     len = 0,
                 stopflag = GO,
                 pcount = 0;


            buf2 = (char*) XGPmalloc(wid,BLKSIZ*sizeof(char));
            while (((buf1 = getc(fp)) !=  EOF) && (stopflag != STOP)) {
              if (buf1 != '\n') {
               buf2[len++] = buf1;
               if ((len % (BLKSIZ-1)) == 0) {
                  buf2 = (char*) realloc(buf2,len+BLKSIZ+1);
	          if (buf2 == NULL) {
	             fprintf(stderr,"XGP Out of Memmory DEAD");
	             exit(1);
	          }

               }
               if (buf1 == '(') {
                  pcount ++ ;
               }
               if (buf1 == ')') {
                  pcount -- ;
                  if (pcount == 0) { stopflag = STOP; }
               }
              }
            }
            buf2[len] = NULL;
	    return(buf2);
        }

FILE* openfile(path)
	char    *path;

        {
   	    return( fopen(path,"r"));
        }

FILE* openwfile(path)
	char    *path;

        {
   	    return( fopen(path,"w"));
        }

closefile (fp)
        FILE     *fp;
	{
   	    fclose(fp);
        }

/****************************************************************/
/* Procedure XGPReadFile         				*/
/* Programmer Dan Bennett     10/31/89                          */
/*								*/
/* This routine will open a file, read in commands, and pass    */
/* those commands to XGPParseString.  If the file is not found  */
/* then an error message is issued                              */
/****************************************************************/

XGPReadFile(wid,path) 
        GraphWidget     wid;
        char            *path;

	{
 	    FILE   *fp;
	    char   *command = "A";

	    fp = openfile(path);
	    if (fp != NULL) {
		while (command[0] != NULL ) {
		    command = getcommand(wid,fp);
		    if (command[0] != NULL) {
		        XGPParseString(wid,command);
		    }
		    free(command);
		}
		closefile(fp);
	    } else {
		error(wid,240,path);
	    }
	}
	

void savecommand(wid,source)
	GraphWidget      wid;
	char             *source;

	{
	     fprintf(wid->graph.files.outfile1,"%s\n",source);
	}

void startsave (wid,path)
	GraphWidget    wid;
	char           *path;

	{
	   if (wid->graph.files.outflag == TOFF) {
	    wid->graph.files.outfile1 = fopen(path,"w");
	    wid->graph.files.outflag = TON;
	   } else {
	    error(wid,241,NULL);
	   }
	}

void stopsave(wid)
	GraphWidget    wid;

	{
	  if (wid->graph.files.outflag == TON) {
            wid->graph.files.outflag = TOFF;
	    close(wid->graph.files.outfile1);
	    wid->graph.files.outfile1 = NULL;
	  } else {
	    error(wid,242,NULL);
	  }
	}

extern char* AllAsk();

void XGPSaveEnv(wid,tree)
	GraphWidget   wid;
	XGP_node      *tree;
	{
	   FILE   *thefile;
           char   *foo;

	   thefile = openwfile(tree->child[0]->sval);
           foo = (char*) AllAsk(wid);
	   fprintf(thefile,"%s",foo);
	   closefile(thefile);
	}
