#include <stdio.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"


void namemaker(temp)
     char   *temp;

	{
	   static int count = 0;

	    sprintf(temp,"temp%d",count++);
	    while (Existing_Name (temp)) {
	        sprintf(temp,"temp%d",count++);
	    }
	}

void addonend(str1,str2)
	char **str1,*str2;

	{
	  *str1=(char*)realloc(*str1,sizeof(char)*(strlen(*str1)+strlen(str2)));
	  strcat(*str1,str2);
	}

char *ModeAsk(wid)
	GraphWidget    wid;

	{
  	   char           *strn;
	   char           *temp;

	   strn = (char*) XGPmalloc(wid,13);
	   switch(wid->graph.Redraw) {
	      case TON: 
	         sprintf(strn,"(Redraw On)");
	         break;
	      case TOFF: 
	         sprintf(strn,"(Redraw Off)");
	         break;
	     default: 
	         break;
           }

           temp = (char*) XGPmalloc(wid,50);
	   switch(wid->graph.SUImode) {
	      case TON: 
	         sprintf(temp,"(SUImode On)");
	         break;
	      case TOFF: 
	         sprintf(temp,"(SUImode Off)");
	         break;
	     default: 
	         break;
	   }
	   addonend(&strn,temp);

	   switch(wid->graph.ColormapMode) {
	      case TPRIVATE: 
	         sprintf(temp,"(Colormap Private)");
	         break;
	      case TPUBLIC: 
	         sprintf(temp,"(Colormap Public)");
	         break;
	     default: 
	         break;
	   }
	   addonend(&strn,temp);

          return(strn);
	}

char *OutputAsk(wid)
	GraphWidget    wid;

	{
  	   char           *strn;
	   char           *temp;

	   strn = (char*) XGPmalloc(wid,50);
	   sprintf(strn,"(DotsPerUnit %d)",wid->graph.HardCopyStuff->dpi);

           temp = (char*) XGPmalloc(wid,50);
	   sprintf(temp,"(PictureWidth %f)(PictureLength %f)",
	     wid->graph.HardCopyStuff->width,wid->graph.HardCopyStuff->height);
	   strn =(char*) realloc(strn,strlen(strn)+strlen(temp));
	   (void) strcat(strn,temp);

           bzero(temp,50);
	   switch (wid->graph.HardCopyStuff->otype) {
	       case TPAINTJET :
		   (void) strcpy(temp,"(OutputFormat PaintJet)");
		   break;
	       case TLASERJET :
		   (void) strcpy(temp,"(OutputFormat LaserJet)");
		   break;
	       case TTEXSPEC :
		   (void) strcpy(temp,"(OutputFormat TexSpecial)");
		   break;
           }
	   strn = (char*)realloc(strn,strlen(strn)+strlen(temp));
	   (void) strcat(strn,temp);
           
	   bzero(temp,50);
	   if (wid->graph.HardCopyStuff->path != NULL) {
	 temp = (char*)realloc(temp,14+strlen(wid->graph.HardCopyStuff->path));
             sprintf(temp,"(OutputFile %s)",wid->graph.HardCopyStuff->path);
	   } else {
	     temp = (char*)realloc(temp,23);
             sprintf(temp,"(OutputFile nil)");
	   }
	   strn = (char*) realloc(strn,strlen(strn)+strlen(temp));
	   (void) strcat(strn,temp);
	  
	   free(temp);
	   return(strn);
	}


char *AskObjectNames(wid)
	GraphWidget    wid;
        {
	 char    *temp;
	 int     count=0,lgth=14;
         XGPNameList   *list;

	 list = wid->graph.names;
         while (list != NULL) {
              lgth = lgth + strlen(list->object->aname->name)+1;
	      list = list->next;
	      count ++;
         } /* while */
	 temp = (char*)XGPmalloc(wid,lgth);
         sprintf(temp,"(Objects %3d ",count);
	 list = wid->graph.names;
         while (list != NULL) {
    	      strcat(temp,list->object->aname->name); 
	      strcat(temp," ");
	      list = list->next;
         } /* while */
	 (void) strcat(temp,")");
	 return(temp);

	}

char *EyeDistanceAsk(wid)
	GraphWidget   wid;
	{
	  char  *foo;

	  foo = (char*) XGPmalloc(wid,60*sizeof(char));
	  sprintf(foo,"(DistanceFromEye  %f)", wid->graph.thd.d1);
	  return(foo);
	}

char *ViewDistanceAsk(wid)
	GraphWidget   wid;
	{
	  char  *foo;

	  foo = (char*) XGPmalloc(wid,60*sizeof(char));
	  sprintf(foo,"(ViewportSize %f %f)",wid->graph.thd.d2,
		   wid->graph.thd.d3);
	  return(foo);
	}


char *EyePositionAsk(wid)
	GraphWidget   wid;
	{
	  char  *foo;

	  foo = (char*) XGPmalloc(wid,60*sizeof(char));
	  sprintf(foo,"(EyePosition %f %f %f)", wid->graph.thd.eye.x,
	     wid->graph.thd.eye.y,wid->graph.thd.eye.z);
	  return(foo);
	}

char *FocusPositionAsk(wid)
	GraphWidget   wid;
	{
	  char  *foo;

	  foo = (char*) XGPmalloc(wid,60*sizeof(char));
	  sprintf(foo,"(FocusPosition %f %f %f)", wid->graph.thd.center.x,
	     wid->graph.thd.center.y,wid->graph.thd.center.z);
	  return(foo);
	}

char *ViewportAsk(wid)
	GraphWidget   wid;
	{
	  char  *foo;

	  foo = (char*) XGPmalloc(wid,60*sizeof(char));
	  sprintf(foo,"(Viewport %f %f %f %f)", wid->graph.graphXMax,
	     wid->graph.graphYMax,wid->graph.graphXMin,wid->graph.graphYMin);
	  return(foo);
	}

char* WorldTreeAsk(wid,tree)
	GraphWidget  wid;
	XGP_node    *tree;
	{
	    char   *strn1,*strn2,*finalstrn;
            int     temp;

	    if (tree!= NULL) {
	        switch (tree->node_type) {
	    	     case TVIEWPORT : 
	    	         strn1 = ViewportAsk(wid);
		         break;
		     case TOUTPUT :
			 strn1 = OutputAsk(wid);
			 break;
		     case TFOCPOS :
			 strn1 = FocusPositionAsk(wid);
			 break;
		     case TDISTFROMI :
			 strn1 = EyeDistanceAsk(wid);
			 break;
		     case TVIEWSIZE :
			 strn1 = ViewDistanceAsk(wid);
			 break;
		     case TOBJECT :
			 strn1 = AskObjectNames(wid);
			 break;
		     case TEYEPOS :
			 strn1 = EyePositionAsk(wid);
			 break;
		     default:
		         break;
	        }
		strn2 = WorldTreeAsk(wid,tree->sibling);
                if (strn2 == NULL) {
		    finalstrn = (char*) XGPmalloc(wid,strlen(strn1)+14);
		    (void) strcpy(finalstrn,"(Set World ");
		    (void) strcat(finalstrn,strn1);
		    (void) strcat(finalstrn,")");
		    (void) free(strn1);
		    return(finalstrn);
		}else {
		    temp = strlen(strn2);
		    finalstrn = (char*) XGPmalloc(wid,strlen(strn1)+temp+1);
                    strn2[temp-1] = ' ';
		    (void) strcpy(finalstrn,strn2);
		    (void) strcat(finalstrn,strn1);
		    (void) strcat(finalstrn,")");
		    (void) free(strn1);
		    (void) free(strn2);
		    return(finalstrn);
		}
	    } else {
		return(NULL);
	    }
        }

char* WorldNoTreeAsk(wid)
	GraphWidget  wid;
	{
	    char  *strn1,strn2[200],*foo;

	    strn1 = (char*) XGPmalloc(wid,sizeof(char)*16);
	    sprintf(strn1,"(Set World ");

	    foo = ModeAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = ViewportAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = OutputAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = FocusPositionAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = EyeDistanceAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = ViewDistanceAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);
	    foo = EyePositionAsk(wid);
	    addonend(&strn1,foo);
	    free(foo);

	    sprintf(strn2," )");
            addonend(&strn1,strn2);

	    return(strn1);

        }

char* WorldAsk(wid,tree)
	GraphWidget  wid;
	XGP_node    *tree;
	{
	  if (tree == NULL){
	     return(WorldNoTreeAsk(wid));
	  } else {
	     return(WorldTreeAsk(wid,tree));
	  }
        }

char* AxisAsk(wid,data)
	GraphWidget     wid;
	ReferenceStuff  data;
	{
	    char  *strn1,strn2[200];

	    /* this will get quit long but it is very simple       */
	    /* first will return auto adjust value (True or False) */

	    if (data.AutoAdjust == TTRUE) {
             strn1=(char*)XGPmalloc(wid,sizeof(char)*strlen("(AutoAdjust True) "));
	     sprintf(strn1,"(AutoAdjust True)");
	    } else {
             strn1=(char*)XGPmalloc(wid,sizeof(char)*strlen("(AutoAdjust False) "));
	     sprintf(strn1,"(AutoAdjust False)");
	    }

	    /* next we will do the line width for the axis */

	    if (data.XWidth == data.YWidth) {
	      sprintf(strn2,"(RLineWidth %3d)",data.XWidth);
	    } else {
	      sprintf(strn2,"(RLineWidthX %3d) (RLineWidthY %3d)"
		  ,data.XWidth,data.YWidth);
	    }
	    addonend(&strn1,strn2);
	    
	    /* make the output for the axis visibility */

	    if (data.Visible == XtInvisible) {
		sprintf(strn2,"(Visibility Invisible)");
	    } else {
		sprintf(strn2,"(Visibility Visible)");
	    }
	    addonend(&strn1,strn2);

	    /* make the output for the linestyle */
            switch (data.XStyle) {
		case TSOLID:
		   sprintf(strn2,"(RlineStyleX Solid)");
		   break;
		case TDASHED:
		   sprintf(strn2,"(RlineStyleX Dashed)");
		   break;
		case TDOUBLE :
		   sprintf(strn2,"(RlineStyleX Double)");
		   break;
		default :
		   break;
	    }
	    addonend(&strn1,strn2);

            switch (data.YStyle) {
		case TSOLID:
		   sprintf(strn2,"(RlineStyleY Solid)");
		   break;
		case TDASHED:
		   sprintf(strn2,"(RlineStyleY Dashed)");
		   break;
		case TDOUBLE :
		   sprintf(strn2,"(RlineStyleY Double)");
		   break;
		default :
		   break;
	    }
	    addonend(&strn1,strn2);

	    /* make output for the center of the axis system */

	    sprintf(strn2,"(Center %f %f)",data.XCenter,data.YCenter);
	    addonend(&strn1,strn2);

	    /* print the scale values */

	    sprintf(strn2,"(TickmarkXScale %f)(TickmarkYScale %f)",data.Xscale,
		    data.Yscale);
	    addonend(&strn1,strn2);

	    /* add the x and y tickmark ranges */

	    sprintf(strn2,"(TickmarkXRange %f %f)(TickmarkYRange %f %f)",
		data.TickXmin,data.TickXmax,data.TickYmin,data.TickYmax);
	    addonend(&strn1,strn2);
	    
	    /* add the x and y lable ranges */

	    sprintf(strn2,"(LabelXRange %f %f)(LabelYRange %f %f)",
		data.LabXmin,data.LabXmax,data.LabYmin,data.LabYmax);
	    addonend(&strn1,strn2);

	    /* add the precision stuff for the axis */
	    sprintf(strn2,"(LabelXPrecision %d %d)(LabelYPrecision %d %d)",
		data.XIntPre,data.XDecPre,data.YIntPre,data.YDecPre);
	    addonend(&strn1,strn2);

	    /* add the label Skip stuff */
	    sprintf(strn2,"(LabelXSkip %d)(LabelYSkip %d)",
		data.XLabelSkip,data.YLabelSkip);
	    addonend(&strn1,strn2);

	    /* add the  color stuff */
	    if (data.AxisColor != NULL) {
	        sprintf(strn2,"(Color %s)",data.AxisColor);
	    } else {
		sprintf(strn2,"(Color Default)");
            }
	    addonend(&strn1,strn2);

	    /* add the  color stuff Label */
	    if (data.LabelColor != NULL) {
	        sprintf(strn2,"(LabelColor %s)",data.LabelColor);
	    } else {
		sprintf(strn2,"(LabelColor Default)");
            }
	    addonend(&strn1,strn2);

	    /* add the  color stuff Tickmark*/
	    if (data.TickColor != NULL) {
	        sprintf(strn2,"(TickColor %s)",data.TickColor);
	    } else {
		sprintf(strn2,"(TickColor Default)");
            }
	    addonend(&strn1,strn2);

	    /* add the visibility of small stuff */
	    if (data.XLabelVisible == XtVisible){
	       sprintf(strn2,"(LabelXVisibility Visible)");
	    } else {
	       sprintf(strn2,"(LabelXVisibility Invisible)");
	    }    
	    addonend(&strn1,strn2);

	    if (data.YLabelVisible == XtVisible){
	       sprintf(strn2,"(LabelYVisibility Visible)");
	    } else {
	       sprintf(strn2,"(LabelYVisibility Invisible)");
	    }    
	    addonend(&strn1,strn2);

	    if (data.XTickVisible == XtVisible){
	       sprintf(strn2,"(TickmarkXVisibility Visible)");
	    } else {
	       sprintf(strn2,"(TickmarkXVisibility Invisible)");
	    }    
	    addonend(&strn1,strn2);

	    if (data.YTickVisible == XtVisible){
	       sprintf(strn2,"(TickmarkYVisibility Visible)");
	    } else {
	       sprintf(strn2,"(TickmarkYVisibility Invisible)");
	    }    
	    addonend(&strn1,strn2);

	    /* do the font stuff */
	    switch (data.XLabelFont){
	       case TREGULAR :
		  sprintf(strn2,"(LabelXFont Regular)");
		  break;
	       case TITALIC :
		  sprintf(strn2,"(LabelXFont Italic)");
		  break;
	       case TBOLD :
		  sprintf(strn2,"(LabelXFont Bold)");
		  break;
	       case TGREEK :
		  sprintf(strn2,"(LabelXFont Greek)");
		  break;
	    }
	    addonend(&strn1,strn2);

	    switch (data.YLabelFont){
	       case TREGULAR :
		  sprintf(strn2,"(LabelYFont Regular)");
		  break;
	       case TITALIC :
		  sprintf(strn2,"(LabelYFont Italic)");
		  break;
	       case TBOLD :
		  sprintf(strn2,"(LabelYFont Bold)");
		  break;
	       case TGREEK :
		  sprintf(strn2,"(LabelYFont Greek)");
		  break;
	    }
	    addonend(&strn1,strn2);

	    /* last and least add the Label Justify stuff */
	    switch (data.Xjustify) {
	       case UP :
		  sprintf(strn2,"(LabelXJustify Up)");
		  break;
	       case DOWN :
		  sprintf(strn2,"(LabelXJustify Down)");
		  break;
	       case CENTER :
		  sprintf(strn2,"(LabelXJustify Center)");
		  break;
	       case RIGHT :
		  sprintf(strn2,"(LabelXJustify Right)");
		  break;
	       case LEFT :
		  sprintf(strn2,"(LabelXJustify Left)");
		  break;
	    }
	    addonend(&strn1,strn2);

	    switch (data.Yjustify) {
	       case UP :
		  sprintf(strn2,"(LabelYJustify Up)");
		  break;
	       case DOWN :
		  sprintf(strn2,"(LabelYJustify Down)");
		  break;
	       case CENTER :
		  sprintf(strn2,"(LabelYJustify Center)");
		  break;
	       case RIGHT :
		  sprintf(strn2,"(LabelYJustify Right)");
		  break;
	       case LEFT :
		  sprintf(strn2,"(LabelYJustify Left)");
		  break;
	    }
	    addonend(&strn1,strn2);

	    return(strn1);
	}

char* ReferenceAsk(wid,data,name)
	GraphWidget     wid;
	ReferenceStuff  data;
	char            *name;
	{
	    char  *strn,*hold;

	    hold = (char*) AxisAsk(wid,data);
            strn = (char*) XGPmalloc(wid,sizeof(char)*(strlen(hold)+strlen(name)));
            sprintf(strn,"(Set %s ",name);
	    (void) strcat(strn,hold);
	    (void) strcat(strn,")");
	    (void) free(hold);
	    return(strn);
	}

char *Axis3DAsk(wid)
	GraphWidget  wid;
	{

	char  *strn1,strn2[200];
        d3axisdef  hold;

	hold = wid->graph.axis3d;
	strn1 = (char*) XGPmalloc(wid,sizeof(char)*12);
	sprintf(strn1,"(Set Axis3D");
	sprintf(strn2,"(Xaxis %f %f %f %f)",hold.xline.start,hold.xline.stop,
	    hold.xline.otherv1,hold.xline.otherv2);
	addonend(&strn1,strn2);

	sprintf(strn2,"(Yaxis %f %f %f %f)",hold.yline.start,hold.yline.stop,
	    hold.yline.otherv1,hold.yline.otherv2);
	addonend(&strn1,strn2);

	sprintf(strn2,"(Zaxis %f %f %f %f)",hold.zline.start,hold.zline.stop,
	    hold.zline.otherv1,hold.zline.otherv2);
	addonend(&strn1,strn2);

	if (hold.AxisColor != NULL) {
	    sprintf(strn2,"(Color %s)",hold.AxisColor);
	} else {
	   sprintf(strn2,"(Color Default)");
        }
	addonend(&strn1,strn2);

	if (hold.xline.visibility == XtVisible) {
	   sprintf(strn2,"(Visibility Visible)");
	} else {
	   sprintf(strn2,"(Visibility Invisible)");
	}
	addonend(&strn1,strn2);

	(void) strcat(strn1,")"); 
	return(strn1);
	}

char *VolumeBoxAsk(wid)
	GraphWidget  wid;
	{

	char  *strn1,strn2[200];
        D3Boxdef  hold;

	hold = wid->graph.viewbox;

	strn1 = (char*) XGPmalloc(wid,sizeof(char)*16);
	sprintf(strn1,"(Set VolumeBox ");

	sprintf(strn2,"(VolumeBoxCoordinates %f %f %f %f %f %f)",
	   hold.xmin,hold.ymin,hold.zmin,hold.xmax,hold.ymax,hold.zmax);
	addonend(&strn1,strn2);

	if (hold.AxisColor != NULL) {
	    sprintf(strn2,"(Color %s)",hold.AxisColor);
	} else {
	   sprintf(strn2,"(Color Default)");
        }
	addonend(&strn1,strn2);

	if (hold.visibility == XtVisible) {
	   sprintf(strn2,"(Visibility Visible)");
	} else {
	   sprintf(strn2,"(Visibility Invisible)");
	}
	addonend(&strn1,strn2);

	(void) strcat(strn1,")"); 
	return(strn1);
	}

char *OtherObjectAsk(wid,obj)
	GraphWidget  wid;
        XGPObject    *obj;	
	{
	char  *strn1,strn2[200];

	strn1 = (char*) XGPmalloc(wid,sizeof(char)*16);
	sprintf(strn1,"(LineWidth  %d)",obj->Other.linewidth);

	if (obj->Other.linestyle == TSOLID) {
	    sprintf(strn2,"(LineStyle Solid)");
	} else if (obj->Other.linestyle == TDASHED) {
	    sprintf(strn2,"(LineStyle Dashed)");
	}
	addonend(&strn1,strn2);

        if (obj->Other.dimension== T2D) {
	    sprintf(strn2,
	      "(Transformation Replace %f %f %f %f %f %f %f %f %f)",
	      obj->Other.transformation[0][0],
	      obj->Other.transformation[1][0],
	      obj->Other.transformation[2][0],
	      obj->Other.transformation[0][1],
	      obj->Other.transformation[1][1],
	      obj->Other.transformation[2][1],
	      obj->Other.transformation[0][2],
	      obj->Other.transformation[1][2],
	      obj->Other.transformation[2][2]);
	} else {
	    sprintf(strn2,
 "(Transformation Replace %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f %f)",
	      obj->Other.transformation[0][0],
	      obj->Other.transformation[1][0],
	      obj->Other.transformation[2][0],
	      obj->Other.transformation[3][0],
	      obj->Other.transformation[0][1],
	      obj->Other.transformation[1][1],
	      obj->Other.transformation[2][1],
	      obj->Other.transformation[3][1],
	      obj->Other.transformation[0][2],
	      obj->Other.transformation[1][2],
	      obj->Other.transformation[2][2],
	      obj->Other.transformation[3][2],
	      obj->Other.transformation[0][3],
	      obj->Other.transformation[1][3],
	      obj->Other.transformation[2][3],
	      obj->Other.transformation[3][3]);
	}
	addonend(&strn1,strn2);

	if (obj->Other.Hidden == XtVisible) {
	    sprintf(strn2,"(Visibility Visible)");
	} else if (obj->Other.Hidden == XtInvisible) {
	    sprintf(strn2,"(Visibility Invisible)");
	}
	addonend(&strn1,strn2);

	if (obj->Other.fgcolor != NULL) {
	    sprintf(strn2,"(Color %s)",obj->Other.fgcolor);
	    addonend(&strn1,strn2);
	}

	switch (obj->Other.fontstyle){
	    case TREGULAR :
	  sprintf(strn2,"(Font Regular)");
	  break;
        case TITALIC :
	  sprintf(strn2,"(Font Italic)");
	  break;
        case TBOLD :
	  sprintf(strn2,"(Font Bold)");
	  break;
        case TGREEK :
	  sprintf(strn2,"(Font Greek)");
	  break;
         }
         addonend(&strn1,strn2);

	return(strn1);
	}

char *CriticalObjectAsk(wid,obj)
	GraphWidget  wid;
        XGPObject    *obj;	
	{

	char  *strn1,strn2[200];
	Numlist   *points;
	SquareSurfaceStruct *kfp,*np;

	strn1 = (char*) XGPmalloc(wid,sizeof(char)*1);

	switch(obj->data.p_data.type) {
	    case Point : 
		if (obj->Other.dimension == T2D) {
		   sprintf(strn2,"(Point %f %f)",
		      obj->data.p_data.data.p_data.point.x,
		      obj->data.p_data.data.p_data.point.y);
		} else {
		   sprintf(strn2,"(Point3D %f %f %f)",
		      obj->data.p_data.data.p_data.point.x,
		      obj->data.p_data.data.p_data.point.y,
		      obj->data.p_data.data.p_data.point.z);
		}
                addonend(&strn1,strn2);
		break;
	    case Line : 
		if (obj->Other.dimension == T2D) {
		   sprintf(strn2,"(Line %f %f %f %f)",
		      obj->data.p_data.data.l_data.start_point.x,
		      obj->data.p_data.data.l_data.start_point.y,
		      obj->data.p_data.data.l_data.end_point.x,
		      obj->data.p_data.data.l_data.end_point.y);
		} else {
		   sprintf(strn2,"(Line3D %f %f %f %f %f %f)",
		      obj->data.p_data.data.l_data.start_point.x,
		      obj->data.p_data.data.l_data.start_point.y,
		      obj->data.p_data.data.l_data.start_point.z,
		      obj->data.p_data.data.l_data.end_point.x,
		      obj->data.p_data.data.l_data.end_point.y,
		      obj->data.p_data.data.l_data.end_point.z);
		}
                addonend(&strn1,strn2);
		break;
	    case Elipse : 
		if (obj->data.p_data.data.c_data.radius1 == 
		      obj->data.p_data.data.c_data.radius2) {
		    sprintf(strn2,"(Circle %f %f %f)",
			obj->data.p_data.data.c_data.center.x-
			obj->data.p_data.data.c_data.radius1/2,
			obj->data.p_data.data.c_data.center.y+
			obj->data.p_data.data.c_data.radius2/2,
			obj->data.p_data.data.c_data.radius1);
		} else {
		    sprintf(strn2,"(Ellipse %f %f %f %f)",
			obj->data.p_data.data.c_data.center.x-
			obj->data.p_data.data.c_data.radius1/2,
			obj->data.p_data.data.c_data.center.y+
			obj->data.p_data.data.c_data.radius2/2,
			obj->data.p_data.data.c_data.radius1,
			obj->data.p_data.data.c_data.radius2);
		}
                addonend(&strn1,strn2);
		break;
	    case Polygon : 
                if (obj->Other.dimension == T2D) {
		    sprintf(strn2,"(Polygon ");
                    addonend(&strn1,strn2);
		    points = obj->data.p_data.data.y_data.points;
		    while (NULL != points) {
			sprintf(strn2," %f %f ", points->x,points->y);
                        addonend(&strn1,strn2);
			points = points->next;
		    }
		} else {
		    sprintf(strn2,"(Polygon3D ");
                    addonend(&strn1,strn2);
		    points = obj->data.p_data.data.y_data.points;
		    while (NULL != points) {
		      sprintf(strn2," %f %f %f ",points->x,points->y,points->z);
                      addonend(&strn1,strn2);
		      points = points->next;
		    }
		}
		sprintf(strn2,")");
                addonend(&strn1,strn2);
		break;
	    case Polyline : 
                if (obj->Other.dimension == T2D) {
		    sprintf(strn2,"(Polyline ");
                    addonend(&strn1,strn2);
		    points = obj->data.p_data.data.pl_data.points;
		    while (NULL != points) {
			sprintf(strn2," %f %f ", points->x,points->y);
                        addonend(&strn1,strn2);
			points = points->next;
		    }
		} else {
		    sprintf(strn2,"(Polyline3D ");
                    addonend(&strn1,strn2);
		    points = obj->data.p_data.data.pl_data.points;
		    while (NULL != points) {
		      sprintf(strn2," %f %f %f ",points->x,points->y,points->z);
                      addonend(&strn1,strn2);
		      points = points->next;
		    }
		}
		sprintf(strn2,")");
                addonend(&strn1,strn2);
		break;
	    case Text : 
		if (obj->Other.dimension == T2D) {
		    sprintf(strn2,"(Text \"%s\" %f %f)", 
			obj->data.p_data.data.t_data.text,
			obj->data.p_data.data.t_data.point.x,
			obj->data.p_data.data.t_data.point.y);
		} else {
		    sprintf(strn2,"(Text3D \"%s\" %f %f %f)", 
			obj->data.p_data.data.t_data.text,
			obj->data.p_data.data.t_data.point.x,
			obj->data.p_data.data.t_data.point.y,
			obj->data.p_data.data.t_data.point.z);
		}
                addonend(&strn1,strn2);
		break;
	    case Surface : 
		    sprintf(strn2,"(Surface %d", 
		       obj->data.p_data.data.s_data.rows);
                    addonend(&strn1,strn2);
		    kfp = obj->data.p_data.data.s_data.data;
		    np = kfp->sp;
		    while(np != NULL) {
			while(kfp != NULL) {
			 sprintf(strn2," %f %f %f ",kfp->x,kfp->y,kfp->z);
                         addonend(&strn1,strn2);
			 kfp = kfp->fp;
			}
			kfp=np;
			np=kfp->sp;
		    }
		while(kfp != NULL) {
		 sprintf(strn2," %f %f %f ",kfp->x,kfp->y,kfp->z);
                 addonend(&strn1,strn2);
		 kfp = kfp->fp;
		}
		sprintf(strn2,")");
                addonend(&strn1,strn2);
		break;
	    default : 
		break;
	}

	return(strn1);
	}

char *BasicObjectAsk(wid,obj,name)
	GraphWidget  wid;
        XGPObject    *obj;	
	char         *name;
	{

	char  *strn1,strn2[200];
	char  *hold;

	strn1 = (char*) XGPmalloc(wid,sizeof(char)*16);
	sprintf(strn1,"(DrawPrimitive ");

        if (name[0] == ' ') {	
	    namemaker(name);
        }
        addonend(&strn1,name);
	    
        sprintf(strn2," ");
        addonend(&strn1,strn2);
	  
	hold = CriticalObjectAsk(wid,obj);
	addonend(&strn1,hold);
	free(hold);
	hold = OtherObjectAsk(wid,obj);
	addonend(&strn1,hold);
	free(hold);

	(void) strcat(strn1,")"); 

	return(strn1);
	}

char* ObjectAsk();

char *ComplexObjectAsk(wid,obj,name)
	GraphWidget  wid;
        XGPObject    *obj;	
	char         *name;
	{

	char  *strn1,strn2[200],*strn3,tname[30];
	char   *hold;
        ChildList   *children;

	strn1 = (char*) XGPmalloc(wid,1);
	strn3 = (char*) XGPmalloc(wid,1); 

	children = obj->data.c_data.children;
	while(children != NULL) {
	    sprintf(tname," ");
	    hold = ObjectAsk(wid,children->self,tname);
	    addonend(&strn1,hold);
	    free(hold);
	    sprintf(strn2," \n ");
            addonend(&strn1,strn2);
	    sprintf(strn2," ");
            addonend(&strn3,strn2);
            addonend(&strn3,tname);	    
	    children = children->siblings;
	}

	sprintf(strn2,"\n (Combine ");
        addonend(&strn1,strn2);

        if (name[0] == ' ') {	
	    namemaker(name);
        }
        addonend(&strn1,name);
	    
        addonend(&strn1,strn3);
        sprintf(strn2," )");
        addonend(&strn1,strn2);
        
	return(strn1);
	}

char *ObjectAsk(wid,obj,name)
	GraphWidget  wid;
        XGPObject    *obj;	
	char         *name;
	{
	switch (obj->type) {
	    case XGPPrimitive:
		return(BasicObjectAsk(wid,obj,name));
		break;
	    case XGPComplex :
		return(ComplexObjectAsk(wid,obj,name));
		break;
	    default:
		break;
	}
	}

char *AllAsk(wid)
	GraphWidget  wid;
	{
	   char  *strn1,strn2[20],*foo;
           XGPNameList   *list;

  
       strn1 = (char*) XGPmalloc(wid,8);
       foo=WorldNoTreeAsk(wid);
       addonend(&strn1,foo);
       free(foo);
       sprintf(strn2," \n ");
       addonend(&strn1,strn2);

       foo=ReferenceAsk(wid,wid->graph.axis[0],"Axis1");
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo=ReferenceAsk(wid,wid->graph.axis[1],"Axis2");
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo = ReferenceAsk(wid,wid->graph.grid,"Grid");
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo = ReferenceAsk(wid,wid->graph.horilin,"HorozontalReference");
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo = ReferenceAsk(wid,wid->graph.virtlin,"VerticalReference");
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo = Axis3DAsk(wid);
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);

       foo = VolumeBoxAsk(wid);
       addonend(&strn1,foo);
       free(foo);
       addonend(&strn1,strn2);
        
	   list = wid->graph.names;
	   while (list != NULL) {
	      foo = ObjectAsk(wid,list->object,list->object->aname->name);
	      addonend(&strn1,foo);
	      free(foo);
              addonend(&strn1,strn2);
	      list = list->next;
	   }

	   return(strn1);
	}

void Inquire(wid,tree)
	GraphWidget  wid;
	XGP_node    *tree;
	{
         static  char  *strn=NULL,hold;

	  if (tree->child[0]!= NULL ) {
	    if (strcmp(tree->child[0]->sval,"World") == 0) { 
		strn = WorldAsk(wid,tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"All") == 0) { 
		strn = AllAsk(wid);
	    } else if (strcmp(tree->child[0]->sval,"Axis1") == 0) { 
	       strn = ReferenceAsk(wid,wid->graph.axis[0],tree->child[0]->sval);
	    } else if (strcmp(tree->child[0]->sval,"Axis2") == 0) { 
	       strn = ReferenceAsk(wid,wid->graph.axis[1],tree->child[0]->sval);
	    } else if (strcmp(tree->child[0]->sval,"Grid") == 0) { 
		strn = ReferenceAsk(wid,wid->graph.grid,tree->child[0]->sval);
	    } else if (strcmp(tree->child[0]->sval,"HorozontalReference")==0) { 
	       strn = ReferenceAsk(wid,wid->graph.horilin,tree->child[0]->sval);
	    } else if (strcmp(tree->child[0]->sval,"VerticalReference")==0) { 
	       strn = ReferenceAsk(wid,wid->graph.virtlin,tree->child[0]->sval);
	    } else if (strcmp(tree->child[0]->sval,"Axis3D") == 0) { 
		strn = Axis3DAsk(wid);
	    } else if (strcmp(tree->child[0]->sval,"VolumeBox") == 0) {
		strn = VolumeBoxAsk(wid);
	    } else if (Existing_Name (tree->child[0]->sval)) {
		strn = ObjectAsk(wid,lookup(tree->child[0]->sval)->datafield,
			tree->child[0]->sval);
            } else {
	        error(wid,160,tree->child[0]->sval);
	    }
	    if (strn != NULL) {
	        XtCallCallbacks(wid,XtNresponse,strn);
	    }
	  }
	}
