#include <stdio.h>
#include <math.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

OutputParam* CreateOutputParameters(wid)
	GraphWidget   wid;
	{
	OutputParam      *temp;

	temp = (OutputParam*) XGPmalloc(wid,sizeof(OutputParam));
	    temp->Units = TINCH;
	    temp->dpi = 300;
	    temp->otype = TLASERJET;
	    temp->height = 2.0;
	    temp->width = 2.0;
	    temp->path = NULL;
	    temp->depth = 4;
	return(temp);
	}

void findWandH(param,width,height)
	OutputParam     *param;
	short             *width,*height;
{	
	    switch (param->Units) {
	      case TCENT :
	          *height = (short) param->height * cm_to_inch * param->dpi;
		  *width = (short) param->width * cm_to_inch * param->dpi;
	          break;
	      case TINCH :
	      default :
	          *height = (short) param->height * param->dpi;
		  *width = (short) param->width * param->dpi;
	          break;
           }
}


void MakeNewPixmap(widget,param)
	GraphWidget    widget;
	OutputParam    *param;

    {
	unsigned int    wid,hei;

	findWandH(param,&wid,&hei);
	widget->core.background_pixmap
		=XCreatePixmap(XtDisplay(widget),XtWindow(widget)
		,wid,hei,XDefaultDepthOfScreen(XtScreen(widget)));
	widget->core.height = (Dimension) hei;
	widget->core.width = (Dimension) wid;
     }

void texoutput(wid,param)
	GraphWidget     wid;
	OutputParam     *param;

	{
	 FILE    *fp;
	 short   height,width;
	 char    bar;	
	 XImage  *img;
	 int     l,w,b,temp;

	MakeNewPixmap(wid,param);
	redisplay_picture(wid);
	    if (param->path == NULL ) {
	       error(wid,250,NULL);
	       fp = stdout;
	    } else {
	       fp = (FILE*)openwfile(param->path);
	    } /* if */
	    findWandH(param,&width,&height);
	    fwrite(&height,sizeof(height),1,fp);
	    bar = 0;
	    fwrite(&bar,1,1,fp);
            bar = (char) ceil((double) width/8);
	    fwrite(&bar,1,1,fp);
	    img = XGetImage(XtDisplay(wid),wid->core.background_pixmap,
	       0,0,(unsigned int) width,(unsigned int) height,
	       AllPlanes,ZPixmap);
	       for (l=0;l<height;l++) {
	       for (w=0;w<width;w = w + 8) {
		  temp = 0;
	          for (b=0;b < 8;b++) {
		     if (w+b < width) {
		       if (XGetPixel(img,w+b,l)!=wid->graph.background) {
	                  temp = temp*2 + 1;
		       } else {
			 temp = temp * 2;
		       }
		     } else {			  /* if */
                          temp = temp*2;
		     } 				  /* if */
		  } 				  /* for b */
	       bar = (char) temp;
	       fwrite(&bar,1,1,fp);
	       }                                  /* for w*/
	    }                                     /* for l */	
	    (void) XDestroyImage(img);
	    if (fp != stdout) {
	       closefile(fp);
	    }					 /* if */
	} 					/* routine */


void laserjetoptioins(wid,param)
	GraphWidget     wid;
	OutputParam     *param;
	{
	    if (param->depth != 1) {
		error(wid,510,NULL);
	    }
                if (param->dpi <80) {
		    param->dpi = 75;
	        } else { if (param->dpi<125) {
		    param->dpi = 100;
		} else { if (param->dpi<225) {
		    param->dpi = 150;
		} else {
		    param->dpi = 300;
		}}}
	}

void laserjetoutput(wid,param)
	GraphWidget     wid;
	OutputParam     *param;

	{
	 FILE    *fp;
	 short   height,width;
	 char    bar;	
	 XImage  *img;
	 int     l,w,b,temp;

            laserjetoptioins(wid,param);
	    MakeNewPixmap(wid,param);
	    redisplay_picture(wid);
	    if (param->path == NULL ) {
	       error(wid,250,NULL);
	       fp = stdout;
	    } else {
	       fp = (FILE*)openwfile(param->path);
	    } /* if */
	    findWandH(param,&width,&height);
	    /* set up for graphics output */
	    fprintf(fp,"%c*t%dR",ESC,param->dpi);  /* set up resolution */
	    fprintf(fp,"%c*r0A",ESC);              /* set up start position */
	    img = XGetImage(XtDisplay(wid),wid->core.background_pixmap,
	       0,0,(unsigned int) width,(unsigned int) height,
	       AllPlanes,ZPixmap);
	       for (l=0;l<height;l++) {
	       fprintf(fp,"%c*b%dW",ESC,width/8);  /* tell # bytes per line */
	       for (w=0;w<width;w = w + 8) {
		  temp = 0;
	          for (b=0;b < 8;b++) {
		     if (w+b < width) {
		       if (XGetPixel(img,w+b,l)!= wid->graph.background) {
	                  temp = temp*2 +1;
		       } else {
		 	  temp = temp * 2;
		       }
		     } else {			  /* if */
                          temp = temp*2;
		     }
		  } 				  /* for b */
	          bar = (char) temp;
	          fwrite(&bar,1,1,fp);
	       }                                  /* for w*/
	    }                                     /* for l */	
	    fprintf(fp,"%c*rB",ESC);     /* the end of graphics output */
	    (void) XDestroyImage(img);
	    if (fp != stdout) {
	       closefile(fp);
	    }					 /* if */
	} 					/* routine */

void paintjetoutput(wid,param)
	GraphWidget     wid;
	OutputParam     *param;

	{
	 FILE    *fp;
	 short   height,width;
	 char    bar;	
	 XImage  *img;
	 int     l,w,b,m,temp,FLAG;
         XColor  exact;
            
	    MakeNewPixmap(wid,param);
	    redisplay_picture(wid);
	    if (param->path == NULL ) {
	       error(wid,250,NULL);
	       fp = stdout;
	    } else {
	       fp = (FILE*)openwfile(param->path);
	    } /* if */
	    findWandH(param,&width,&height);
	    /* set up the color table */
	    fprintf(fp,"%c*r%dS",ESC,width);   /* tell this thing width */
	    fprintf(fp,"%c*t%dR",ESC,param->dpi);   /* set up DPI */
	    fprintf(fp,"%c*r4U",ESC);               /* set up Depth */
            for (l=0;l<16;l++) {
	      exact.pixel = (long) l;
	      XQueryColor(XtDisplay(wid),wid->core.colormap,&exact);	
	      fprintf(fp,"%c*v%dA",ESC,(int)((float)exact.red/65535*86+4));
	      fprintf(fp,"%c*v%dB",ESC,(int)((float)exact.green/65535*84+4));
	      fprintf(fp,"%c*v%dC",ESC,(int)((float)exact.blue/65535*79+6));
	      fprintf(fp,"%c*v%dI",ESC,l);
	    }
	    /* set up for graphics output */
	    fprintf(fp,"%c*r0A",ESC);
	    img = XGetImage(XtDisplay(wid),wid->core.background_pixmap,
	       0,0,(unsigned int) width,(unsigned int) height,
	       AllPlanes,ZPixmap);
	       for (l=0;l<height;l++) {
		 for(m=0;m<4;m++){
		    if(m!=3) {
	               fprintf(fp,"%c*b%dV",ESC,width/8);
		    } else {
	               fprintf(fp,"%c*b%dW",ESC,width/8);
                    }
	            for (w=0;w<width;w = w + 8) {
	     	       temp = 0;
	               for (b=0;b < 8;b++) {
		          if (w+b < width) {
	                       temp = temp*2 +
				(int)((XGetPixel(img,w+b,l)>>m)&1);
		          } else {			  /* if */
                              temp = temp*2;
			  }
		       } 				  /* for b */
	               bar = (char) temp;
	               fwrite(&bar,1,1,fp);
	           }                                  /* for w*/
		 }
	       }                                     /* for l */	
	    fprintf(fp,"%c*r1B",ESC);
	    (void) XDestroyImage(img);
	    if (fp != stdout) {
	       closefile(fp);
	    }					 /* if */
	} 					/* routine */


void OutputPicture(wid,param)
	GraphWidget     wid;
	OutputParam     *param;

	{
	   switch (param->otype) {
	        case TTEXSPEC :
		   texoutput(wid,param);
		   break;
		case TPAINTJET :
		   paintjetoutput(wid,param);
		   break;
		case TLASERJET :
		   laserjetoutput(wid,param);
		   break;
	        default :
		   break;
		}
	}
		
void XPixmapOut(wid)
	GraphWidget    wid;
	{
	  Dimension hwidth,hheight;

/* save some vital info and make room for a new pixmap */

	XFreePixmap(XtDisplay(wid),wid->core.background_pixmap);
	hheight = wid->core.height;
	hwidth = wid->core.width;

/* call the proper output command */

	OutputPicture(wid,wid->graph.HardCopyStuff);

/* destroy the pixmap  recreate the basic on and restore the backup  */

	XFreePixmap(XtDisplay(wid),wid->core.background_pixmap);
	wid->core.height = hheight;
	wid->core.width = hwidth;
       wid->core.background_pixmap = XCreatePixmap(XtDisplay(wid),XtWindow(wid),
                       wid->core.width,wid->core.height,
                       XDefaultDepthOfScreen(XtScreen(wid)));
	}

