#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

extern float XGPPixelsPerUnitX();
extern float XGPPixelsPerUnitY();
extern float return_float_point();
extern int   return_int_point();
extern int   return_visibility();
extern int   return_justify();

#include "GraphAxis.h"


extern float biggest();
extern float smallest();

#define LargeTickmarkSize    8 
#define SmallTickmarkSize    4
#define string_max           20

void word_put(wid,fid,wx,wy,num,displace,count)
       GraphWidget   wid;
       param         *fid;
       float         wx, wy;
       float         num;
       float         displace;
       int           *count;

       {
        char        *word;
        Position       x,y;

        if ((fid->lab == TRUE) && (num != 0)){
         if (*count >= fid->labskip) {
          *count = 0;
          word = (char*) XGPmalloc(wid,string_max*sizeof(char));

          (void) sprintf(word,"%*.*f",fid->labipre,fid->labdpre,num);

	   if (fid->LC != NULL) {
	       XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		   MakeColor(wid,fid->LC));
	   }
           if (fid->labfont != TREGULAR) {
             change_font(wid,fid->labfont);
           }
           switch (fid->labjust) {
             case RIGHT :
                 world_to_device(wid,wx+displace,wy,&x,&y);
                 put_word(wid,x+4,y,CENTER,RIGHT,word,fid->labfont);
                 break;
             case LEFT :
                 world_to_device(wid,wx-displace,wy,&x,&y);
                 put_word(wid,x-4,y,CENTER,LEFT,word,fid->labfont);
                 break;
             case CENTER :
                 world_to_device(wid,wx,wy,&x,&y);
                 put_word(wid,x,y,CENTER,CENTER,word,fid->labfont);
                 break;
             case UP :
                 world_to_device(wid,wx-displace,wy,&x,&y);
                 put_word(wid,x,y-13,CENTER,CENTER,word,fid->labfont);
                 break;
             case DOWN :
                 world_to_device(wid,wx-displace,wy,&x,&y);
                 put_word(wid,x,y+10,CENTER,CENTER,word,fid->labfont);
                 break;
             default : break;
          }
         if (fid->labfont != TREGULAR) {
             change_font(wid,TREGULAR);
         }

/* put the color back */

	if (fid->TC != NULL) {
	    XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		MakeColor(wid,fid->TC));
	}else {
	    if (fid->AC != NULL) {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
    		    MakeColor(wid,fid->AC));
	    } else {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
	               wid->graph.foreground);
	    }
	}
/* free the memmory that the word was put in */
	 (void) free(word);
      } else {
        *count = *count + 1;
      }
     } /* if visibile = true */
 }

void hortick(wid,fid,ltick)
	GraphWidget     wid;
	param           *fid;
	int             ltick;

	{
            float  ppu,     /* the number of pixels per unit in the x dir */
		   symin,   /* start for small x tickmarks                */
		   symax,   /* stop for small y tickmarks                 */
		   lymin,   /* start for large y tickmarks                */
		   lymax,   /* stop for large y tickmarks                 */
		   temp1,   /* 1/2 length of short tickmarks              */ 
                   temp2,   /* work field for intermediate calculations   */
		   foo,bar, /* a patch 3/90 */
		   cx,      /* the current y position (of the tickmark)   */
		   textr,   /* temporary extreme point                    */
		   xmin,    /* the lowest tickmark allowed                */
		   xmax;    /* the largest tickmark position allowed      */
	    int    big,     /* the number of ticks skipped since last big */
                   labcnt,
                   st,lt;

	    if (ltick != Default) {

	        temp1 = 0;
		temp2 = 0;
		foo=0;bar=0;
		symin = wid->graph.graphYMin;
		lymin = wid->graph.graphYMin;
		symax = wid->graph.graphYMax;
		lymax = wid->graph.graphYMax;

	    } else {

	        ppu = XGPPixelsPerUnitY(wid);
	        temp1 = ((fid->width+SmallTickmarkSize)/(float) (2*ppu));
	        symin = fid->loc - temp1;
	        symax = fid->loc + temp1;
		temp2 = ((fid->width+LargeTickmarkSize)/(float) (2*ppu));
		lymin = fid->loc - temp2;
		lymax = fid->loc + temp2;
		ppu = XGPPixelsPerUnitX(wid);
		foo = ((fid->width+SmallTickmarkSize)/(float) (2*ppu));
		bar = ((fid->width+LargeTickmarkSize)/(float) (2*ppu));
            }
	if (fid->TC != NULL) {
	    XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		MakeColor(wid,fid->TC));
	}
	    textr = smallest(fid->tickmin,fid->labmin);
	    xmin = biggest(wid->graph.graphXMin,textr);
	    textr = biggest(fid->tickmax,fid->labmax);
	    xmax = smallest(wid->graph.graphXMax,textr);
            big = -1;
            labcnt = 0;

	    for (cx = fid->cent;cx<=xmax;cx=cx+fid->tickscal) {
		if (big >= fid->tickskip) {
                   big = 0;
		   if (fid->labmax >= cx) {
		       word_put(wid,fid,cx,lymax,cx,bar,&labcnt);
		   }
		   if ((fid->tick == TRUE)&& (fid->tickmax >= cx)) {
		     drawline(wid,cx,lymin,cx,lymax);
		   }
		} else {
		   big = big + 1;
		   if (fid->labmax >= cx) {
                       word_put(wid,fid,cx,symax,cx,foo,&labcnt);
		   }
		   if ((fid->tick == TRUE) && (fid->tickmax >= cx)) {
		     drawline(wid,cx,symin,cx,symax);
		   }
		}
	    }

            big = 0;
            labcnt = 0;
            for (cx=fid->cent-fid->tickscal;cx>=xmin;cx=cx-fid->tickscal) {
                if (big >= fid->tickskip) {
                   big = 0;
		   if ((fid->tick == TRUE) && (fid->tickmin <= cx)) {
                       drawline(wid,cx,lymin,cx,lymax);
		   }
		   if ((fid->labmin <= cx)) {
                       word_put(wid,fid,cx,lymax,cx,bar,&labcnt);
		   }
                } else {
                   big = big + 1;
		   if ((fid->tick == TRUE) && (fid->tickmin <= cx)) {
                     drawline(wid,cx,symin,cx,symax);
		   }
		   if ((fid->labmin <= cx)) {
                       word_put(wid,fid,cx,symax,cx,foo,&labcnt);
		   }
                }
            }
	    if (fid->AC != NULL) {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
    		    MakeColor(wid,fid->AC));
	    } else {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
	               wid->graph.foreground);
	    }

	}


void virttick(wid,fid,ltick)
	GraphWidget     wid;
	param           *fid;
	int             ltick;
	{
            float  ppu,     /* the number of pixels per unit in the x dir */
		   sxmin,   /* start for small x tickmarks                */
		   sxmax,   /* stop for small x tickmarks                 */
		   lxmin,   /* start for large x tickmarks                */
		   lxmax,   /* stop for large x tickmarks                 */
		   temp1,   /* 1/2 length of short tickmarks              */ 
                   temp2,   /* work field for intermediate calculations   */
		   foo,bar, /* a patch 3/90 */
		   cy,      /* the current y position (of the tickmark)   */
		   textr,   /* temporary extreem point for max or min     */
		   ymin,    /* the lowest tickmark allowed                */
		   ymax;    /* the largest tickmark position allowed      */
	    int    big,     /* the number of ticks skipped since last big */
                   labcnt,
		   st,lt;

            if (ltick == Default) {

		ppu = XGPPixelsPerUnitX(wid);
		temp1 = ((fid->width+SmallTickmarkSize)/(float) (2*ppu));
		sxmin = fid->loc - temp1;
		sxmax = fid->loc + temp1;
		temp2 = ((fid->width+LargeTickmarkSize)/(float) (2*ppu));
		lxmin = fid->loc - temp2;
		lxmax = fid->loc + temp2;
		ppu = XGPPixelsPerUnitX(wid);
		foo = ((fid->width+SmallTickmarkSize)/(float) (2*ppu));
		bar = ((fid->width+LargeTickmarkSize)/(float) (2*ppu));

	    } else {
		temp1 = 0;
		temp2 = 0;
		foo =0 ;bar=0;
		sxmin = wid->graph.graphXMin;
		lxmin = wid->graph.graphXMin;
		lxmax = wid->graph.graphXMax;
		sxmax = wid->graph.graphXMax;
	    }
	if (fid->TC != NULL) {
	    XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		 MakeColor(wid,fid->TC));
	}

	    textr = smallest (fid->tickmin,fid->labmin);
	    ymin = biggest(wid->graph.graphYMin,textr);
	    textr = biggest(fid->tickmax,fid->labmax);
	    ymax = smallest(wid->graph.graphYMax,textr);
            big = -1;
            labcnt = 0;
 
	    for (cy = fid->cent;cy<=ymax;cy=cy+fid->tickscal) {
		if (big >= fid->tickskip) {
                   big = 0;
        	   if (fid->labmax >= cy) {
		       word_put(wid,fid,lxmax,cy,cy,bar,&labcnt);
		   }
		   if ((fid->tick == TRUE) && (fid->tickmax >= cy)) {
		     drawline(wid,lxmin,cy,lxmax,cy);
		   }
		} else {
		   big = big + 1;
		   if (fid->labmax >= cy) {
                       word_put(wid,fid,sxmax,cy,cy,foo,&labcnt);
		   }
		   if ((fid->tick == TRUE)  && (fid->tickmax >= cy)){
		     drawline(wid,sxmin,cy,sxmax,cy);
		   }
		}
	    }

            big = 0;
            labcnt = 0;

            for (cy=fid->cent-fid->tickscal;cy>=ymin;cy=cy-fid->tickscal) {
                if (big >= fid->tickskip) {
                   big = 0;
		   if ((fid->tick == TRUE) && (fid->tickmin <= cy)) {
                     drawline(wid,lxmin,cy,lxmax,cy);
		   }
		   if (fid->labmin <= cy) {
                       word_put(wid,fid,lxmax,cy,cy,bar,&labcnt);
		   }
                } else {
                   big = big + 1;
		   if ((fid->tick == TRUE) && (fid->tickmin <= cy)) {
                     drawline(wid,sxmin,cy,sxmax,cy);
		   }
		   if (fid->labmin <= cy) {
                       word_put(wid,fid,sxmax,cy,cy,foo,&labcnt);
		   }
                }
            }
	    if (fid->AC != NULL) {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
    		    MakeColor(wid,fid->AC));
	    } else {
	        XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
	               wid->graph.foreground);
	    }

	}

/*********************************************************************/
/*  Procedure drawReferenceLine                                      */
/*  Programmer Dan Bennett      11/7/89                              */
/*								     */
/*  This procedure will draw a reference line and call the right     */
/*   sub procedures to add tickmarks and labels as needed            */
/* The input to the procedure is the Graph Widget and a special      */
/* structure to contain all of the parameters needed to controll the */
/* lines to the degree required                                      */
/*********************************************************************/

void drawReferenceLine(wid,fid,lt)
	GraphWidget     wid;
	param           *fid; /* see the data structure at the top */
        int             lt;	
{
   int       wflag = FALSE;  /*width flag true if width is changed    */

	if ((fid->width > 1) || (fid->style != TSOLID)) {
	    Change_Line_Style(wid,fid->width,fid->style);
	    wflag = TRUE;
	}
	if (fid->AC != NULL) {
	    XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		 MakeColor(wid,fid->AC));
	}
	if (fid->dir == HOROZONTAL ) {
	    drawline(wid,wid->graph.graphXMin,
		    fid->loc,wid->graph.graphXMax,fid->loc);
	    if ((wflag == TRUE)&& (lt == Default)) {
		Change_Line_Style(wid,0,TSOLID);
		wflag = FALSE;
	    }
            if ((fid->tick == TRUE) || (fid->lab == TRUE)){
	       hortick(wid,fid,lt);
	    }
	    if (wflag == TRUE) {
		Change_Line_Style(wid,0,TSOLID);
		wflag=FALSE;
	    }
	} else {
	    drawline(wid,fid->loc,wid->graph.graphYMin,
		    fid->loc,wid->graph.graphYMax);
	    if ((wflag == TRUE) && (lt == Default)) {
                Change_Line_Style(wid,0,TSOLID);
		wflag = FALSE;
            }
	    if ((fid->tick == TRUE) || (fid->lab == TRUE)) {
		virttick(wid,fid,lt);
	    }
            if (wflag == TRUE) {
                Change_Line_Style(wid,0,TSOLID);
                wflag=FALSE;
            }
	}
	if (fid->AC != NULL) {
	    XSetForeground(XtDisplay(wid),wid->graph.XGPgc,
		 wid->graph.foreground);
        }
}

void assignLabel(wid,data,tree)
	GraphWidget  wid;
	ReferenceStuff *data;
	XGP_node       *tree;
        {
	switch (tree->node_type) {
	    case TLABXVIS:
		data->XLabelVisible = 
		      return_visibility(tree->child[0]->node_type);
		break;
	    case TLABYVIS:
		data->YLabelVisible =
		      return_visibility(tree->child[0]->node_type);
		break;
	    case TLABXFONT:
		data->XLabelFont = tree->child[0]->node_type;
		break;
	    case TLABYFONT:
		data->YLabelFont = tree->child[0]->node_type;
		break;
	    case TLABXPRE:
		data->XIntPre = return_int_point(tree->child[0]);
		data->XDecPre = return_int_point(tree->child[1]);
		break;
	    case TLABYPRE:
                data->YIntPre = return_int_point(tree->child[0]);
                data->YDecPre = return_int_point(tree->child[1]);
		break;
	    case TLABXSKIP:
		data->XLabelSkip = return_int_point(tree->child[0]);
		break;
	    case TLABYSKIP:
                data->YLabelSkip = return_int_point(tree->child[0]);
		break;
	    case TLABXJUST:
                data->Xjustify = return_justify(tree->child[0]->node_type);
		break;
	    case TLABYJUST:
                data->Yjustify = return_justify(tree->child[0]->node_type);
		break;
	    case TLABXRANGE:
		data->LabXmin = return_float_point(tree->child[0]);
		data->LabXmax = return_float_point(tree->child[1]);
		break;
	    case TLABYRANGE:
                data->LabYmin = return_float_point(tree->child[0]);
                data->LabYmax = return_float_point(tree->child[1]);
		break;
	    case TLABCOLOR:
		AssignColorField(wid,tree->child[0]->sval,&data->LabelColor);
		break;
	    default :
		break;
	} /* switch */
	}

void assignTick(wid,data,tree)
	GraphWidget wid;
        ReferenceStuff *data;
	XGP_node    *tree;
	{
	switch (tree->node_type) {
	    case TTICKXVIS:
                data->XTickVisible =
                      return_visibility(tree->child[0]->node_type);
		break;
	    case TTICKYVIS:
                data->YTickVisible =
                      return_visibility(tree->child[0]->node_type);
		break;
	    case TTICKXSCALE:
                data->Xscale = return_float_point(tree->child[0]);
		break;
	    case TTICKYSCALE:
                data->Yscale = return_float_point(tree->child[0]);
		break;
	    case TTICKXRANGE:
                data->TickXmin = return_float_point(tree->child[0]);
                data->TickXmax = return_float_point(tree->child[1]);
		break;
	    case TTICKYRANGE:
                data->TickYmin = return_float_point(tree->child[0]);
                data->TickYmax = return_float_point(tree->child[1]);
		break;
	    case TTICCOLOR:
		AssignColorField(wid,tree->child[0]->sval,&data->TickColor);
		break;
	    default:
		break;
	} /* switch */
        }

void AssignRefAttrib(wid,data,tree)
	GraphWidget     wid;
	ReferenceStuff *data;
	XGP_node    *tree;

	{

	if (tree == NULL) {
	   redisplay_picture(wid);
	} else {
	    switch (tree->node_type) {
		case TVISIBILITY :
		   data->Visible = return_visibility(tree->child[0]->node_type);
		   break;
	        case TAUTOADJ :
		   data->AutoAdjust = tree->child[0]->node_type;
		   break;
		case TXWIDTH :
		   data->XWidth = return_int_point(tree->child[0]);
		   break;
		case TYWIDTH :
		   data->YWidth = return_int_point(tree->child[0]);
		   break;
		case TRXSTYLE :
		   data->XStyle = tree->child[0]->node_type;
		   break;
		case TRYSTYLE :
		   data->YStyle = tree->child[0]->node_type;
		   break;
                case TCENTER :
                   data->XCenter = return_float_point(tree->child[0]);
                   data->YCenter = return_float_point(tree->child[1]);
                   break;
	        case TCOLOR:
		   AssignColorField(wid,tree->child[0]->sval,&data->AxisColor);
		   break;
		default :
		   assignLabel(wid,data,tree);
		   assignTick(wid,data,tree);
		   break;
                } /* switch */
                AssignRefAttrib(wid,data,tree->sibling);
	    } /* else */
	}

