#include <X11/IntrinsicP.h>
#include <X11/StringDefs.h>
#include <stdio.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"


/*************************************************************************/
/* Procedure returnfontid						 */
/* Programmer Dan Bennett 9/89						 */
/*									 */
/* returnfontid is a kluge It is not good.  It relies on the font        */
/* structure being a certin way.  This works wil x11 r3 and I hope with  */
/* other versioins.  If not I'll bet someone other than me has to fix it */
/* I wish you luck    Dan   9/28/89                                      */
/*************************************************************************/

Font   returnfontid(fontpointer)
	XFontStruct *fontpointer;

	{
	   return(fontpointer->fid);
	}

/*************************************************************************/
/* Procedure put_word                                      		 */
/* Programmer Dan Bennett   9/89					 */
/*									 */
/* This procedure will put the text stored in word on the screen at      */
/* location x,y x and y are pixel values.  Justify directs where the     */
/* base line is for that text.  The values are  			 */
/*    Up which should make the bottom of the text line up with x, y      */
/*    Center which should center the text at x, y                        */
/*    Down which should make x,y the upper left corner for the text      */
/* direct determines which way the text flows from x, y                  */
/*    Right is normal English style                             	 */
/*    Center centers the text with respect to x,y                        */
/*    Left makes the text end at x,y       				 */
/* fontid is the name of the font to use  (Regular Italic Bold Greek     */
/*************************************************************************/

void put_word(wid,x,y,justify,drect,word,fontid)
        GraphWidget  wid;
        Position     x,y;
        int          justify,drect;
        char         *word;
	int          fontid;

       {
        int         direction, ascent, decent;
        XCharStruct *overall;
        Position    nx,ny;

        nx = x;
        ny = y;
        overall = (XCharStruct*) XGPmalloc(wid,sizeof(XCharStruct));
	switch (fontid) {
	    case TGREEK :
	       XTextExtents(wid->graph.greekfont,word,
	       strlen(word),&direction,&ascent,&decent,overall);
	       break;
            case TBOLD :
               XTextExtents(wid->graph.boldfont,word,
               strlen(word),&direction,&ascent,&decent,overall);
               break;
            case TITALIC :
               XTextExtents(wid->graph.italicfont,word,
               strlen(word),&direction,&ascent,&decent,overall);
               break;
            case TREGULAR :
               XTextExtents(wid->graph.normalfont,word,
               strlen(word),&direction,&ascent,&decent,overall);
               break;
	    default : break;
        }
        switch (justify) {
           case UP :
              ny = ny - ascent - 2;
              break;
           case CENTER :
              ny = ny + (ascent + decent) / 2;
              break;
           case DOWN :
              ny = ny + decent+2;
              break;
           defalut : break;
        }
        switch (drect) {
           case RIGHT :
              nx = nx + 1;
              break;
           case LEFT :
              nx = nx - overall->width;
              break;
           case CENTER :
              nx = nx - (overall->width/2);
              break;
           default : break;
        }
        XDrawString(XtDisplay(wid),wid->core.background_pixmap,
            wid->graph.XGPgc,nx,ny,word,strlen(word));
	(void) free(overall);
}

/*************************************************************************/
/* Procedure change_font						 */
/* Programmer Dan Bennett   9/89					 */
/*									 */
/* This procedure will change the current font used by the GC to draw    */
/* with.  wid is the widget id and fid is the font id (Regular Italic    */
/* Bold Greek) 								 */
/*************************************************************************/

void change_font (wid,fid)
	GraphWidget     wid;
	int             fid;

	{
	   switch (fid) {
		case TREGULAR :
		    XSetFont(XtDisplay(wid),wid->graph.XGPgc,
			  returnfontid(wid->graph.normalfont));
		    break;
		case TITALIC :
		    XSetFont(XtDisplay(wid),wid->graph.XGPgc,  
			  returnfontid(wid->graph.italicfont));
		    break;
		case TBOLD :
		    XSetFont(XtDisplay(wid),wid->graph.XGPgc,
			  returnfontid(wid->graph.boldfont));
		    break;
		case TGREEK :
		    XSetFont(XtDisplay(wid),wid->graph.XGPgc,
			  returnfontid(wid->graph.greekfont));
		    break;
		defalut : break;
	 }
     }

/*************************************************************************/
/* Procedure XGPLoadFont                                                 */
/* Programmer Dan Bennett 9/89                                           */
/*									 */
/* This procedure will load a font into the font space specified.  Wid   */
/* is the widget id, name is the name of the font to be loaded and       */
/* fid is the slot into which the font will be loaded.  The procedure    */
/* checks for valid font names and if the name is valid the font is      */
/* loaded.                                                               */
/*************************************************************************/

void XGPLoadFont(wid,name,fid)
	GraphWidget   wid;
	char          *name;
	int           fid;

	{
	   int numb;

	   XListFonts(XtDisplay(wid),name,1,&numb);
	   if (numb > 0) {
	      switch (fid) {
		  case TREGULAR :
		      wid->graph.normalfont = XLoadQueryFont(XtDisplay(wid),
			    name);
		      break;
		  case TGREEK :
		      wid->graph.greekfont = XLoadQueryFont(XtDisplay(wid),
			    name);
			    break;
		  case TBOLD :
		      wid->graph.boldfont = XLoadQueryFont(XtDisplay(wid),
			    name);
			    break;
		  case TITALIC :
		      wid->graph.italicfont = XLoadQueryFont(XtDisplay(wid),
			    name);
			    break;
		  defalut : break;
	      }
	   } else {
	      error (wid,230,name);
	   }
	}
