#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"
#include <math.h>

float biggest(a,b)
      float a,b;
       {
	   if (a>b) {
	      return(a);
	   } else {
	      return(b);
	   }
	}

float smallest(a,b)
      float a,b;
      {
	  if (a<b) {
	      return(a);
	  } else {
	      return(b);
	  }
      }


void newmaxmin(wid,x,y)
	GraphWidget    wid;
	float          x,y;

	{
	   if (wid->graph.twoDvaluesFlag == FALSE) {
	       wid->graph.twoDxmax = x;
	       wid->graph.twoDymax = y;
	       wid->graph.twoDxmin = x;
	       wid->graph.twoDymin = y;
	       wid->graph.twoDvaluesFlag = TRUE;
	   } else {
	       wid->graph.twoDxmax = biggest(wid->graph.twoDxmax,x);
	       wid->graph.twoDymax = biggest(wid->graph.twoDymax,y);
	       wid->graph.twoDxmin = smallest(wid->graph.twoDxmin,x);
	       wid->graph.twoDymin = smallest(wid->graph.twoDymin,y);
	   }
	}

/********************************************************************/
/* August 1989          Dan Bennett                                 */
/* This procedure will return a float when given a number node.     */
/* (a number node holds a float or an integer  )                     */
/********************************************************************/

float return_float_point(node)
      XGP_node    *node;

    {
      if(node->node_type == TICONST ){
	   return( (float) node->ival);
      }else{
	   return( (float) node->fval);
      }
    }

int return_int_point(node)
      XGP_node    *node;

      {
          if(node->node_type == TICONST ){
             return( (int) node->ival);
          }else{
             return( (int) node->fval);
          }
      }

int DeTreePoint(tree,point)
	XGP_node  *tree;
	XtXGPPointStruct *point;
	{
	      if(tree->node_type == TPOINT3D){
	          point->x = return_float_point(tree->child[0]->child[0]);
	          point->y = return_float_point(tree->child[0]->child[1]);
	          point->z = return_float_point(tree->child[1]);
		  return(T3D);
	      } else {
	          point->x = return_float_point(tree->child[0]);
	          point->y = return_float_point(tree->child[1]);
	          point->z = 0.0;
		  return(T2D);
	      }
	}
void  Detree3DPoints(tree,x,y,z)
	XGP_node  *tree;
	float *x,*y,*z;
	{
	     *x = return_float_point(tree->child[0]->child[0]);
	     *y = return_float_point(tree->child[0]->child[1]);
	     *z = return_float_point(tree->child[1]);
	}

#define degrees  0.01745329

void make3dRotate(tree,trans)
	 float        trans[4][4];
	 XGP_node     *tree;
 
	 {
	 float   cx,cy,cz,nx,ny,nz,deg,build[4][4];
	 float   d1,st,ct,other[4][4];
	 float   d2,sa,ca,sb,cb;
         XtXGPPointStruct temp;

	 DeTreePoint(tree->child[0]->child[0],&temp);
	 cx = temp.y; cy = temp.x; cz = temp.z;
	 DeTreePoint(tree->child[0]->child[1],&temp);
	 nx = temp.y; ny = temp.x; nz = temp.z;
         deg = return_float_point(tree->child[1]->child[0]);
	 matrixident(build);
	 /* set up the transformation matrix translate center to 0,0,0 */
         build[3][0] = -cx; build[3][1] = -cy; build[3][2] = -cz;
         matrixident(other);
	 /* rotate about x axis to bring normal into xy plane */	
	  d1 = sqrt((cx-nx)*(cx-nx)+(cy-ny)*(cy-ny)+(cz-nz)*(cz-nz));
	  st = sqrt((cz-nz)*(cz-nz))/d1;
	  ct = sqrt((cx-nx)*(cx-nx)+(cy-ny)*(cy-ny))/d1;
	  other[0][0]=ct;other[0][2]=st;
	  other[2][0]= -st;other[2][2]=ct;
	 matrixmultiply(build,other,4);
         matrixcopy(other,build);
	 /* rotate about the z axis */
	 matrixident(other);
  d2 = sqrt((cx-nx)*(cx-nx) + (ct*(cy-ny)-st*(cz-nz))*(ct*(cy-ny)-st*(cz-nz))); 
	  sa = sqrt((cx-nx)*(cx-nx))/d2;
	  ca = sqrt((ct*(cy-ny)-st*(cz-nz))*(ct*(cy-ny)-st*(cz-nz)))/d2;
	  other[0][0] = ca; other[0][1] = sa;
	  other[1][0] = -sa; other[1][1] = ca;
	 matrixmultiply(build,other,4);
         matrixcopy(other,build);
	  matrixident(other);
	  cb = cos(deg*degrees);
	  sb = sin(deg*degrees);
	  other[1][1] = cb; other[1][2] = sb;
	  other[2][1] = -sb; other[2][2] = cb;
	 matrixmultiply(build,other,4);
         matrixcopy(other,build);
	  matrixident(other);
	  other[0][0] = ca; other[0][1] = -sa;
	  other[1][0] = sa; other[1][1] = ca;
	 matrixmultiply(build,other,4);
         matrixcopy(other,build);
	  matrixident(other);
	  other[0][0]=ct;other[0][2]= -st;
	  other[2][0]=st;other[2][2]=ct;
	 matrixmultiply(build,other,4);
         matrixcopy(other,build);
	  matrixident(other);
          build[3][0] = cx; build[3][1] = cy; build[3][2] = cz;
	 matrixmultiply(build,other,4);
	 matrixmultiply(trans,build,4);
         matrixcopy(build,trans);
	 }

void MakeRotate(tree,trans)
	 float        trans[4][4];
	 XGP_node     *tree;
 
	 {
	    transform  temp;
           
	    if (tree->child[0]->node_type == TPOINT3D) {
		make3dRotate(tree,trans);
	    } else {
	        temp.centerx = return_float_point(tree->child[0]->child[0]);
	        temp.centery = return_float_point(tree->child[0]->child[1]);
	        temp.factor1 = return_float_point(tree->child[1]->child[0]);
	        addrotate(&temp,trans,3);
	   }
	 }


void MakeTranslate(tree,trans)
         float        trans[4][4];	
	 XGP_node     *tree;

	 {
	     transform  temp;

	     if (tree->child[0]->node_type == TPOINT) {
		 temp.factor1 = return_float_point(tree->child[0]->child[0]);
		 temp.factor2 = return_float_point(tree->child[0]->child[1]);
		 temp.factor3 = return_float_point(tree->child[1]);
		 addtranslate(&temp,trans,4);
	     } else {
	         temp.factor1 = return_float_point(tree->child[0]);
	         temp.factor2 = return_float_point(tree->child[1]);
	         addtranslate(&temp,trans,3);
	     }
	 }

void MakeScale(tree,trans)
	 float        trans[4][4];
	 XGP_node     *tree;
 
	 {
	     transform  temp;

       if (tree->child[0]->child[0]->node_type == TPOINT) {
	 temp.centerx = return_float_point(tree->child[0]->child[0]->child[0]);
	 temp.centery = return_float_point(tree->child[0]->child[0]->child[1]);
	 temp.centerz = return_float_point(tree->child[0]->child[1]);
	 temp.factor1 = return_float_point(tree->child[1]->child[0]->child[0]);
	 temp.factor2 = return_float_point(tree->child[1]->child[0]->child[1]);
	 temp.factor3 = return_float_point(tree->child[1]->child[1]);
	 addscale(&temp,trans,4);
       } else {
	 temp.factor1 = return_float_point(tree->child[1]->child[0]);
	 temp.factor2 = return_float_point(tree->child[1]->child[1]);
	 temp.centerx = return_float_point(tree->child[0]->child[0]);
	 temp.centery = return_float_point(tree->child[0]->child[1]);
	 addscale(&temp,trans,3);
       }
   }

void detree2dmatrix(trans,tree)
	float       trans[4][4];
	XGP_node    *tree;

	{
	matrixident(trans);
	trans[0][0] = return_float_point(tree->child[0]->child[0]->child[0]);
	trans[1][0] = return_float_point(tree->child[0]->child[1]->child[0]);
	trans[2][0] = return_float_point(tree->child[0]->child[1]->child[1]);
	trans[0][1] = return_float_point(tree->child[1]->child[0]->child[0]);
	trans[1][1] = return_float_point(tree->child[1]->child[0]->child[1]);
	trans[2][1] = return_float_point(tree->child[1]->child[1]->child[0]);
	trans[0][2] = return_float_point(tree->child[1]->child[1]->child[1]);
        trans[1][2] = return_float_point(tree->child[0]->child[0]->
		       child[1]->child[0]);
        trans[2][2] = return_float_point(tree->child[0]->child[0]->
		       child[1]->child[1]);
        }

void detree3dmatrix(trans,tree)
	float       trans[4][4];
	XGP_node    *tree;

	{
	matrixident(trans);
trans[0][0] = return_float_point(tree->child[0]->child[0]->child[0]->child[0]);
trans[1][0] = return_float_point(tree->child[0]->child[0]->child[0]->child[1]);
trans[2][0] = return_float_point(tree->child[0]->child[0]->child[1]->child[0]);
trans[3][0] = return_float_point(tree->child[0]->child[0]->child[1]->child[1]);
trans[0][1] = return_float_point(tree->child[0]->child[1]->child[0]->child[0]);
trans[1][1] = return_float_point(tree->child[0]->child[1]->child[0]->child[1]);
trans[2][1] = return_float_point(tree->child[0]->child[1]->child[1]->child[0]);
trans[3][1] = return_float_point(tree->child[0]->child[1]->child[1]->child[1]);
trans[0][2] = return_float_point(tree->child[1]->child[0]->child[0]->child[0]);
trans[1][2] = return_float_point(tree->child[1]->child[0]->child[0]->child[1]);
trans[2][2] = return_float_point(tree->child[1]->child[0]->child[1]->child[0]);
trans[3][2] = return_float_point(tree->child[1]->child[0]->child[1]->child[1]);
trans[0][3] = return_float_point(tree->child[1]->child[1]->child[0]->child[0]);
trans[1][3] = return_float_point(tree->child[1]->child[1]->child[0]->child[1]);
trans[2][3] = return_float_point(tree->child[1]->child[1]->child[1]->child[0]);
trans[3][3] = return_float_point(tree->child[1]->child[1]->child[1]->child[1]);
        }

void MakeTransform(tree,trans)
	float       trans[4][4];
	XGP_node    *tree;

	{
		float   temp[4][4];

		switch (tree->child[1]->node_type) {
		    case TIDENTITY  :
			matrixident(trans);
			break;
		    case T2D :
			switch (tree->child[0]->node_type) {
			   case TAPPEND :
			       detree2dmatrix(temp,tree->child[1]);
			       matrixmultiply(trans,temp,3);
			       matrixcopy(temp,trans);
			       break;
			   case TREPLACE :
			   default :
			       detree2dmatrix(trans,tree->child[1]);
			       break;
			}
			break;
		   case T3D :
			switch (tree->child[0]->node_type) {
			   case TAPPEND :
			       detree3dmatrix(temp,tree->child[1]);
			       matrixmultiply(trans,temp,4);
			       matrixcopy(temp,trans);
			       break;
			   case TREPLACE :
			   default :
			       detree3dmatrix(trans,tree->child[1]);
			       break;
		        } 
			break;
		   default :
		      break;
		}
	}
