#include <stdio.h>
#include "GraphP.h"

/***********************************************************************/
/* this function will provide facilities for error messages            */
/* the input to this procedure is a code number and possibly a string  */
/* of characters.  This string will contain such information as object */
/* names and unknown commands to be printed.                           */
/***********************************************************************/

void error(wid,code,word)
     GraphWidget wid;
     int      code;  /* a number indicating the error */
     char     *word; /* any special things that need to be output */

     {
         char     astring[500]; /* an output string */

	 sprintf(astring,"Unknown XGP Error\n");
	 switch (code ) {
	   case OutOfMemmory:
	     sprintf(astring,"Out Of memmory, Command Failed. \n");
	     break;
           case 100:
	     sprintf(astring,"Attempt to create an object with a name that is currently in use, %s \n",word);
	     break;
	   case 101:
	     sprintf(astring,"Attempt to combine with a nonexisting object, %s\n"
			     ,word);
	     break;
	   case 102:
	     sprintf(astring,"Object %s was not created \n",word);
	     break;
	   case 103:
	     sprintf(astring,"Combine called with non existing children \n");
	     break;
           case 104: 
	     sprintf(astring,"Unknown object in combine, %s \n",word);
	     break;
	   case 105:
	     sprintf(astring,"%s is currently in use \n",word);
	     break;
	   case 106:
	     sprintf(astring,"No primitive structure specified for object %s\n"
		      ,word);
	     break;
	   case 107:
	     sprintf(astring,"Unknown primitive type for object %s \n",word);
	     break;
	   case 108:
	     sprintf(astring,"Attempt to create a regular polygon with less than 3 sides \n");
             break;
	   case 109 :
	     sprintf(astring,"No points given for surface object \n");
	     break;
	   case 110 :
	     sprintf(astring,"Attempt to use an active object name / alias \n");
	     break;
	   case 111:
	     sprintf(astring,"Aliasing of object names is not permitted \n");
	     break;
	   case 112:
	     sprintf(astring,"Unknown object in Move Command %s \n",word);
	     break;
	   case 160:
	     sprintf(astring,"Attempt to set attributes for unknown object %s \n"
                        ,word);
	     break;
	   case 161:
	     sprintf(astring,"Attribute not implemented \n");
	     break;
	   case 171:
	     sprintf(astring,"Attempt to set viewport width to 0 \n");
	     break;
	   case 172 :
	     sprintf(astring,"Attempt to set viewport height to 0 \n");
	     break;
	   case 200:
	     sprintf(astring,"Error in World Transformation Matrix List \n");
	     break;
	   case 220:
	     sprintf(astring,"No object exists called %s to be deleted\n",word);
	     break;
	   case 221:
	     sprintf(astring,"%s is part of a complex object, It cannot be destroyed \n",word);
	     break;
	   case 230 :
	     sprintf(astring,"%s font not found, No font loaded \n",word);
	     break;
	   case 240 :
	     sprintf(astring,"File %s not found. Operation Aborted \n",word);
	     break;
	   case 241:
	     sprintf(astring,"Attempt to open multiple save files.  Second file not opened\n");
	     break;
	   case 242:
	     sprintf(astring,"Attempt to close save file when no file is open.\n");
	     break;
	   case 250 : 
	     sprintf(astring,"No Output File Specified. Output sent to standard output\n");
	     break;
	   case 260 :
	     sprintf(astring,"Color Table Full, color %s not allocated \n",word);
	     break;
	   case 261 :
	     sprintf(astring,"Color %s not found \n",word);
	     break;
	   case 265 :
	     sprintf(astring,"Default colormap is now the colormap used");
	     break;
	   case 266 :
	     sprintf(astring,"Private colormap is now the colormap used");
	     break;
	   case 510 :
	     sprintf(astring,"Laserjet can only print 2 colors\n");
	     break;
	   case 511 :
	     sprintf(astring,"Invalid Dots per Inch for laserjet (75,100,150,300)\n");
	     break;
	   case 1000 : 
	     sprintf(astring,"Syntax Error : Unbalenced Parenthesis \n %s \n",
		     word);
	     break;
	   case 1001 : 
	     sprintf(astring,"Syntax Error : %s \n",word);
	     break;
	   default :
	     sprintf(astring,"Unknown GraphWidget error %s \n",word);
	     break;
	 }
	 XtCallCallbacks(wid,XtNerror,astring);
     }

void GraphError(wid,cdat,rdat)
    GraphWidget  wid;
    caddr_t      cdat,rdat;
    {
	 fprintf(stderr,"XGP ERROR: %s",rdat);
    }
