#include <math.h>
#include "GraphP.h"

/********************************************************************/
/* Procedure matrixident             12/89                          */
/* This procedure will set a matrix to the identity matrix          */
/********************************************************************/

void matrixident(a)
	float  a[4][4];

	{
	   a[0][0] = 1.0; a[0][1] = 0.0; a[0][2] = 0.0; a[0][3] = 0.0;
	   a[1][0] = 0.0; a[1][1] = 1.0; a[1][2] = 0.0; a[1][3] = 0.0;
	   a[2][0] = 0.0; a[2][1] = 0.0; a[2][2] = 1.0; a[2][3] = 0.0;
	   a[3][0] = 0.0; a[3][1] = 0.0; a[3][2] = 0.0; a[3][3] = 1.0;
        }

/********************************************************************/
/* will copy a matrix from c to b.                                  */
/********************************************************************/

void matrixcopy(c,b)

	float    b[4][4], c[4][4];

	{ int i,j;

             for (i=0;i<4;i++) {
                 for (j=0;j<4;j++) {
                   b[i][j] = c[i][j];
                 }
             }
        }


/********************************************************************/
/* the following routins are to multiply matricies  3x3 4x4         */
/* but only by a matrix of the smae size                            */
/********************************************************************/

void matrixmultiply3x3(a,b)
       float        a[4][4],
		    b[4][4];

	{    float   c[4][4];

	     c[0][0] = a[0][0]*b[0][0]+a[0][1]*b[1][0]+a[0][2]*b[2][0];
	     c[0][1] = a[0][0]*b[0][1]+a[0][1]*b[1][1]+a[0][2]*b[2][1];
	     c[0][2] = a[0][0]*b[0][2]+a[0][1]*b[1][2]+a[0][2]*b[2][2];
	     c[1][0] = a[1][0]*b[0][0]+a[1][1]*b[1][0]+a[1][2]*b[2][0];
	     c[1][1] = a[1][0]*b[0][1]+a[1][1]*b[1][1]+a[1][2]*b[2][1];
	     c[1][2] = a[1][0]*b[0][2]+a[1][1]*b[1][2]+a[1][2]*b[2][2];
	     c[2][0] = a[2][0]*b[0][0]+a[2][1]*b[1][0]+a[2][2]*b[2][0];
	     c[2][1] = a[2][0]*b[0][1]+a[2][1]*b[1][1]+a[2][2]*b[2][1];
	     c[2][2] = a[2][0]*b[0][2]+a[2][1]*b[1][2]+a[2][2]*b[2][2];
	     c[0][3] = 0; c[1][3] = 0; c[2][3] = 0;
	     c[3][0] = 0; c[3][1] = 0; c[3][2] = 0; c[3][3] = 0;
	     matrixcopy(c,b);
        }

void matrixmultiply4x4(a,b)
	float      a[4][4],
		   b[4][4];

	{    float   c[4][4];
       c[0][0]=a[0][0]*b[0][0]+a[0][1]*b[1][0]+a[0][2]*b[2][0]+a[0][3]*b[3][0];
       c[0][1]=a[0][0]*b[0][1]+a[0][1]*b[1][1]+a[0][2]*b[2][1]+a[0][3]*b[3][1];
       c[0][2]=a[0][0]*b[0][2]+a[0][1]*b[1][2]+a[0][2]*b[2][2]+a[0][3]*b[3][2];
       c[0][3]=a[0][0]*b[0][3]+a[0][1]*b[1][3]+a[0][2]*b[2][3]+a[0][3]*b[3][3];
       c[1][0]=a[1][0]*b[0][0]+a[1][1]*b[1][0]+a[1][2]*b[2][0]+a[1][3]*b[3][0];
       c[1][1]=a[1][0]*b[0][1]+a[1][1]*b[1][1]+a[1][2]*b[2][1]+a[1][3]*b[3][1];
       c[1][2]=a[1][0]*b[0][2]+a[1][1]*b[1][2]+a[1][2]*b[2][2]+a[1][3]*b[3][2];
       c[1][3]=a[1][0]*b[0][3]+a[1][1]*b[1][3]+a[1][2]*b[2][3]+a[1][3]*b[3][3];
       c[2][0]=a[2][0]*b[0][0]+a[2][1]*b[1][0]+a[2][2]*b[2][0]+a[2][3]*b[3][0];
       c[2][1]=a[2][0]*b[0][1]+a[2][1]*b[1][1]+a[2][2]*b[2][1]+a[2][3]*b[3][1];
       c[2][2]=a[2][0]*b[0][2]+a[2][1]*b[1][2]+a[2][2]*b[2][2]+a[2][3]*b[3][2];
       c[2][3]=a[2][0]*b[0][3]+a[2][1]*b[1][3]+a[2][2]*b[2][3]+a[2][3]*b[3][3];
       c[3][0]=a[3][0]*b[0][0]+a[3][1]*b[1][0]+a[3][2]*b[2][0]+a[3][3]*b[3][0];
       c[3][1]=a[3][0]*b[0][1]+a[3][1]*b[1][1]+a[3][2]*b[2][1]+a[3][3]*b[3][1];
       c[3][2]=a[3][0]*b[0][2]+a[3][1]*b[1][2]+a[3][2]*b[2][2]+a[3][3]*b[3][2];
       c[3][3]=a[3][0]*b[0][3]+a[3][1]*b[1][3]+a[3][2]*b[2][3]+a[3][3]*b[3][3];
       matrixcopy(c,b);
         }

void matrixmultiply(a,b,size)
       float a[4][4],
             b[4][4];
       int   size;

       {
           if (size == 3 ) {
	      matrixmultiply3x3(a,b);
	   } else {
	      matrixmultiply4x4(a,b);
	   }
	}

/********************************************************************/
/* the following routines set up the transformation matricies       */
/********************************************************************/

void  addscale(t,m,size)
	transform   *t;
	float       m[4][4];
	int         size;

	{
        float      temp[4][4];

	matrixident(temp);
        temp[0][0] = t->factor1;
        temp[1][1] = t->factor2;
	if (size == 3) {
	    temp[2][0] = (1-t->factor1)*t->centerx;
	    temp[2][1] = (1-t->factor2)*t->centery;
   	    matrixmultiply(m,temp,3);
	} else {
	    temp[2][2] = t->factor3;
	    temp[3][0] = (1-t->factor1)*t->centerx;
	    temp[3][1] = (1-t->factor2)*t->centery;
	    temp[3][2] = (1-t->factor3)*t->centerz;
	    matrixmultiply(m,temp,4);
	}
	matrixcopy(temp,m);
        }

void  addtranslate(t,m,size)
	transform   *t;
	float       m[4][4];
	int         size;

	{
        float      temp[4][4];

	matrixident(temp);
	if (size == 3) {
	   temp[2][0] = t->factor1;
	   temp[2][1] = t->factor2;
	   matrixmultiply(m,temp,3);
	} else {
	   temp[3][0] = t->factor1;
	   temp[3][1] = t->factor2;
	   temp[3][2] = t->factor3;
	   matrixmultiply(m,temp,4);
	}
	matrixcopy(temp,m);
        }

#define degrees  0.01745329 

void  addrotate(t,m,size)
	transform   *t;
	float       m[4][4];
	int         size;

	{
        float      temp[4][4],
		   ct,st;
    
	matrixident(temp);
	if (size == 3) {
	   st = (float) sin(t->factor1*degrees);
   	   ct = (float) cos(t->factor1*degrees);

           temp[0][0] = ct;
	   temp[1][0] = -st;
	   temp[2][0] = (1-ct)*t->centerx+t->centery*st;
	   temp[0][1] = st;
           temp[1][1] = ct;
	   temp[2][1] = (1-ct)*t->centery-t->centerx*st;
	   temp[0][2] = 0;
	   temp[1][2] = 0;
	   temp[2][2] = 1;
	   matrixmultiply(m,temp,3);
	} else {
	}
	matrixcopy(temp,m);
        }

void Apply2DMatrix(wid,x,y,p,ox,oy)
	GraphWidget wid;
    	float      x,y,
		   p[4][4],
		   *ox,*oy;
      
	{
		   *ox = x*p[0][0]+y*p[1][0]+p[2][0];
		   *oy = x*p[0][1]+y*p[1][1]+p[2][1];
		   if (wid->graph.Update2Dminmax == TRUE) {
		       newmaxmin(wid,*ox,*oy);
		   }
        }

void Apply3DMatrix(wid,x,y,z,mat,ox,oy,oz)
	GraphWidget   wid;
	float         x,y,z,
		      mat[4][4],
		      *ox,*oy,*oz;

	{
	    *ox = x*mat[0][0] + y*mat[1][0] + z*mat[2][0]+mat[3][0];
	    *oy = x*mat[0][1] + y*mat[1][1] + z*mat[2][1]+mat[3][1];
	    *oz = x*mat[0][2] + y*mat[1][2] + z*mat[2][2]+mat[3][2];
	}
