#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <math.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

/* whenever an object is made a child of a complex object it should   */
/* be removed from the master list   I think that this procedure does */
/* this								      */

extern int retrun_int_point();
extern float return_floatpoint();

void remove_names(child_list,wid)
	ChildList      *child_list;
	GraphWidget    wid;

	{
	  XGPNameList   *curent, *last;

        if (child_list != NULL) {
	  curent = wid->graph.names;
          if (curent->object == child_list->self) {
	      wid->graph.names = curent->next;
	      free((char*)curent);
	      remove_names(child_list->siblings,wid);
	  } else {
	  while ((curent->object != child_list->self) &&
				  (curent->next != NULL)) {
	      last = curent;
	      curent = curent->next;
	  }
	  if (curent->object == child_list->self) {
	      last->next = curent->next;
	      free((char*)curent);
	  }
	  remove_names(child_list->siblings,wid);
	  }
	  }
	}

/******************************************************************/
/* This procedure will create an object in the data base  and call*/
/* display routines for the object.  Input   the widget the       */
/* tree holding the data and the type of object to be created     */
/******************************************************************/

XGPMakeObject(wid,tree,type)
    GraphWidget wid;
    XGP_node    *tree;
    int         type;

    { XGPObject     *data = NULL; 
    stblentry *lookup();

      if (Existing_Name (tree->child[0]->sval)){
	  error(wid,100,tree->child[0]->sval);
      } else {
         switch (type)  {
	    case XGPPrimitive :
	       data= (XGPObject*) MakePrimitive(wid,tree->child[0]->sval,
						tree->child[1]);
	       break;
	    case XGPComplex :
	       data = (XGPObject*) CombineObject(wid,tree->child[0]->sval,
						 tree->child[1]);
	       if (data != NULL) {
	           remove_names(data->data.c_data.children,wid);
	       }
	       break;
	    default :break;
	}
	if (data == NULL) {
	   error(wid,102,(char*)NULL);
	} else {
	   data->aname = lookup(tree->child[0]->sval);
	   Add_Object (tree->child[0]->sval,wid,data);
           if ((data->Other.dimension == T3D ) &&
               (wid->graph.modeadj == TRUE)) {
	       if ((wid->graph.mode != T3D)) {
                    wid->graph.mode = T3D;
	       }
           }
	   if (wid->graph.Redraw == TON) {
		redisplay_picture(wid);
	   }
	}
      }
	 
}

void object_change(wid,tree,obj)
	GraphWidget wid;
	XGP_node    *tree;
	XGPObject   *obj;
        {
            char *foo;

            if (tree == NULL) {
               redisplay_picture(wid);
            } else {
	    switch (tree->node_type) {
		case TVISIBILITY :
		case THIDDEN :
                   if (tree->child[0]->node_type == TVISIBLE) {
                        obj->Other.Hidden = XtVisible;
                    } else {
                        obj->Other.Hidden = XtInvisible;
                    }
                    break;
		case TLINEWID :
		   obj->Other.linewidth = 
                           (int) return_int_point(tree->child[0]);
		   break;
		case TROTATE :
		     MakeRotate(tree,obj->Other.transformation);
		     break;
		case TTRANSLATE :
		     MakeTranslate(tree,obj->Other.transformation);
		     break;
                case TSCALE :
		     MakeScale(tree,obj->Other.transformation);
		     break;
		case TTRANSFORM :
		     MakeTransform(tree,obj->Other.transformation);
		     break;
		case TFONT :
		     obj->Other.fontstyle = tree->child[0]->node_type;
		     break;
		case TCOLOR :
                     foo = tree->child[0]->sval;
		     AssignColorField(wid,foo,&obj->Other.fgcolor);
                     break;
		case  TLINEST :
                      obj->Other.linestyle =tree->child[0]->node_type;
                      break;
                default : break;
            } /* switch */
            object_change(wid,tree->sibling,obj);
          } /* if tree = NULL */
        }

void all_change()

	{
	}

void XGPSetValue (wid,tree)
	GraphWidget wid;
	XGP_node    *tree;

	{
	    XGPObject   *tmp;

	    if (strcmp(tree->child[0]->sval,"World") == 0) { 
		world_change(wid,tree->child[1],FALSE);
	    } else if (strcmp(tree->child[0]->sval,"All") == 0) { 
		all_change();
	    } else if (strcmp(tree->child[0]->sval,"Axis1") == 0) { 
		AssignRefAttrib(wid,&wid->graph.axis[0],tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"Axis2") == 0) { 
		AssignRefAttrib(wid,&wid->graph.axis[1],tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"Grid") == 0) { 
		AssignRefAttrib(wid,&wid->graph.grid,tree->child[1]);
	    }else if(strcmp(tree->child[0]->sval,"HorozontalReference")==0){ 
		AssignRefAttrib(wid,&wid->graph.horilin,tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"VerticalReference") == 0) { 
		AssignRefAttrib(wid,&wid->graph.virtlin,tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"Axis3D") == 0) { 
		Assign3DRefAttrib(wid,tree->child[1]);
	    } else if (strcmp(tree->child[0]->sval,"VolumeBox") == 0) {
		AssignVolumeRefAttrib(wid,tree->child[1]);
	    } else if (Existing_Name (tree->child[0]->sval)) {
		tmp = (XGPObject*)find_object(tree->child[0]->sval);
		if (tmp != NULL) {
		    object_change(wid,tree->child[1],tmp);
		} 
            } else {
	        error(wid,160,tree->child[0]->sval);
	    }
	}

XGPNameList *remove_name(list,node)
       XGPNameList   *list;
       XGPObject     *node; 

       {
	   XGPNameList    *t, *s;

           if (list == NULL) {
	      return(NULL);
	   }
	   if (list->object == node) {
	       t = list;
	       s = list->next;
	       free((char*)t);
	       return(s);
	   } else {
	       list->next = remove_name(list->next,node);
	       return(list);
	   }
	}

void kill_surface_grid(sd)
        SquareSurfaceStruct   *sd;

	{
	  SquareSurfaceStruct *temp;

	  if (sd != NULL) {
	      if (sd->sp != NULL) {
	          kill_surface_grid(sd->sp);
	      }
	      while(sd != NULL) {
		 temp = sd->fp;
		 free((char*)sd);
		 sd = temp;
	     }
	  }
	}

void kill_poly_data(nl)
	Numlist     *nl;
	{
	    if (nl != NULL) {
		kill_poly_data(nl->next);
		free((char*)nl);
	    }
	}

void remove_primitive_structures(node)
	XGPObject    *node;

	{
	    SquareSurfaceStruct   *sd1;
	    Numlist               *nl1;

	    switch (node->data.p_data.type) {
		case Polygon :
		    nl1 = node->data.p_data.data.y_data.points;
		    kill_poly_data(nl1);
		    break;
		case Polyline :
		    nl1 = node->data.p_data.data.pl_data.points;
		    kill_poly_data(nl1);
		    break;
		case Surface :
		    sd1 = node->data.p_data.data.s_data.data;
		    kill_surface_grid(sd1);
		    break;
		default : break;
	    }
	}

void kill_all_else();


/* this routine will destroy the children of a complex type that is
   now to be killed.  No need to take things out of the name list since
   they have been destroyed already.   3/90				*/

void destroy_complex_children(list)
	ChildList  *list;
	{
	  if (list != NULL) {
	      kill_all_else(list->self);
	      destroy_complex_children(list->siblings);
	      free((char*)list->self);
	      free((char*)list);
	  }
	}

void kill_all_else(node)
	XGPObject    *node;

	{
	    switch (node->type) {
		case XGPPrimitive :
		   remove_primitive_structures(node);
		   if (NULL != node->Other.fgcolor) {
		       free(node->Other.fgcolor);
		   }
		   break;
		case XGPComplex:
                   destroy_complex_children(node->data.c_data.children);
		   break;
		default : break;
	    }
	}


void killall(wid)
	GraphWidget  wid;

	{
	    XGPObject        *node;
            XGPNameList    *foo,*bar;

                 foo = wid->graph.names;
           	 wid->graph.names = NULL;
                 while(foo != NULL) {
		     node = foo->object;
		     bar = foo;
		     foo = bar->next;
		     free((char*)bar);
		     kill_all_else(node);
                     node->aname->datafield = NULL; 
		     free((char*)node);
		 }
	}

/**********************************************************************/
/* XGPDestroy  3/90               Dan Bennett                         */
/* this routine will process the remove command.  It will take an     */
/* object out of the data structure and redisplay the picture.        */
/* the routine works on single objects or on the entire collection of */
/* objects.                                                           */
/**********************************************************************/

void XGPDestroy(wid,tree)
	GraphWidget  wid;
	XGP_node     *tree;

	{
	    stblentry *t, *lookup();
	    XGPObject        *node;
            XGPNameList    *foo,*bar;

	    if (tree->sibling != NULL) {
	       XGPDestroy(wid,tree->sibling);
	    }

/* at this point all of the objects are to be removed */

	    if (strcmp(tree->sval,"All")== 0 ) {
                killall(wid);

/* remove only one or a series of single objects */

	    } else if (Existing_Name(tree->sval)) {
		     t = lookup(tree->sval);
		     node = t->datafield;
		     if (node->parent != NULL) {
			error(wid,221,tree->sval);
		     } else {
			kill_all_else(node);
			t->datafield = NULL;
			wid->graph.names =
			     remove_name(wid->graph.names,node);
			free((char*)node);
		     }
	    } else {
	       error(wid,220,tree->sval);
	    }
	}

void XGPMoveObject(wid,tree)
	GraphWidget    wid;
	XGP_node       *tree;

	{
	    stblentry *lookup(),*temp,*temp2;

	    if (Existing_Name (tree->child[1]->sval)){ 
		error(wid,105,tree->child[1]->sval);
	    } else if (!Existing_Name (tree->child[0]->sval)) {
		error(wid,112,tree->child[0]->sval);
	    } else {
		temp = lookup(tree->child[0]->sval);
		temp2 = stblget(tree->child[1]->sval,TIDENT);
		temp2->datafield = temp->datafield;
		temp2->datafield->aname = temp2;
		temp->datafield = NULL;
	    }
	}
