#include        <X11/Intrinsic.h>
#include        <X11/StringDefs.h>
#include        "Graph.h"
#include        "GraphP.h"
#include	<stdio.h>
#include	"pars.h"
#include	"y.tab.h"

extern XGPMakeObject();

GraphWidget  widgetholdforparse;

#define STOP 0
#define GO   1
#define BLKSIZ 216

/************************************************************************/
/* Procedure chipchop                          				*/
/* Programmer Dan Bennett   10/27/89					*/
/*									*/
/* this procedure will destroy the AST                                  */
/************************************************************************/

void chipchop(tp)
       XGP_node   *tp;   /* the pointer to the root of a tree */ 

       {
         if (tp!= NULL)  {
            chipchop(tp->child[0]);
            chipchop(tp->child[1]);
            chipchop(tp->sibling);
	    if (tp->node_type == TSCONST) {
	       free(tp->sval);
	    }
            free(tp);
         }
       }

/************************************************************************/
/************************************************************************/
void trueparse(wid,source)
	GraphWidget     wid;
	char            *source;

        {
        scan_init (wid,source);
        if ((source[0] != '\n') && ( source[0] != NULL)) {
	    widgetholdforparse= wid;
            if (!yyparse ()) {
	        if(wid->graph.SUImode == TON){	
			printf(" %s \n",source);
			fflush(stdout);
		}
		XtCallCallbacks(wid,XtNbuisy,XtWorking);
                pt (wid,XGP_command);
		XtCallCallbacks(wid,XtNbuisy,XtDone);
		if ((wid->graph.files.outflag == TON) && 
		    (XGP_command->node_type != TSAVECOMM)) {
		    savecommand(wid,source);
		}
		XGPCopyArea(wid,0,0,wid->core.width,wid->core.height,0,0);
                chipchop(XGP_command);
            }
        }
        }

void buildcommand(wid,source)
	GraphWidget    wid;
        char           *source;

	{
           int tlength;

	   tlength = strlen(source);
	   if (wid->graph.StringLength != 0) {
	       wid->graph.StringHold =(char*) realloc(wid->graph.StringHold,
	       (tlength+wid->graph.StringLength) * sizeof(char));
	       if (wid->graph.StringHold==NULL) {
		   fprintf(stderr,"XGP Out of memmory DEAD ");
		   exit(1);
	       }
	   } else {
	       wid->graph.StringHold = (char*) XGPmalloc(wid,tlength*sizeof(char));
	       bzero(wid->graph.StringHold,tlength*sizeof(char));
	   }
	   wid->graph.StringHold = strcat(wid->graph.StringHold,source);
	   wid->graph.StringLength =  wid->graph.StringLength + tlength;
	}

void parsebuiltcommand(wid)
	GraphWidget    wid;
        {
	   trueparse(wid,wid->graph.StringHold);
	   free((char*)wid->graph.StringHold);
	   wid->graph.StringHold = NULL;
	   wid->graph.StringLength = 0;
	}

void parse(wid,source,id)
GraphWidget    wid;
int            *source;
XtInputId      *id;

{
   char    buf1,
	   *buf2;
   int     len = 0,
	   stopflag = GO,
	   pcount = 0;

	buf2 = (char*) XGPmalloc(wid,BLKSIZ*sizeof(char));
        while (stopflag != STOP) {
	  if ((buf1 = getchar()) == EOF) {stopflag = STOP;buf1 = '\n';}
	  if (buf1 == '\n') { 
	    if (pcount == 0) { stopflag = STOP;}
	  } else {
	   buf2[len++] = buf1;
	   if ((len % (BLKSIZ-1)) == 0) {
              buf2 = (char*) realloc(buf2,len+BLKSIZ);
	       if (buf2==NULL) {
		   fprintf(stderr,"XGP Out of memmory DEAD ");
		   exit(1);
	       }
	   }
	   if (buf1 == '(') {
	      pcount ++ ;
	   } 
	   if (buf1 == ')') {
	      pcount -- ;
	      if (pcount == 0) { stopflag = STOP; }
	      if (pcount < 0) { 
	          error(widgetholdforparse,1000,buf2);
		  stopflag = STOP;
	      }
	   }
	  }
	}
	buf2[len] = NULL; 
	if (pcount == 0 ) {
             trueparse(wid,buf2);	
	} else {
	     error(widgetholdforparse,1000,buf2);
	}
        free(buf2);
}

void XGPParseString(wid,buf)
	GraphWidget    wid;
	char           *buf;

	{
        trueparse(wid,buf);
	}


pt (wid,tp)
GraphWidget wid;
XGP_node *tp;
{
   int  foo;
   stblentry  *hp1,*hp2;

	for (; tp != NULL; tp = tp->sibling) {
		switch (tp->node_type) {
			case TDRAWPRIM:
				XGPMakeObject(wid,tp,XGPPrimitive);
				break;
			case TCOMBINE:
				XGPMakeObject(wid,tp,XGPComplex);
				break;
			case TMOVE:
				XGPMoveObject(wid,tp);
				break;
			case TCOPY:
				break;
			case TSET:
				XGPSetValue(wid,tp);
				break;
			case TCHANGE:
				printf ("change (");
				pt (wid,tp->child[0]);
				printf (",");
				pt (wid,tp->child[1]);
				printf (")\n");
				break;
			case TRESET:
				XGPInit(wid);
				killall(wid);
				redisplay_picture(wid);
				break;
			case TREMOVE:
				XGPDestroy(wid,tp->child[0]);
				redisplay_picture(wid);
				break;
			case TSLEEP:
			        if (tp->child[0]->node_type == TICONST) {
				    fprintf(stdout,"Sleeping for %d seconds\n",
				      tp->child[0]->ival);
				    redisplay_picture(wid);
				    sleep(tp->child[0]->ival);
				    fprintf(stdout,"Sleep now Done\n");
				} 
				break;    
			case TEXECUTE:
				XGPReadFile(wid,tp->child[0]->sval);
				break;
			case TSAVE:
				XGPSaveEnv(wid,tp);
				break;
			case TSAVECOMM:
				startsave(wid,tp->child[0]->sval);
				break;
			case TSAVECOMMSTOP:
				stopsave(wid);
				break;
			case TALIAS:
				break;
			case TQUIT:
			      if(wid->graph.SUImode == TOFF) {
				exit(1);
			      }
			      break;
			case TINQUIRE:
				Inquire(wid,tp);
				break;
			case THARDCOPY :
				XPixmapOut(wid);
				break;
			default:
				printf ("bad node_type value.. %d \n",
							   tp->node_type);
				break;
		}
	}
}
