#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <math.h>
#include "GraphP.h"
#include "pars.h"
#include "y.tab.h"

extern float return_float_point();
extern int return_int_point();

void reset_axis_stuff(wid,obj)
	GraphWidget      wid;
	ReferenceStuff   *obj;

	{float  sx,sy,lx,ly,xdist,ydist;
        if (obj->AutoAdjust == TRUE) {
	sx = wid->graph.graphXMin;
        sy = wid->graph.graphYMin;
	lx = wid->graph.graphXMax;
	ly = wid->graph.graphYMax;

	xdist = lx - sx;
	ydist = ly - sy;

	obj->TickXmin = sx+(xdist*0.05);
	obj->TickYmin = sy+(ydist*0.05);
	obj->TickXmax = lx-(xdist*0.05);
	obj->TickYmax = ly-(ydist*0.05);
        
	obj->LabXmin = sx+(xdist*0.05);
	obj->LabYmin = sy+(ydist*0.05);
	obj->LabXmax = lx-(xdist*0.05);
	obj->LabYmax = ly-(ydist*0.05);

	obj->Xscale = (xdist * 0.05);
	obj->Yscale = (ydist * 0.05);
   
	obj->XCenter = sx + (xdist * 0.5);
	obj->YCenter = sy + (ydist * 0.5);

	sx = (float) log10(xdist);
	if (sx >= 0 ) {
            obj->XIntPre = (int) (sx + 1);
	    if (sx+1 < 3) {
	      obj->XDecPre = (float) (3 - sx);
	    } else { 
	      obj->XDecPre =0;
	    }
	} else {
	   obj->XIntPre = 0;
	   obj->XDecPre = (int) (-sx+2);
	}
        sx = (float) log10(ydist);
        if (sx >= 0 ) {
            obj->YIntPre = (int) (sx + 1);
            if (sx+1 < 3) {
              obj->YDecPre = (float) (3 - sx);
            } else {
              obj->YDecPre = 0;
            }
        } else {
           obj->YIntPre = 0;
           obj->YDecPre = (int) (-sx+2);
        }
     }
}


void world_change(wid,tree,redisp)
	GraphWidget      wid;
	XGP_node        *tree;
	int              redisp;

	{
	 int     temp;
	 float   x,y,z;

	    if (tree == NULL) {
	       redisplay_picture(wid);
	    } else {
		switch (tree->node_type) {
/* 
    stuff fot the output of hardcopy */
     
		  case TOUTFILE :
		       wid->graph.HardCopyStuff->path = (char*) XGPmalloc(
		wid,(strlen(tree->child[0]->_info._sval)+1)*sizeof(char));  
		       wid->graph.HardCopyStuff->path = 
			   strcpy(wid->graph.HardCopyStuff->path,
			    tree->child[0]->_info._sval);
		       break;
		  case TREDRAW :
		       wid->graph.Redraw = tree->child[0]->node_type;
		       break;
		  case TDIMENSION :
		       wid->graph.mode = tree->child[0]->node_type;
		       break;
		  case THLHS :
		       wid->graph.Hidden = tree->child[0]->node_type;
		       break;
		  case TSUIMODE :
		       wid->graph.SUImode = tree->child[0]->node_type;
		       break;
		  case TPICTLEN :
		       wid->graph.HardCopyStuff->height = 
			    return_float_point(tree->child[0]);
		       break;
		  case TPICTWID :
		       wid->graph.HardCopyStuff->width = 
			    return_float_point(tree->child[0]);
		       break;
		   case TDPI :
		        wid->graph.HardCopyStuff->dpi = 
			    return_int_point(tree->child[0]);
			break;
                   case TOUTFORM :
			wid->graph.HardCopyStuff->otype = 
			    tree->child[0]->node_type;
			break;
                  case TLOADFONT :
                       XGPLoadFont(wid,tree->child[1]->sval,
                             tree->child[0]->node_type);
                       break;
		  case TCOLORMAP :
		       switch (tree->child[0]->node_type) {
			  case TPUBLIC :
			       if (wid->graph.ColormapMode != TPUBLIC) {
				 RestoreDefaultColormap(wid);
				 wid->graph.ColormapMode = TPUBLIC;
			       } else {
				 error(wid,265,NULL);
			       }
			    break;
			  case TPRIVATE :
			       if (wid->graph.ColormapMode != TPRIVATE) {
				 MakeColormap(wid);
				 wid->graph.ColormapMode = TPRIVATE;
			       } else {
				 error(wid,266,NULL);
			       }
			    break;
		       }
		       break;
		  case TVIEWPORT :
		      switch (tree->child[0]->node_type) {
		         case TPOINT : 
		             x = return_float_point(
				 tree->child[0]->child[0]->child[0]);
		             y = return_float_point(
				 tree->child[0]->child[1]->child[0]);
		         if (x==y) {
			    error(wid,171,(char*)NULL);
		          } else {
		             if (x<y) { 
		                wid->graph.graphXMin=x;
		                wid->graph.graphXMax=y;
		             } else {
			        wid->graph.graphXMin=y;
			        wid->graph.graphXMax=x;
		             }
		          }
		          x = return_float_point(
				tree->child[0]->child[0]->child[1]);
		          y = return_float_point(
				tree->child[0]->child[1]->child[1]);
		          if (x==y) {
			    error(wid,172,(char*)NULL);
		          } else {
			     if (x<y) {
			        wid->graph.graphYMin=x;
			        wid->graph.graphYMax=y;
			     } else {
			        wid->graph.graphYMin=y;
			        wid->graph.graphYMax=x;
			     }
		          }
			  break;
		      case TDEFAULT :
				wid->graph.graphYMin = -100.0;
				wid->graph.graphYMax = 100.0;
				wid->graph.graphXMin = -100.0;
				wid->graph.graphXMax = 100.0;
				break;
		      case TMINMAX :
				wid->graph.Update2Dminmax = TRUE;
				wid->graph.twoDvaluesFlag = FALSE;
				redisplay_picture(wid);
				x = wid->graph.twoDxmax;
				y = wid->graph.twoDxmin;
				z = x - y;
				if (z==0 ) { z = 180;}
				wid->graph.graphXMin = y - (0.05) * z;
				wid->graph.graphXMax = x + (0.05) * z;
				x = wid->graph.twoDymax;
				y = wid->graph.twoDymin;
				z = x - y;
				if (z==0 ) { z = 180;}
				wid->graph.graphYMin = y - (0.05) * z;
				wid->graph.graphYMax = x + (0.05) * z;
				wid->graph.Update2Dminmax = TRUE;
				break;
		      }

/* this probably should check to see if the thing is visible */
/* before it does all of those calculations but i'm not too  */
/* sure so I am not going to do it  -- It's now your problem */
		      reset_axis_stuff(wid,&wid->graph.axis[0]);
		      reset_axis_stuff(wid,&wid->graph.axis[1]);
		      reset_axis_stuff(wid,&wid->graph.grid);
		      reset_axis_stuff(wid,&wid->graph.horilin);
		      reset_axis_stuff(wid,&wid->graph.virtlin);
		      redisp = TRUE;
		      break;
		  case TROTATE :
		      MakeRotate(tree,wid->graph.twoDtrans.transformation);
		      break;
		  case TTRANSLATE :
		      MakeTranslate(tree,wid->graph.twoDtrans.transformation);
		      break;
		  case TSCALE :
		      MakeScale(tree,wid->graph.twoDtrans.transformation);
		      break;
                  case TTRANSFORM :
                     MakeTransform(tree,wid->graph.twoDtrans.transformation);
                     break;
		  case TEYEPOS :
		     (void) DeTreePoint(tree->child[0],&wid->graph.thd.eye);
		     resetmatrix(wid);
		     break;
		  case TFOCPOS :
		     if (tree->child[0] != NULL) {
		         (void) DeTreePoint(tree->child[0],
				   &wid->graph.thd.center);
		     } else{
			FindWorldCenter(wid);
		     }
		     resetmatrix(wid);
		     break;
		  case TVIEWSIZE :
		     wid->graph.thd.d2 = return_float_point (
			    tree->child[0]);
                     wid->graph.thd.d3 = return_float_point (
			   tree->child[1]);
		     resetmatrix(wid);
		     break;
		  case TDISTFROMI :
		     wid->graph.thd.d1 = return_float_point(
			   tree->child[0]);
		     resetmatrix(wid);
		     break;
		  case TVIEWROT :
		     wid->graph.thd.rot = return_float_point(
			   tree->child[0]);
		     resetmatrix(wid);
		     break;
		  default : break;
		}
		world_change(wid,tree->sibling,redisp);
	    } 
	}
