%{

/*********************************************************************/
/* The shell for this file and for all of the parser scanner was     */
/* was provided by Sanjiva Weerawarana and was origionally developed */
/* for GENCRAY  his Masters Thesis                                   */
/*********************************************************************/

#include	<stdio.h>
#include	<ctype.h>
#ifdef SYSV
#	include	<string.h>
#	define	index	strchr
#	define	rindex	strrchr
#else
#	include	<strings.h>
#endif

#include	"pars.h"
#include	"y.tab.h"
#include	"ObjectsP.h"
#include        "GraphP.h"

#ifndef TRUE
#define	TRUE	1
#endif
#ifndef FALSE
#define	FALSE	0
#endif

/* this is defined later - see at the bottom */

#undef  dbgetc()

#undef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
  result = (buf[0] = dbgetc()) == EOF ? YY_NULL : 1;

/* This structure is used to make the scanner get input from a string */
static struct {
        char    *data;
        char    *ptr;
} input_buffer;
static GraphWidget GraphWidgetHold;

#ifdef LEXDEBUG
#	define	mreturn(x)	if (1) { \
				  fprintf (stderr, "yylex(): returning: %d\n", x); \
				  return (x); \
				} \
				else
#else
#	define	mreturn(x)	return (x)
#endif

char		*calloc();

int		xgp_paran_ct = 0;	/* # of open left parans */
%}

ws	[ \b\f\r\t\n]*
id	[a-zA-Z_][a-zA-Z0-9_]*
int	(\+|\-)?[0-9]+
real	(\-|\+)?(([0-9]+"."[0-9]*)|([0-9]*"."[0-9]+))(e(\-|\+)[0-9]+)?
als     "~"a.*\n
str     \"[^\"]*\"

%%
{ws}	{ /* no action, no return */ }
{id}	{
	  stblentry *sp;

	  sp = stblget (yytext, TIDENT);
	  if (sp->tokencode == TIDENT)
	    yylval._sval = sp->name;
	  mreturn (sp->tokencode);
	}
{str}   { 
	  /* delete the " and return the string            */
	  yylval._sval = calloc (yyleng-1, sizeof(char));
	  if(yylval._sval == NULL) {
	    fprintf(stderr,"XGP out of memmory, DEAD");
	    exit(-1);
	  }
	  strncpy (yylval._sval,(char*) yytext+1,yyleng-2);
	  yylval._sval[yyleng-1] = NULL;
	  return (TSCONST);
	}
{int}	{ 
	  sscanf (yytext, "%d", &yylval._ival);
	  mreturn (TICONST);
	}
{real}	{
	  sscanf (yytext, "%f", &yylval._fval);
	  mreturn (TFCONST);
	}
";".*   {
	  char c;
	  while (EOF != (c = input()));
          mreturn(TCOMMENT);
	}
{als}	{
	  stblentry *sp,*np;
          char c;
	  char *foo;
	  int  i;

	  i = 3;

	  while(((char*)yytext+i) != (char*)' ') {i++;}
	  foo = (char*) yytext + i;
	  foo = (char*) '\n';
	  yytext = (char*) yytext+3;
	  sp = stblget (yytext, TIDENT);
	  np = stblget (yytext, TIDENT);
	  printf("%s  %s %s \n",yytext,sp->name,np->name);
	  if (sp->tokencode == TIDENT){
	     error(GraphWidgetHold,111,NULL);
	     mreturn(TALIAS);
	  } 
	  if (np->datafield == NULL){
	     error(GraphWidgetHold,110,NULL);
	     mreturn(TALIAS);
	  }
	  if (np->tokencode != TIDENT){
	     error(GraphWidgetHold,110,NULL);
	     mreturn(TALIAS);
	  }
	  np->tokencode = sp->tokencode;
	  mreturn (TALIAS);
	}
"("	{ 
	  xgp_paran_ct++;
	  mreturn (TLP);
	}
")"	{
	  xgp_paran_ct--;
	  mreturn (TRP);
	}
.	{ mreturn (*yytext); }
%%

/*
 * This is our version of getc().
 * It ignores (@!#$) the fileptr argument and, instead, read a character
 * from the global structure input_buffer and returns it.
 */

dberror(s)
	char    *s;
	{
	   error(GraphWidgetHold,1001,input_buffer.data);
	}

dbgetc (fp)
FILE *fp;
{
        char    c;


        if (input_buffer.ptr == NULL)
                return (EOF);
        c = *(input_buffer.ptr);
        (input_buffer.ptr)++;
        if (c == '\0') {
                input_buffer.ptr = NULL;
                input_buffer.data = NULL;
                return (EOF);
        }
        return (c);
}

/*
 * This function MUST be called before calling yyparse(). This sets the
 * data up so that the dbgetc() function above will work.
 */
scan_init (wid,s)
GraphWidget wid;
char *s;
{
        input_buffer.data = input_buffer.ptr = s;
	GraphWidgetHold = wid;
}

