#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <math.h>
#include <stdio.h>
#include <X11/Box.h>
#include <X11/Form.h>
#include <X11/Composite.h>
#include <X11/Command.h>
#include <X11/Shell.h>
#include <strings.h>
#include "Graph/Graph.h"
#include <X11/Xlib.h>
#include <X11/List.h>
#include "XGPSet.h"
#include "XGPUtils.h"
#include <X11/Dialog.h>

Widget   level2_mgr,
         level2_bar;

extern Widget thegraph, SET, REMOVE;
objects current_object;

char  *robject_names[]=
   {" "," "," "," "," "," "," "," "," "," "," BACK "," DOWN ","All"," NONE "};

void object_free(a)
	objects a;
	{
	    (void) free(a.curent);
	    (void) free(a.string);
	    (void) free(a.last);
	    (void) free(a.numlist);
	}

void RChangeList(current_object)
	objects current_object;
    {
      int  i;

      for(i=current_object.position;i<current_object.position+10;i++){
	if (i>=current_object.objects) {
	    strcpy(robject_names[i-current_object.position]," "); 
	} else {   
          robject_names[i-current_object.position] =
	       (char*) current_object.string+current_object.numlist[i];
	}
      }
      XawListChange(level2_bar,robject_names,14,False);

    }


static void level2_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
        {
	 int temp,i;
	 char  *foo;

	 switch (rdat->list_index){
	     case 10:
	          if (current_object.position-10<0){
 			current_object.position = 0;
		  } else {
                        current_object.position = current_object.position-10;
		  }
		  RChangeList(current_object);
		  break;
	       case 11:
		  if (current_object.position+20<current_object.objects){
 			current_object.position = current_object.position+10;
		  } else {
		    if (current_object.objects-10<0) {
			current_object.position = 0;
		    } else {
                        current_object.position = current_object.objects-10;
		    }
		  }
		  RChangeList(current_object);
		  break;
	       case 13 :
		  object_free(current_object);
	          XYMenu(level2_mgr,POPDOWN);
		  break;
	       case 12 :
		  object_free(current_object);
	          XYMenu(level2_mgr,POPDOWN);
		  XGPParseString(thegraph,"(Remove All)\n");
		  break;
	       default:
		  temp = current_object.position+rdat->list_index;
		  if (temp<current_object.objects) {
		    temp = current_object.numlist[temp];
		    foo = (char*) malloc(sizeof(char)*(8+
			 strlen((char*)current_object.string+temp)));
		    sprintf(foo,"(Remove %s )",
		       (char*)(current_object.string+temp));
		    XGPParseString(thegraph,foo);
		  }
		  object_free(current_object);
	          XYMenu(level2_mgr,POPDOWN);
		  break;
	   }
        }

static void MakeNameSelector(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;

  {
      int foo,loop;
      int   i,longest=0,len;

      foo=0;
      current_object.string = (char*) rdat;
      current_object.curent = (char*) NULL;
      current_object.position = 0;
      current_object.numlist = (int*) NULL;
      current_object.last = (char*) NULL;
      current_object.objects = 0;

/* skip the (Set World   */ 

      foo=1;
      while(current_object.string[foo] != '(') { foo++;}

/* skip the (Objects    */

      while(current_object.string[foo] != ' ') { foo++;}
 
/* get the # of objects */

      sscanf((char*)(foo+current_object.string)," %d",
	      &current_object.objects);
    
    current_object.numlist = (int*) malloc(sizeof(int)*current_object.objects);
    while(current_object.string[foo] == ' '){foo++;}
   
      for(i=0;i<current_object.objects;i++){
	 len = 0;
	 /* skip the curent word */
	 while(current_object.string[foo+len] != ' ') {len++;}
	 if (len>longest){longest=len;}
	 foo = foo+len;
	 current_object.string[foo] = (char) NULL;
	 foo++;
	 current_object.numlist[i] = foo;
	 /* put a null in the blank so the words can be used */
      }
      while(current_object.string[foo] != ' ') {foo++;}
      current_object.string[foo] = (char) NULL;
      RChangeList(current_object);
      XYMenu(level2_mgr,POPUP);
  }

static void Level1_call(wid,cdat,rdat)
/********************************************************************/
/* This procedure will setup the objects for the remove menu        */
/********************************************************************/

	Widget   wid;
        XawListReturnStruct  *cdat,*rdat;
	{
         static XtCallbackRec ary[]= {{MakeNameSelector,NULL},{NULL,NULL}};
	 Arg args[1];

	 XtSetArg(args[0],XtNresponse,ary);
	 XtSetValues(thegraph,args,1);
	 XGPParseString(thegraph,"(Inquire World (Object))\n");
	}

static XtCallbackRec L1[]= {{Level1_call,NULL},{NULL,NULL}};
static XtCallbackRec L2[]= {{level2_call,NULL},{NULL,NULL}};

void RemoveInit(box,box2)
	Widget box,box2;

	{
        Arg    args[10];
        Widget tbox;

	  /* create a button on the main window */

        XtSetArg(args[0],XtNlabel,"Remove");
        XtSetArg(args[1],XtNcallback,L1);
        XtSetArg(args[2],XtNfromHoriz,SET);
        REMOVE=XtCreateManagedWidget("Remove",commandWidgetClass,box,args,3);

	   /* make the object menu for popup */

        level2_mgr = XtCreatePopupShell("l2mgr",overrideShellWidgetClass,
		      box2,NULL,0);
        tbox=XtCreateManagedWidget("rem_box",boxWidgetClass,level2_mgr,NULL,0);
	XtSetArg(args[0],XtNlabel,"Select Object To Remove");
	XtCreateManagedWidget("Remove_title",labelWidgetClass,tbox,args,1);
	XtSetArg(args[0],XtNnumberStrings,14);
	XtSetArg(args[1],XtNlist,robject_names);
	XtSetArg(args[2],XtNcallback,L2);
	level2_bar=XtCreateManagedWidget("L2_bar",listWidgetClass,tbox,args,3);
	}
