#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <math.h>
#include <stdio.h>
#include <X11/Box.h>
#include <X11/Form.h>
#include <X11/Composite.h>
#include <X11/Command.h>
#include <X11/Shell.h>
#include <strings.h>
#include "Graph/Graph.h"
#include <X11/Xlib.h>
#include <X11/List.h>
#include "XGPSet.h"
#include "XGPUtils.h"
#include <X11/Dialog.h>


Widget 
         set_mgr,
         Set_bar,
         level2_B_bar,
         level2_B_mgr,
         level2_C_bar,
         level2_C_mgr,
	 level3A_mgr,
	 level3A_bar,
         level3A_A_title,
         level3A_A_mgr,
         level3A_A_bar,
         level3A_A_dialog,
	 level3A_B_mgr,
	 level3A_B_bar,
	 level3A_D_mgr,
	 level3A_D_bar,
         level3A_E_title,
         level3A_E_mgr,
         level3A_E_bar,
         level3A_E_dialog,
         level3C_C_mgr,
         level3C_C_bar,
	 level3C_A_mgr,
	 level3C_A_bar,
	 level3cadialog1,
	 level3C_B_mgr,
	 level3C_B_bar,
	 level3C_C_A_mgr,
	 level3ccadialog1,
	 level3ccadialog2,
	 level3ccadialog3,
	 level3ccadialog4,
         level3C_D_mgr,
	 level3cddialog1,
	 level3cddialog2,
	 level3cddialog3,
         level3C_E_mgr,
	 level3cedialog1,
	 level3cedialog2,
	 level3cedialog3,
         level3C_F_mgr,
	 level3cfdialog1,
         level3C_G_mgr,
	 level3cgdialog1,
	 level3cgdialog2,
         level3C_H_mgr,
	 level3C_H_bar,
         level3C_I_mgr,
	 level3C_I_bar,
         level1_bar,
         level1_mgr;

float      xm,ym,XM,YM;

extern Widget thegraph, SET,TITLE;
extern objects current_object;
extern void foobar();

/* the first level down labels */

char  *object_names[]=
   {" "," "," "," "," "," "," "," "," "," "," BACK "," DOWN "," NONE "},
      *l3A_names[]={"Line Width","Line Style","Transform","Visibility",
			"Color","None"},
      *Set_names[]={"Object","Reference","World","None"},
      *ref_names[]={"Axis1","Axis2","Axis3d","Grid","X-Line","Y-Line","Box",
                   "NONE"},
      *l2C_names[]={"Load Font","Color Map","Viewport","Eye Position",
                   "Focus Position","Distance From Eye","Viewport Size"
                   ,"Redraw","Dimension","NONE"},
      *l3C_A_names[]={"Regular","Italic","Bold","Greek","NONE"},
      *l3A_B_names[]={"Solid","Dashed","NONE"},
      *l3A_D_names[]={"Visible","Invisible","NONE"},
      *l3C_B_names[]={"Public","Private","NONE"},
      *l3C_H_names[]={"On","Off","NONE"},
      *l3C_I_names[]={"2D","2DOnly","3D","3DOnly","NONE"};

/* the world attributes setting labels */
char  *l3C_C_names[]={"Min-Max","Default","X-Y","None"};

static void  GetXYValues(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
 static    char  *temp,foo[30],foo1[20],foo2[20],foo3[20],foo4[20];
           Arg args[3];
           Widget  hold;

	   temp= (char*) findparam((char*)rdat,"Viewport");
           sscanf(temp,"%f %f %f %f",&xm,&ym,&XM,&YM);
           (void) free(temp);
	   sprintf(foo1,"%f ",xm);
	   XtSetArg(args[0],XtNvalue,foo1);
           XtSetValues(level3ccadialog1,args,1);
	  
	   hold = XtNameToWidget(level3ccadialog1,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo1));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo1));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo2,"%f ",ym);
	   XtSetArg(args[0],XtNvalue,foo2);
           XtSetValues(level3ccadialog2,args,1);
	   hold = XtNameToWidget(level3ccadialog2,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo2));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo2));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo3,"%f ",XM);
	   XtSetArg(args[0],XtNvalue,foo3);
           XtSetValues(level3ccadialog3,args,1);
	   hold = XtNameToWidget(level3ccadialog3,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo3));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo3));
           XtSetValues(hold,args,3);
	  
	   sprintf(foo4,"%f ",YM);
	   XtSetArg(args[0],XtNvalue,foo4);
           XtSetValues(level3ccadialog4,args,1);
	   hold = XtNameToWidget(level3ccadialog4,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo4));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo4));
           XtSetValues(hold,args,3);
         
	   XYMenu(level3C_C_mgr,POPUP);
    }

static void  GetFocusValues(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
 static    char  *temp,foo[30],foo1[20],foo2[20],foo3[20];
           Arg args[3];
           Widget  hold;

	   temp= (char*) findparam((char*)rdat,"FocusPosition");
           sscanf(temp,"%f %f %f ",&xm,&ym,&XM);
           (void) free(temp);
	   sprintf(foo1,"%f ",xm);
	   XtSetArg(args[0],XtNvalue,foo1);
           XtSetValues(level3cedialog1,args,1);
	  
	   hold = XtNameToWidget(level3cedialog1,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo1));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo1));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo2,"%f ",ym);
	   XtSetArg(args[0],XtNvalue,foo2);
           XtSetValues(level3cedialog2,args,1);
	   hold = XtNameToWidget(level3cedialog2,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo2));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo2));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo3,"%f ",XM);
	   XtSetArg(args[0],XtNvalue,foo3);
           XtSetValues(level3cedialog3,args,1);
	   hold = XtNameToWidget(level3cedialog3,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo3));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo3));
           XtSetValues(hold,args,3);
	  
	   XYMenu(level3C_E_mgr,POPUP);
    }

static void  GetEyeValues(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
 static    char  *temp,foo[30],foo1[20],foo2[20],foo3[20];
           Arg args[3];
           Widget  hold;

	   temp= (char*) findparam((char*)rdat,"EyePosition");
           sscanf(temp,"%f %f %f ",&xm,&ym,&XM);
           (void) free(temp);
	   sprintf(foo1,"%f ",xm);
	   XtSetArg(args[0],XtNvalue,foo1);
           XtSetValues(level3cddialog1,args,1);
	  
	   hold = XtNameToWidget(level3cddialog1,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo1));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo1));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo2,"%f ",ym);
	   XtSetArg(args[0],XtNvalue,foo2);
           XtSetValues(level3cddialog2,args,1);
	   hold = XtNameToWidget(level3cddialog2,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo2));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo2));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo3,"%f ",XM);
	   XtSetArg(args[0],XtNvalue,foo3);
           XtSetValues(level3cddialog3,args,1);
	   hold = XtNameToWidget(level3cddialog3,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo3));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo3));
           XtSetValues(hold,args,3);
	  
	   XYMenu(level3C_D_mgr,POPUP);
    }

static void  GetViewSizeValues(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
 static    char  *temp,foo[30],foo1[20],foo2[20];
           Arg args[3];
           Widget  hold;

	   temp= (char*) findparam((char*)rdat,"ViewportSize");
           sscanf(temp,"%f %f ",&xm,&ym);
           (void) free(temp);
	   sprintf(foo1,"%f ",xm);
	   XtSetArg(args[0],XtNvalue,foo1);
           XtSetValues(level3cgdialog1,args,1);
	  
	   hold = XtNameToWidget(level3cgdialog1,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo1));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo1));
           XtSetValues(hold,args,3);
	   
	   sprintf(foo2,"%f ",ym);
	   XtSetArg(args[0],XtNvalue,foo2);
           XtSetValues(level3cgdialog2,args,1);
	   hold = XtNameToWidget(level3cgdialog2,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo2));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo2));
           XtSetValues(hold,args,3);
	   
	   XYMenu(level3C_G_mgr,POPUP);
    }

static void  GetEyeDistanceValues(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
 static    char  *temp,foo[30],foo1[20];
           Arg args[3];
           Widget  hold;

	   temp= (char*) findparam((char*)rdat,"DistanceFromEye");
           sscanf(temp,"%f ",&xm);
           (void) free(temp);
	   sprintf(foo1,"%f ",xm);
	   XtSetArg(args[0],XtNvalue,foo1);
           XtSetValues(level3cfdialog1,args,1);
	  
	   hold = XtNameToWidget(level3cfdialog1,"value");
	   XtSetArg(args[0],XtNborderWidth,0);
	   XtSetArg(args[1],XtNlength,strlen(foo1));
	   XtSetArg(args[2],XtNinsertPosition,strlen(foo1));
           XtSetValues(hold,args,3);
	   
	   XYMenu(level3C_F_mgr,POPUP);
    }

static void level2Ccall(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
        {
         Arg args[4];
	 static char lafoo[30];

         static XtCallbackRec ary[]={{GetXYValues,NULL},{NULL,NULL}};
         static XtCallbackRec bry[]={{GetFocusValues,NULL},{NULL,NULL}};
         static XtCallbackRec cry[]={{GetEyeValues,NULL},{NULL,NULL}};
         static XtCallbackRec dry[]={{GetEyeDistanceValues,NULL},{NULL,NULL}};
         static XtCallbackRec ery[]={{GetViewSizeValues,NULL},{NULL,NULL}};
         Widget hold;

           XYMenu(level2_C_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
		 sprintf(lafoo," ");
	         XtSetArg(args[0],XtNvalue,lafoo);
                 XtSetValues(level3cadialog1,args,1);
	         hold = XtNameToWidget(level3cadialog1,"value");
	         XtSetArg(args[0],XtNborderWidth,0);
	         XtSetArg(args[1],XtNlength,30);
	         XtSetArg(args[2],XtNinsertPosition,1);
                 XtSetValues(hold,args,3);
		 XYMenu(level3C_A_mgr,POPUP);
                 break; 
               case 1:
		 XYMenu(level3C_B_mgr,POPUP);
                 break; 
               case 2:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (Viewport))\n");
                 break; 
               case 3:
		 XtSetArg(args[0],XtNresponse,cry);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (EyePosition))\n");
                 break; 
               case 4:
		 XtSetArg(args[0],XtNresponse,bry);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (FocusPosition))\n");
                 break; 
               case 5:
		 XtSetArg(args[0],XtNresponse,dry);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (DistanceFromEye))\n");
                 break; 
               case 6:
		 XtSetArg(args[0],XtNresponse,ery);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (ViewportSize))\n");
                 break; 
               case 7:
		 XYMenu(level3C_H_mgr,POPUP);
                 break; 
               case 8:
		 XYMenu(level3C_I_mgr,POPUP);
                 break; 
               default:
                 break; 
           }
        }

static void level3C_C_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
        {
           XYMenu(level3C_C_mgr,POPDOWN);
	   switch (rdat->list_index){
	      case 0:
		XGPParseString(thegraph,"(Set World (Viewport MinMax))\n");
		break;
	      case 1:
		XGPParseString(thegraph,"(Set World (Viewport Default))\n");
		break;
              case 2:
		XYMenu(level3C_C_A_mgr,POPUP);
                break;
	      default:
		break;
           } 
        }

int check(foo)
	char  *foo;
	{
	 int len,i;

	 len = 0; 
	 for (i=0;i<strlen(foo);i++){
	    if (foo[i]!=' ') { len=1;}
	 }
	 return(len);
	}

static void level3C_A_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
	char  *foo,bar[200];

        XYMenu(level3C_A_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3cadialog1);
	   switch (rdat->list_index){
               case 0:
		   sprintf(bar,"(Set World (LoadFont Regular \"%s\"))",foo);
	           break;
               case 1:
		   sprintf(bar,"(Set World (LoadFont Italic \"%s\"))",foo);
	           break;
               case 2:
		   sprintf(bar,"(Set World (LoadFont Bold \"%s\"))",foo);
	           break;
               case 3:
		   sprintf(bar,"(Set World (LoadFont Greek \"%s\"))",foo);
	           break;
               default:
	           break;
	   }
           XGPParseString(thegraph,bar);
    }

static void level3C_B_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
        XYMenu(level3C_B_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
                   XGPParseString(thegraph,"(Set World (Colormap Public))");
	           break;
               case 1:
                   XGPParseString(thegraph,"(Set World (Colormap Private))");
	           break;
               default:
	           break;
	   }
    }

static void level3C_H_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
        XYMenu(level3C_H_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
                   XGPParseString(thegraph,"(Set World (Redraw On))");
	           break;
               case 1:
                   XGPParseString(thegraph,"(Set World (Redraw Off))");
	           break;
               default:
	           break;
	   }
    }

static void level3C_I_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
        XYMenu(level3C_I_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
                   XGPParseString(thegraph,"(Set World (Dimension TwoD))");
	           break;
               case 1:
                   XGPParseString(thegraph,"(Set World (Dimension TwoDOnly))");
	           break;
               case 2:
                   XGPParseString(thegraph,"(Set World (Dimension ThreeD))");
	           break;
               case 3:
                  XGPParseString(thegraph,"(Set World (Dimension ThreeDOnly))");
	           break;
               default:
	           break;
	   }
    }

static void level3C_C_A_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
     char   *foo;

        XYMenu(level3C_C_A_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3ccadialog1);
	if (check(foo)==1) {
	    xm = atof(foo);
	}
	foo = XawDialogGetValueString(level3ccadialog2);
	if (check(foo)==1) {
	    ym = atof(foo);
	}
	foo = XawDialogGetValueString(level3ccadialog3);
	if (check(foo)==1) {
	    XM = atof(foo);
	}
	foo = XawDialogGetValueString(level3ccadialog4);
	if (check(foo)==1) {
	    YM = atof(foo);
	}
	foo = (char*) malloc(80*sizeof(char));
	sprintf(foo,"(Set World (Viewport %f %f %f %f ))\n",xm,ym,XM,YM);
        XGPParseString(thegraph,foo);
	(void) free(foo);
    }

static void level3C_D_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
     char   *foo;

        XYMenu(level3C_D_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3cddialog1);
	if (check(foo)==1) {
	    xm = atof(foo);
	}
	foo = XawDialogGetValueString(level3cddialog2);
	if (check(foo)==1) {
	    ym = atof(foo);
	}
	foo = XawDialogGetValueString(level3cddialog3);
	if (check(foo)==1) {
	    XM = atof(foo);
	}
	foo = (char*) malloc(80*sizeof(char));
	sprintf(foo,"(Set World (EyePosition %f %f %f ))\n",xm,ym,XM);
        XGPParseString(thegraph,foo);
	(void) free(foo);
    }

static void level3C_E_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
     char   *foo;

        XYMenu(level3C_E_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3cedialog1);
	if (check(foo)==1) {
	    xm = atof(foo);
	}
	foo = XawDialogGetValueString(level3cedialog2);
	if (check(foo)==1) {
	    ym = atof(foo);
	}
	foo = XawDialogGetValueString(level3cedialog3);
	if (check(foo)==1) {
	    XM = atof(foo);
	}
	foo = (char*) malloc(80*sizeof(char));
	sprintf(foo,"(Set World (FocusPosition %f %f %f ))\n",xm,ym,XM);
        XGPParseString(thegraph,foo);
	(void) free(foo);
    }

static void level3C_F_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
     char   *foo;

        XYMenu(level3C_F_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3cfdialog1);
	if (check(foo)==1) {
	    xm = atof(foo);
	}
	foo = (char*) malloc(80*sizeof(char));
	sprintf(foo,"(Set World (DistanceFromEye %f ))\n",xm);
        XGPParseString(thegraph,foo);
	(void) free(foo);
    }

static void level3C_G_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
     char   *foo;

        XYMenu(level3C_G_mgr,POPDOWN);

	foo = XawDialogGetValueString(level3cgdialog1);
	if (check(foo)==1) {
	    xm = atof(foo);
	}
	foo = XawDialogGetValueString(level3cgdialog2);
	if (check(foo)==1) {
	    ym = atof(foo);
	}
	foo = (char*) malloc(80*sizeof(char));
	sprintf(foo,"(Set World (ViewportSize %f %f ))\n",xm,ym);
        XGPParseString(thegraph,foo);
	(void) free(foo);
    }
static void AxisChange(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
    }

static void Axis3DChange(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
    }

static void BoxChange(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
    }

static void level2Bcall(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
        {
         Arg args[1];
         static XtCallbackRec ary[]={{AxisChange,NULL},{NULL,NULL}};
         static XtCallbackRec bry[]={{Axis3DChange,NULL},{NULL,NULL}};
         static XtCallbackRec cry[]={{BoxChange,NULL},{NULL,NULL}};

           XYMenu(level2_B_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (Axis1))\n");
		 break;
               case 1:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (Axis2))\n");
		 break;
               case 2:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (Grid))\n");
		 break;
               case 3:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
             XGPParseString(thegraph,"(Inquire World (HorizontalReference))\n");
		 break;
               case 4:
		 XtSetArg(args[0],XtNresponse,ary);
                 XtSetValues(thegraph,args,1);
             XGPParseString(thegraph,"(Inquire World (VerticalReference))\n");
		 break;
               case 5:
		 XtSetArg(args[0],XtNresponse,bry);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (Axis3D))\n");
		 break;
               case 6:
		 XtSetArg(args[0],XtNresponse,cry);
                 XtSetValues(thegraph,args,1);
                 XGPParseString(thegraph,"(Inquire World (VolumeBox))\n");
		 break;
	       default :
		 break;
	   }
        }

void ChangeList(current_object)
	objects current_object;
    {
      int  i;

      for(i=current_object.position;i<current_object.position+10;i++){
	if (i>=current_object.objects) {
	    strcpy(object_names[i-current_object.position]," "); 
	} else {   
          object_names[i-current_object.position] =
	       (char*) current_object.string+current_object.numlist[i];
	}
      }
      XawListChange(Set_bar,object_names,13,False);

    }


static void sitcall(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
        {
	 int temp,i;
	   switch (rdat->list_index){
	       case 10:
		  if (current_object.position-10<0){
 			current_object.position = 0;
		  } else {
                        current_object.position = current_object.position-10;
		  }
		  ChangeList(current_object);
		  break;
	       case 11:
		  if (current_object.position+20<current_object.objects){
 			current_object.position = current_object.position+10;
		  } else {
		    if (current_object.objects-10<0) {
			current_object.position = 0;
		    } else {
                        current_object.position = current_object.objects-10;
		    }
		  }
		  ChangeList(current_object);
		  break;
	       case 12 :
	          XYMenu(set_mgr,POPDOWN);
		  break;
	       default:
		  temp = current_object.position+rdat->list_index;
		  if (temp<current_object.objects) {
		    temp = current_object.numlist[temp];
		    if (current_object.curent == NULL) {
		      current_object.curent = (char*) 
		    	malloc(strlen((char*)current_object.string+temp));
		    } else {
		          current_object.curent = (char*)
		  	     realloc(current_object.curent,
		  	     strlen((char*)current_object.string+temp));
		    }
		    strcpy(current_object.curent,
		  	       (char*)(current_object.string+temp));
	            XYMenu(set_mgr,POPDOWN);
		    XYMenu(level3A_mgr,POPUP);
		  } else{
	            XYMenu(set_mgr,POPDOWN);
		  }
		  break;
	   }
        }

static void MakeNameSelector(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;

  {
      int foo,loop;
      int   i,longest=0,len;

      current_object.string = (char*) rdat;
      current_object.curent = (char*) NULL;
      current_object.position = 0;
/* skip the (Set World */
foo = 18;
/* skip the (Objects    */
      while(current_object.string[foo] != ' ') { foo++;}
 
/* get the # of objects */
      sscanf((char*)(foo+current_object.string)," %d",
	      &current_object.objects);
    if (current_object.numlist != NULL){
      free((char*)current_object.numlist);
    }
    current_object.numlist = (int*) malloc(sizeof(int)*current_object.objects);
    while(current_object.string[foo] == ' '){foo++;}
   
      for(i=0;i<current_object.objects;i++){
	 len = 0;
	 /* skip the curent word */
	 while(current_object.string[foo+len] != ' ') {len++;}
	 if (len>longest){longest=len;}
	 foo = foo+len;
	 current_object.string[foo] = (char) NULL;
	 foo++;
	 current_object.numlist[i] = foo;
	 /* put a null in the blank so the words can be used */
      }
      while(current_object.string[foo] != ' ') {foo++;}
      current_object.string[foo] = (char) NULL;
      ChangeList(current_object);
      XYMenu(set_mgr,POPUP);
  }


static void setcall(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
        XYMenu(level1_mgr,POPUP);
    }

static void level3A_E1_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
        char  *foo,bar[200];

	foo = XawDialogGetValueString(level3A_E_dialog);
        XYMenu(level3A_E_mgr,POPDOWN);
        sprintf(bar,"(Set %s (Color \"%s\"))",current_object.curent,foo);
	XGPParseString(thegraph,bar);
    }

static void level3A_E2_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
        XYMenu(level3A_E_mgr,POPDOWN);
    }

static void level3A_B_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
	char  bar[100];
        XYMenu(level3A_B_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
        sprintf(bar,"(Set %s (LineStyle Solid))",current_object.curent);
	           break;
               case 1:
        sprintf(bar,"(Set %s (LineStyle Dashed))",current_object.curent);
	           break;
               default:
	           break;
	   }
           XGPParseString(thegraph,bar);
    }

static void level3A_D_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
	char  bar[100];
        XYMenu(level3A_D_mgr,POPDOWN);
	   switch (rdat->list_index){
               case 0:
        sprintf(bar,"(Set %s (Visibility Visible))",current_object.curent);
	           break;
               case 1:
        sprintf(bar,"(Set %s (Visibility Invisible))",current_object.curent);
	           break;
               default:
	           break;
	   }
           XGPParseString(thegraph,bar);
    }


static void level3A_A1_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
        char  *foo,bar[200];
        int   d;

	foo = XawDialogGetValueString(level3A_A_dialog);
	if (check(foo)==1) {
	    d =(int) atoi(foo);
	}
        XYMenu(level3A_A_mgr,POPDOWN);
        sprintf(bar,"(Set %s (LineWidth %d))",current_object.curent,d);
	XGPParseString(thegraph,bar);
    }

static void level3A_A2_call(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
        XYMenu(level3A_A_mgr,POPDOWN);
    }

static void level3A_call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;
    {
        static  char foo[30];
        Arg     args[10];
        Widget  hold;

        XYMenu(level3A_mgr,POPDOWN);
	switch (rdat->list_index){
	    case 0:
               sprintf(foo,"");
                 XtSetArg(args[0],XtNvalue,foo);
                 XtSetValues(level3A_A_dialog,args,1);
                 hold = XtNameToWidget(level3A_A_dialog,"value");
                 XtSetArg(args[0],XtNborderWidth,0);
                 XtSetArg(args[1],XtNlength,30);
                 XtSetArg(args[2],XtNinsertPosition,0);
                 XtSetValues(hold,args,3);
                 XYMenu(level3A_A_mgr,POPUP);
	       break;
	    case 1:
                 XYMenu(level3A_B_mgr,POPUP);
	       break;
	    case 2:
	       break;
	    case 3:
                 XYMenu(level3A_D_mgr,POPUP);
	       break;
	    case 4:
               sprintf(foo,"");
                 XtSetArg(args[0],XtNvalue,foo);
                 XtSetValues(level3A_E_dialog,args,1);
                 hold = XtNameToWidget(level3A_E_dialog,"value");
                 XtSetArg(args[0],XtNborderWidth,0);
                 XtSetArg(args[1],XtNlength,30);
                 XtSetArg(args[2],XtNinsertPosition,0);
                 XtSetValues(hold,args,3);
                 XYMenu(level3A_E_mgr,POPUP);
	       break;
	    default:
	       break;
	}
    }

static void level1call(wid,cdat,rdat)
    Widget   wid;
    XawListReturnStruct  *cdat,*rdat;

    {
       Arg args[1];
       static XtCallbackRec ary[]= {{MakeNameSelector,NULL},{NULL,NULL}};

	   switch (rdat->list_index){
                 case 0:
                     XYMenu(level1_mgr,POPDOWN);
                     XtSetArg(args[0],XtNresponse,ary);
                     XtSetValues(thegraph,args,1);
                     XGPParseString(thegraph,"(Inquire World (Object))\n");
                   break;
                 case 1:
                     XYMenu(level1_mgr,POPDOWN);
                     XYMenu(level2_B_mgr,POPUP);
                   break;
                 case 2:
                     XYMenu(level1_mgr,POPDOWN);
                     XYMenu(level2_C_mgr,POPUP);
                   break;
                 default:
                     XYMenu(level1_mgr,POPDOWN);
                   break;
           } 
    }

static XtCallbackRec Set[]=    {{setcall,NULL},{NULL,NULL}};
static XtCallbackRec Sit[]=    {{sitcall,NULL},{NULL,NULL}};
static XtCallbackRec L1[]=     {{level1call,NULL},{NULL,NULL}};
static XtCallbackRec L2B[]=    {{level2Bcall,NULL},{NULL,NULL}};
static XtCallbackRec L2C[] =   {{level2Ccall,NULL},{NULL,NULL}};
static XtCallbackRec L3C_C[] = {{level3C_C_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CA[] =  {{level3C_A_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CB[] =  {{level3C_B_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CCA[] = {{level3C_C_A_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CD[] =  {{level3C_D_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CE[] =  {{level3C_E_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CF[] =  {{level3C_F_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CG[] =  {{level3C_G_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CH[] =  {{level3C_H_call,NULL},{NULL,NULL}};
static XtCallbackRec L3CI[] =  {{level3C_I_call,NULL},{NULL,NULL}};
static XtCallbackRec L3A[] =   {{level3A_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AA1[] = {{level3A_A1_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AA2[] = {{level3A_A2_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AB[] =  {{level3A_B_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AD[] =  {{level3A_D_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AE1[] = {{level3A_E1_call,NULL},{NULL,NULL}};
static XtCallbackRec L3AE2[] = {{level3A_E2_call,NULL},{NULL,NULL}};


void setinit(box,box2)
	Widget   box,box2 ;

	{
	 Arg  args[10];
         Widget  tbox;

/* Make the st button on the main window */

      XtSetArg(args[0],XtNlabel,"Set");
      XtSetArg(args[1],XtNcallback,Set);
      XtSetArg(args[2],XtNfromHoriz,TITLE);
      SET = XtCreateManagedWidget("set",commandWidgetClass,box,args,3);

/* Make the first level pop-up window */
      level1_mgr = XtCreatePopupShell("l1mgr",overrideShellWidgetClass,box2,
           NULL,0);
      tbox = XtCreateManagedWidget("set_box",boxWidgetClass,level1_mgr,NULL,0);
      XtSetArg(args[0],XtNlabel,"Select");
      XtCreateManagedWidget("set_title",labelWidgetClass,tbox,args,1);
      XtSetArg(args[0],XtNnumberStrings,4);
      XtSetArg(args[1],XtNlist,Set_names);
      XtSetArg(args[2],XtNcallback,L1);
      level1_bar = XtCreateManagedWidget("Setl1_bar",listWidgetClass,tbox,args,3);
/* make a popup menu for the Reference stuff */

      level2_B_mgr = XtCreatePopupShell("l2bmgr",overrideShellWidgetClass,box2,
           NULL,0);
      tbox = XtCreateManagedWidget("l2bbox",boxWidgetClass,level2_B_mgr,NULL,0);
      XtSetArg(args[0],XtNlabel,"Which Object");
      XtCreateManagedWidget("l2btitle",labelWidgetClass,tbox,args,1);
      XtSetArg(args[0],XtNnumberStrings,8);
      XtSetArg(args[1],XtNlist,ref_names);
      XtSetArg(args[2],XtNcallback,L2B);
      level2_B_bar=XtCreateManagedWidget("l2bbar",listWidgetClass,tbox,args,3);

/* make a popup for the */
/* make a popup menu for the World  stuff */

      level2_C_mgr = XtCreatePopupShell("l2cmgr",overrideShellWidgetClass,box2,
           NULL,0);
      tbox = XtCreateManagedWidget("l2cbox",boxWidgetClass,level2_C_mgr,NULL,0);
      XtSetArg(args[0],XtNlabel,"Set Which?");
      XtCreateManagedWidget("l2btitle",labelWidgetClass,tbox,args,1);
      XtSetArg(args[0],XtNnumberStrings,10);
      XtSetArg(args[1],XtNlist,l2C_names);
      XtSetArg(args[2],XtNcallback,L2C);
      level2_C_bar=XtCreateManagedWidget("l2cbar",listWidgetClass,tbox,args,3);

/* make a popup for the font */
    level3C_A_mgr = XtCreatePopupShell("l3camgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cabox",boxWidgetClass,level3C_A_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Enter Font Name");
    level3cadialog1=XtCreateManagedWidget("3ca1",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"Font Slot");
    XtCreateManagedWidget("l3catitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,5);
    XtSetArg(args[1],XtNlist,l3C_A_names);
    XtSetArg(args[2],XtNcallback,L3CA);
    level3C_A_bar=XtCreateManagedWidget("l3cabar",listWidgetClass,tbox,args,3);

/* make a popup for the colormap stuff */
    level3C_B_mgr = XtCreatePopupShell("l3cbmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cbbox",boxWidgetClass,level3C_B_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Colormap Mode");
    XtCreateManagedWidget("l3cbtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,3);
    XtSetArg(args[1],XtNlist,l3C_B_names);
    XtSetArg(args[2],XtNcallback,L3CB);
    level3C_B_bar=XtCreateManagedWidget("l3cbbar",listWidgetClass,tbox,args,3);

/* make a popup for the Redraw option */
    level3C_H_mgr = XtCreatePopupShell("l3chmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3chbox",boxWidgetClass,level3C_H_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Redraw");
    XtCreateManagedWidget("l3chtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,3);
    XtSetArg(args[1],XtNlist,l3C_H_names);
    XtSetArg(args[2],XtNcallback,L3CH);
    level3C_H_bar=XtCreateManagedWidget("l3chbar",listWidgetClass,tbox,args,3);

/* make a popup for Dimension */
    level3C_I_mgr = XtCreatePopupShell("l3cimgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cibox",boxWidgetClass,level3C_I_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Dimension");
    XtCreateManagedWidget("l3cititle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,5);
    XtSetArg(args[1],XtNlist,l3C_I_names);
    XtSetArg(args[2],XtNcallback,L3CI);
    level3C_I_bar=XtCreateManagedWidget("l3ibbar",listWidgetClass,tbox,args,3);

/* make a popup mgr for Eye Position  this is level 3 */
    
    level3C_D_mgr = XtCreatePopupShell("l3cdmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cdbox",boxWidgetClass,level3C_D_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Set Eye Position");
    XtCreateManagedWidget("l3cdtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        X         ");
    level3cddialog1=XtCreateManagedWidget("3ced1",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Y         ");
    level3cddialog2=XtCreateManagedWidget("3cdd2",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Z         ");
    level3cddialog3=XtCreateManagedWidget("3cdd3",dialogWidgetClass,
	     tbox,args,1);
    /* create a done button */
    XtSetArg(args[0],XtNlabel,"        DONE       ");
    XtSetArg(args[1],XtNcallback,L3CD);
    XtCreateManagedWidget("3cddone",commandWidgetClass,tbox,args,2);

/* make a popup mgr for Focus Position  this is level 3 */
    
    level3C_E_mgr = XtCreatePopupShell("l3cemgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cebox",boxWidgetClass,level3C_E_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Set Focus Position");
    XtCreateManagedWidget("l3cetitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        X         ");
    level3cedialog1=XtCreateManagedWidget("3ced1",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Y         ");
    level3cedialog2=XtCreateManagedWidget("3ced2",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Z         ");
    level3cedialog3=XtCreateManagedWidget("3ced3",dialogWidgetClass,
	     tbox,args,1);
    /* create a done button */
    XtSetArg(args[0],XtNlabel,"        DONE       ");
    XtSetArg(args[1],XtNcallback,L3CE);
    XtCreateManagedWidget("3cedone",commandWidgetClass,tbox,args,2);

/* make a popup mgr for Distance frome eye  this is level 3 */
    
    level3C_F_mgr = XtCreatePopupShell("l3cfmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cebox",boxWidgetClass,level3C_F_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Set Distance To Viewplane");
    XtCreateManagedWidget("l3cftitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"Enter the distance ");
    level3cfdialog1=XtCreateManagedWidget("3cfd1",dialogWidgetClass,
	     tbox,args,1);
    /* create a done button */
    XtSetArg(args[0],XtNlabel,"        DONE       ");
    XtSetArg(args[1],XtNcallback,L3CF);
    XtCreateManagedWidget("3cfdone",commandWidgetClass,tbox,args,2);

/* make a popup mgr for Focus Position  this is level 3 */
    
    level3C_G_mgr = XtCreatePopupShell("l3cgmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3cgbox",boxWidgetClass,level3C_G_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Set Focus Position");
    XtCreateManagedWidget("l3cgtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"    X Dimension       ");
    level3cgdialog1=XtCreateManagedWidget("3cgd1",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"    Y Dimension       "); 
    level3cgdialog2=XtCreateManagedWidget("3cgd2",dialogWidgetClass,
	     tbox,args,1);
    /* create a done button */
    XtSetArg(args[0],XtNlabel,"        DONE       ");
    XtSetArg(args[1],XtNcallback,L3CG);
    XtCreateManagedWidget("3cgdone",commandWidgetClass,tbox,args,2);

/* make a popup menu for the viewport sutff  this is level 3 */

    level3C_C_mgr = XtCreatePopupShell("l3ccmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3ccbox",boxWidgetClass,level3C_C_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Select Mode");
    XtCreateManagedWidget("l3cctitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,4);
    XtSetArg(args[1],XtNlist,l3C_C_names);
    XtSetArg(args[2],XtNcallback,L3C_C);
    XtSetArg(args[3],XtNdefaultColumns,2);
    level3C_C_bar=XtCreateManagedWidget("l3ccbar",listWidgetClass,tbox,args,4);

/* finally for the level 3C_C we need a dialog to get viewport cordinates */
     level3C_C_A_mgr=XtCreatePopupShell("l3ccamgr",overrideShellWidgetClass,
           box2,NULL,0);
    tbox=XtCreateManagedWidget("l3ccbox",boxWidgetClass,level3C_C_A_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"    Enter Values    ");
    XtCreateManagedWidget("l3ccatitle",labelWidgetClass,tbox,args,1);
    /* create a dialog widget for each field */
    XtSetArg(args[0],XtNlabel,"        X1         ");
    level3ccadialog1=XtCreateManagedWidget("3ccad1",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Y1         ");
    level3ccadialog2=XtCreateManagedWidget("3ccad2",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        X2         ");
    level3ccadialog3=XtCreateManagedWidget("3ccad3",dialogWidgetClass,
	     tbox,args,1);
    XtSetArg(args[0],XtNlabel,"        Y2         ");
    level3ccadialog4=XtCreateManagedWidget("3ccad4",dialogWidgetClass,
	     tbox,args,1);
    /* create a done button */
    XtSetArg(args[0],XtNlabel,"        DONE       ");
    XtSetArg(args[1],XtNcallback,L3CCA);
    XtCreateManagedWidget("3ccadone",commandWidgetClass,tbox,args,2);

/* make a level 2 object popup menu */

       set_mgr = XtCreatePopupShell("set_mgr",overrideShellWidgetClass,box2,
           NULL,0);
      tbox = XtCreateManagedWidget("set_box",boxWidgetClass,set_mgr,NULL,0);
      XtSetArg(args[0],XtNlabel,"Select Object");
      XtCreateManagedWidget("set_title",labelWidgetClass,tbox,args,1);
      XtSetArg(args[0],XtNnumberStrings,13);
      XtSetArg(args[1],XtNlist,object_names);
      XtSetArg(args[2],XtNcallback,Sit);
      Set_bar = XtCreateManagedWidget("Set_bar",listWidgetClass,tbox,args,3);
      
/* make the next popup for set objects  call this level 3A */
     
       level3A_mgr= XtCreatePopupShell("l3aamgr",overrideShellWidgetClass,box2,
           NULL,0);
      tbox=XtCreateManagedWidget("l3a_box",boxWidgetClass,level3A_mgr,NULL,0);
      XtSetArg(args[0],XtNlabel,"Select Attribute");
      XtCreateManagedWidget("l3a_title",labelWidgetClass,tbox,args,1);
      XtSetArg(args[0],XtNnumberStrings,6);
      XtSetArg(args[1],XtNlist,l3A_names);
      XtSetArg(args[2],XtNcallback,L3A);
     level3A_bar=XtCreateManagedWidget("l3aa_bar",listWidgetClass,tbox,args,3);

/* make a popup for line width */
   level3A_A_mgr= XtCreatePopupShell("l3aamgr",overrideShellWidgetClass,box2,
           NULL,0);
   tbox=XtCreateManagedWidget("l3aa_box",boxWidgetClass,level3A_A_mgr,NULL,0);
   XtSetArg(args[0],XtNlabel," Line Width");
   XtCreateManagedWidget("l3aa_title",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"Enter New Width");
    level3A_A_dialog=XtCreateManagedWidget("l3aadialog",dialogWidgetClass,
                     tbox,args,1);
      XtSetArg(args[0],XtNlabel,"Do");
    XtSetArg(args[1],XtNcallback,L3AA1);
    XtCreateManagedWidget("doit",commandWidgetClass,tbox,args,2);
    XtSetArg(args[0],XtNlabel,"Cancel");
    XtSetArg(args[1],XtNcallback,L3AA2);
    XtCreateManagedWidget("dontdoit",commandWidgetClass,tbox,args,2); 

/* make a popup for line style */
    level3A_B_mgr = XtCreatePopupShell("l3abmgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3abbox",boxWidgetClass,level3A_B_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Select Line Style");
    XtCreateManagedWidget("l3abtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,3);
    XtSetArg(args[1],XtNlist,l3A_B_names);
    XtSetArg(args[2],XtNcallback,L3AB);
    level3A_B_bar=XtCreateManagedWidget("l3abbar",listWidgetClass,tbox,args,3);


/* make a popup for transformation */

/* make a popup for visibility */
    level3A_D_mgr = XtCreatePopupShell("l3admgr",overrideShellWidgetClass,box2,
           NULL,0);
    tbox = XtCreateManagedWidget("l3adbox",boxWidgetClass,level3A_D_mgr,NULL,0);
    XtSetArg(args[0],XtNlabel,"Select Visiblilty");
    XtCreateManagedWidget("l3adtitle",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNnumberStrings,3);
    XtSetArg(args[1],XtNlist,l3A_D_names);
    XtSetArg(args[2],XtNcallback,L3AD);
    level3A_D_bar=XtCreateManagedWidget("l3adbar",listWidgetClass,tbox,args,3);


/* make a popup for color */
   level3A_E_mgr= XtCreatePopupShell("l3aemgr",overrideShellWidgetClass,box2,
           NULL,0);
   tbox=XtCreateManagedWidget("l3ae_box",boxWidgetClass,level3A_E_mgr,NULL,0);
   XtSetArg(args[0],XtNlabel," Line Width");
   XtCreateManagedWidget("l3ae_title",labelWidgetClass,tbox,args,1);
    XtSetArg(args[0],XtNlabel,"Enter New Color");
    level3A_E_dialog=XtCreateManagedWidget("l3aedialog",dialogWidgetClass,
                     tbox,args,1);
      XtSetArg(args[0],XtNlabel,"Do");
    XtSetArg(args[1],XtNcallback,L3AE1);
    XtCreateManagedWidget("doit",commandWidgetClass,tbox,args,2);
    XtSetArg(args[0],XtNlabel,"Cancel");
    XtSetArg(args[1],XtNcallback,L3AE2);
    XtCreateManagedWidget("dontdoit",commandWidgetClass,tbox,args,2); 

}
