#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Dialog.h>
#include <X11/Xlib.h>

#include <X11/Command.h>
#include <X11/Shell.h>

#include "XGPUtils.h"

extern Widget buisy_done;
extern Widget toplevel,
	      QUIT,SAVE,ERRORBOX,
 	      thegraph;

static Widget ErrorShell;
static Widget DialogHold;

void XYMenu(mgr,action)
   Widget mgr;

   {
     Arg       args[2];
     Position  x,y;

     XtSetArg(args[0],XtNx,&x);
     XtSetArg(args[1],XtNy,&y);

     switch (action) {
         case POPUP :
           XtGetValues(mgr,args,2);
           if (x == 0 && y == 0 ) {
             XtGetValues(toplevel,args,2);
             XtMoveWidget(mgr,x,y);
           }
           XtPopup(mgr,XtGrabExclusive);
           break;
         case POPDOWN :
           XtPopdown(mgr);
           XtSetArg(args[0],XtNx,0);
           XtSetArg(args[1],XtNy,0);
           XtSetValues(mgr,args,2);
           break;
         default :
           break;
     }
   }

XtEventHandler moveEvent(w,client_data,event)
   Widget       w;
   caddr_t      client_data;
   XEvent       *event;

   {
     Arg       args[10];
     if (event->type == ConfigureNotify) {
        XtSetArg(args[0],XtNx,(XtArgVal) event->xconfigure.x);
        XtSetArg(args[1],XtNy,(XtArgVal) event->xconfigure.y);
        XtSetValues(w,args,2);
     }
   }

XtCallbackProc XGPError(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
    {
	Arg   args[10];

	XtSetArg(args[0],XtNvalue,rdat);
	XtSetValues(ERRORBOX,args,1);
        XYMenu(ErrorShell,POPUP); 
    }

XtCallbackProc bw(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;

  {
     Arg   args[1];

      if ((int) rdat == XtWorking) {
         XtSetArg(args[0],XtNlabel,"Buisy");
      } else {
         XtSetArg(args[0],XtNlabel,"Idle ");
      }
      XtSetValues(buisy_done,args,1);
  }

static void quit1(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
 
  {
   XGPParseString(thegraph,"(Quit)\n");
  }

static void dismisscall(wid,cdat,rdat)
    Widget   wid;
    caddr_t  cdat,rdat;
 
  {
    XYMenu(ErrorShell,POPDOWN); 
  }


void MakeErrorStuff(box,len)
	Widget   box;
	int      len;
  {
       Arg   args[4];
       static XtCallbackRec dismiss[]= {{dismisscall,NULL},{NULL,NULL}};

       ErrorShell = XtCreatePopupShell("ES",overrideShellWidgetClass,box,
		    NULL,0);
       XtSetArg(args[0],XtNlabel,"XGP Error");
       XtSetArg(args[1],XtNvalue,"");
       ERRORBOX=XtCreateManagedWidget("x",dialogWidgetClass,ErrorShell,args,2);
       
       DialogHold = XtNameToWidget(ERRORBOX,"value");
       XtSetArg(args[1],XtNwidth,len);
       XtSetArg(args[0],XtNlength,300);
       XtSetValues(DialogHold,args,2);

       XtSetArg(args[0],XtNlabel,"Dismiss");
       XtSetArg(args[1],XtNcallback,dismiss);
       XtCreateManagedWidget("x",commandWidgetClass,ERRORBOX,args,2);

  }

void MakeBasicStuff(box,box2)
	Widget   box,box2;

  {
    Arg args[4];
    static XtCallbackRec try[]= {{quit1,NULL},{NULL,NULL}};

    XtSetArg(args[0],XtNlabel,"Idle ");
    XtSetArg(args[1],XtNfromHoriz,SAVE);
    buisy_done = XtCreateManagedWidget("status",labelWidgetClass,box,args,2);

    XtSetArg(args[0],XtNlabel,"Quit");
    XtSetArg(args[1],XtNcallback,try);
    XtSetArg(args[2],XtNfromHoriz,buisy_done);
    QUIT = XtCreateManagedWidget("quit",commandWidgetClass,box,args,3);

  }

